package it.finanze.dogane.accise.aautotrasportatori.model;

import it.finanze.dogane.accise.aautotrasportatori.config.Contatori;
import it.finanze.dogane.accise.model.AbstractRecord;
import it.finanze.dogane.accise.util.StringUtil;

import java.io.IOException;
import java.math.BigDecimal;
import java.math.BigInteger;

public  class AutotrasportatoriQuadroB extends AutotrasportatoriRecord {
	
// dichiarazioni variabili  
// I nomi iniziano tutti per superiore o inferiore   
   private BigInteger progressivoRecord =BigInteger.valueOf(0);                                                       
	private String superioreCodiceDitta="";                                                       
	private BigInteger superioreNumeroFatture=BigInteger.valueOf(0);                                          
	private BigInteger superioreTotaleLitri =BigInteger.valueOf(0);                                                        
	private BigDecimal superioreTotaleImporto=  BigDecimal.valueOf(0,0);                                                  
	private String superioreGasolioUtilizzatoRifornimAutovQuadroA ="";
	                           
	private String inferioreProvinciaUbicazioneImpianto="";    
	private String inferioreComuneUbicazioneImpianto="";                                         
	private String inferioreIndirizzoUbicazioneImpianto ="";                       
	private BigDecimal inferioreCapacitaStoccaggioSerbatoio=BigDecimal.valueOf(0);                                        
	private BigInteger inferioreNumeroFatture =BigInteger.valueOf(0);                                                        
	private BigInteger inferioreTotaleLitri =BigInteger.valueOf(0);                                                          
	private BigDecimal inferioreTotaleImporto =BigDecimal.valueOf(0,0);                                                  
	private String inferioreGasolioUtilizzatoRifornimAutovQuadroA =""; 
	private String gasolioUtilizzatoRifornimAutovQuadroA =""; 
	public static final int dimGasolioUtilizzatoRifornimAutovQuadroA =1;                                  

	private String tipoSerbatoio="";    
                                                                                     
//	dichiarazione dimenzione variabile                                                 
	public static final int dimSuperioreCodiceDitta=9;                                            
	public static final int dimSuperioreNumeroFatture=4;                               
	public static final int dimSuperioreTotaleLitri =	12;                                            
	public static final int dimSuperioreTotaleImportoInt=12;                                       
	public static final int dimSuperioreTotaleImportoDec=2;                                       
	public static final int dimSuperioreGasolioUtilizzatoRifornimAutovQuadroA =1;

	public static final int dimInferioreProvinciaUbicazioneImpianto=2;                           
	public static final int dimInferioreComuneUbicazioneImpianto=45;                            
	public static final int dimInferioreIndirizzoUbicazioneImpianto=45;                          
	public static final int dimInferioreCapacitaStoccaggioSerbatoio =4;                             
	public static final int dimInferioreNumeroFatture=4;                                           
	public static final int dimInferioreTotaleLitri=12;                                            
	public static final int dimInferioreTotaleImportoInt=12;                                        
	public static final int dimInferioreTotaleImportoDec=2;                                         
	public static final int dimInferioreGasolioUtilizzatoRifornimAutovQuadroA=1;    
	public static final int dimTipoSerbatoio=1;  
	private static final int dimProgressivoRecord =4;  
	
	public static final int dimCapStoccaggioInt=4;                                        
	public static final int dimCapStoccaggioDec=3;  
	
	


	public static AutotrasportatoriQuadroB getNewObject(ProspettoConsumo prospettoConsumo) {
		AutotrasportatoriQuadroB retvalue = new AutotrasportatoriQuadroB();
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		retvalue.setAnnoDic(frontespizio.getAnnoDic());
		retvalue.setPartitaIva(frontespizio.getPartitaIva());
		retvalue.setProgPartitaIva(frontespizio.getProgPartitaIva());
		return retvalue;
	}

	public void scriviOggetto(java.io.OutputStream out) throws IOException {		

		String testValue = StringUtil.nullify(inferioreIndirizzoUbicazioneImpianto);
		
		if ((!inferioreTotaleLitri.equals(BigInteger.ZERO) || !superioreTotaleLitri.equals(BigInteger.ZERO)) 
				&& AutotrasportatoriRecord.QUADRO_B_ZERO ) {
			AutotrasportatoriRecord.QUADRO_B_ZERO = false;			
		}	
		
		
		if (inferioreTotaleLitri.equals(BigInteger.ZERO) && superioreTotaleLitri.equals(BigInteger.ZERO)) {			
			return;
		}	
		
		super.scriviOggetto(out);		
		
		Contatori.PROGRESSIVO_FILE_QUADRO_B++;			
		progressivoRecord=new BigInteger(""+Contatori.PROGRESSIVO_FILE_QUADRO_B);
		out.write(normalizzaCampo(progressivoRecord, dimProgressivoRecord));
		
		if(testValue == null) {
			
			out.write(normalizzaCampo(superioreCodiceDitta, dimSuperioreCodiceDitta));                                                                
			out.write(normalizzaCampo(superioreNumeroFatture, dimSuperioreNumeroFatture));                                              
			out.write(normalizzaCampo(superioreTotaleLitri, dimSuperioreTotaleLitri));                                                                
			out.write(normalizzaCampo(superioreTotaleImporto, dimSuperioreTotaleImportoInt, dimSuperioreTotaleImportoDec));               
			out.write(normalizzaCampo("", dimInferioreProvinciaUbicazioneImpianto));                                
			out.write(normalizzaCampo("", dimInferioreComuneUbicazioneImpianto));                                           
			out.write(normalizzaCampo("", dimInferioreIndirizzoUbicazioneImpianto));                                
			out.write(normalizzaCampo(BigDecimal.valueOf(0), dimCapStoccaggioInt, dimCapStoccaggioDec));   
			                            
			out.write(normalizzaCampo(inferioreNumeroFatture, dimInferioreNumeroFatture));  //                                            
			out.write(normalizzaCampo(inferioreTotaleLitri, dimInferioreTotaleLitri));        //                                                        
			out.write(normalizzaCampo(BigInteger.valueOf(0), dimInferioreTotaleImportoInt+dimInferioreTotaleImportoDec)); //
								      		      
			out.write(normalizzaCampo(gasolioUtilizzatoRifornimAutovQuadroA, dimGasolioUtilizzatoRifornimAutovQuadroA));			
			out.write(normalizzaCampo(tipoSerbatoio, dimTipoSerbatoio));      
		} else {
			out.write(normalizzaCampo("", dimSuperioreCodiceDitta));                                                                
			out.write(normalizzaCampo(BigInteger.valueOf(0), dimSuperioreNumeroFatture));                                              
			out.write(normalizzaCampo(BigInteger.valueOf(0), dimSuperioreTotaleLitri));                                                                
			out.write(normalizzaCampo(BigInteger.valueOf(0), dimSuperioreTotaleImportoInt+dimSuperioreTotaleImportoDec));               
			
			out.write(normalizzaCampo(inferioreProvinciaUbicazioneImpianto, dimInferioreProvinciaUbicazioneImpianto));                                
			out.write(normalizzaCampo(inferioreComuneUbicazioneImpianto, dimInferioreComuneUbicazioneImpianto));                                           
			out.write(normalizzaCampo(inferioreIndirizzoUbicazioneImpianto, dimInferioreIndirizzoUbicazioneImpianto));                                
			
			               
			out.write(normalizzaCampo(inferioreCapacitaStoccaggioSerbatoio, dimCapStoccaggioInt, dimCapStoccaggioDec));
			   
			out.write(normalizzaCampo(inferioreNumeroFatture, dimInferioreNumeroFatture));                                              
			out.write(normalizzaCampo(inferioreTotaleLitri, dimInferioreTotaleLitri));                                                                
			out.write(normalizzaCampo(inferioreTotaleImporto, dimInferioreTotaleImportoInt, dimInferioreTotaleImportoDec));               
			
			out.write(normalizzaCampo(gasolioUtilizzatoRifornimAutovQuadroA, dimGasolioUtilizzatoRifornimAutovQuadroA));			
			out.write(normalizzaCampo(tipoSerbatoio, dimTipoSerbatoio));	      
		}

		scriviFineRiga(out);
	}

	public void leggiOggetto(java.io.InputStream in) throws IOException {

		super.leggiOggetto(in);
		
		progressivoRecord = readFieldBigInteger(in, dimProgressivoRecord); 
		superioreCodiceDitta = readFieldString(in, dimSuperioreCodiceDitta);                                                                           
		superioreNumeroFatture = readFieldBigInteger(in, dimSuperioreNumeroFatture);                                                         
		superioreTotaleLitri = readFieldBigInteger(in, dimSuperioreTotaleLitri);                                                                           
		superioreTotaleImporto = readFieldBigDecimal(in, dimSuperioreTotaleImportoInt, dimSuperioreTotaleImportoDec);                          
		//superioreGasolioUtilizzatoRifornimAutovQuadroA = readFieldString(in, dimSuperioreGasolioUtilizzatoRifornimAutovQuadroA);                       
		
		inferioreProvinciaUbicazioneImpianto = readFieldString(in, dimInferioreProvinciaUbicazioneImpianto);                                           
		inferioreComuneUbicazioneImpianto = readFieldString(in, dimInferioreComuneUbicazioneImpianto);                                                 
		inferioreIndirizzoUbicazioneImpianto = readFieldString(in, dimInferioreIndirizzoUbicazioneImpianto);                                           
		inferioreCapacitaStoccaggioSerbatoio = readFieldBigDecimal(in, dimCapStoccaggioInt, dimCapStoccaggioDec);                                          
		inferioreNumeroFatture = readFieldBigInteger(in, dimInferioreNumeroFatture);                                                         
		inferioreTotaleLitri = readFieldBigInteger(in, dimInferioreTotaleLitri);                                                                           
		inferioreTotaleImporto = readFieldBigDecimal(in, dimInferioreTotaleImportoInt, dimInferioreTotaleImportoDec);                          
		//inferioreGasolioUtilizzatoRifornimAutovQuadroA = readFieldString(in, dimInferioreGasolioUtilizzatoRifornimAutovQuadroA);                 
		
		gasolioUtilizzatoRifornimAutovQuadroA = readFieldString(in, dimGasolioUtilizzatoRifornimAutovQuadroA);                       
		tipoSerbatoio = readFieldString(in, dimTipoSerbatoio); 
	
		saltaFineRiga(in);
	}             

	public Object clone() throws CloneNotSupportedException {
		AutotrasportatoriQuadroB clonato = new AutotrasportatoriQuadroB();

		clonato.setSuperioreCodiceDitta(this.superioreCodiceDitta);
		clonato.setSuperioreNumeroFatture(this.superioreNumeroFatture);
		clonato.setSuperioreTotaleLitri(this.superioreTotaleLitri);
		clonato.setSuperioreTotaleImporto(this.superioreTotaleImporto);
		clonato.setGasolioUtilizzatoRifornimAutovQuadroA(this.gasolioUtilizzatoRifornimAutovQuadroA);
		clonato.setInferioreProvinciaUbicazioneImpianto(this.inferioreProvinciaUbicazioneImpianto);
		clonato.setInferioreComuneUbicazioneImpianto(this.inferioreComuneUbicazioneImpianto);
		clonato.setInferioreIndirizzoUbicazioneImpianto(this.inferioreIndirizzoUbicazioneImpianto);
		clonato.setInferioreCapacitaStoccaggioSerbatoio(this.inferioreCapacitaStoccaggioSerbatoio);
		clonato.setInferioreNumeroFatture(this.inferioreNumeroFatture);
		clonato.setInferioreTotaleLitri(this.inferioreTotaleLitri);
		clonato.setInferioreTotaleImporto(this.inferioreTotaleImporto);
		//clonato.setGasolioUtilizzatoRifornimAutovQuadroA(this.gasolioUtilizzatoRifornimAutovQuadroA);

		clonato.setPartitaIva(this.getPartitaIva());
		clonato.setProgPartitaIva(this.getProgPartitaIva());
		clonato.setAnnoDic(this.getAnnoDic());
		clonato.setTipoRecord(this.getTipoRecord());
		clonato.setTipoSerbatoio(this.getTipoSerbatoio());

		return clonato;
	}

	public boolean isSuperiore() {
		boolean retvalue = false;
		String testValue = StringUtil.nullify(getInferioreIndirizzoUbicazioneImpianto());
		
		if(testValue == null) {
			retvalue = true;
		}
		return retvalue;
	}
	
	public boolean isInferiore() {
		return !isSuperiore();
	}

	public void setSuperioreGasolioUtilizzatoRifornimAutovQuadroA(boolean bool) {
		if(bool) {
			setSuperioreGasolioUtilizzatoRifornimAutovQuadroA("S");
		} else {
			setSuperioreGasolioUtilizzatoRifornimAutovQuadroA("N");
		}
	}

	public void setInferioreGasolioUtilizzatoRifornimAutovQuadroA(boolean bool) {
		if(bool) {
			setInferioreGasolioUtilizzatoRifornimAutovQuadroA("S");
		} else {
			setInferioreGasolioUtilizzatoRifornimAutovQuadroA("N");
		}
	}

	public boolean isSuperioreGasolioUtilizzatoRifornimAutovQuadroA() {
		boolean retvalue = true;
		if(StringUtil.nullify(superioreGasolioUtilizzatoRifornimAutovQuadroA) == null ||
			superioreGasolioUtilizzatoRifornimAutovQuadroA.equals("N")) {
			retvalue = false;
		}
		return retvalue;
	}

	public boolean isInferioreGasolioUtilizzatoRifornimAutovQuadroA() {
		boolean retvalue = true;
		if(StringUtil.nullify(inferioreGasolioUtilizzatoRifornimAutovQuadroA) == null ||
			inferioreGasolioUtilizzatoRifornimAutovQuadroA.equals("N")) {
			retvalue = false;
		}
		return retvalue;
	}

	/**
	 * @return
	 */
	public BigDecimal getInferioreCapacitaStoccaggioSerbatoio() {
		return inferioreCapacitaStoccaggioSerbatoio;
	}

	/**
	 * @return
	 */
	public String getInferioreComuneUbicazioneImpianto() {
		return inferioreComuneUbicazioneImpianto;
	}

	/**
	 * @return
	 */
	public String getInferioreGasolioUtilizzatoRifornimAutovQuadroA() {
		return inferioreGasolioUtilizzatoRifornimAutovQuadroA;
	}

	/**
	 * @return
	 */
	public String getInferioreIndirizzoUbicazioneImpianto() {
		return inferioreIndirizzoUbicazioneImpianto;
	}

	/**
	 * @return
	 */
	public BigInteger getInferioreNumeroFatture() {
		return inferioreNumeroFatture;
	}

	/**
	 * @return
	 */
	public String getInferioreProvinciaUbicazioneImpianto() {
		return inferioreProvinciaUbicazioneImpianto;
	}

	/**
	 * @return
	 */
	public BigDecimal getInferioreTotaleImporto() {
		return inferioreTotaleImporto;
	}

	/**
	 * @return
	 */
	public BigInteger getInferioreTotaleLitri() {
		return inferioreTotaleLitri;
	}

	/**
	 * @return
	 */
	public String getSuperioreCodiceDitta() {
		return superioreCodiceDitta;
	}

	/**
	 * @return
	 */
	public String getSuperioreGasolioUtilizzatoRifornimAutovQuadroA() {
		return superioreGasolioUtilizzatoRifornimAutovQuadroA;
	}

	/**
	 * @return
	 */
	public BigInteger getSuperioreNumeroFatture() {
		return superioreNumeroFatture;
	}

	/**
	 * @return
	 */
	public BigDecimal getSuperioreTotaleImporto() {
		return superioreTotaleImporto;
	}

	/**
	 * @return
	 */
	public BigInteger getSuperioreTotaleLitri() {
		return superioreTotaleLitri;
	}

	/**
	 * @param integer
	 */
	public void setInferioreCapacitaStoccaggioSerbatoio(BigDecimal integer) {
		inferioreCapacitaStoccaggioSerbatoio = integer;
	}

	/**
	 * @param string
	 */
	public void setInferioreComuneUbicazioneImpianto(String string) {
		inferioreComuneUbicazioneImpianto = string;
	}

	/**
	 * @param string
	 */
	public void setInferioreGasolioUtilizzatoRifornimAutovQuadroA(String string) {
		inferioreGasolioUtilizzatoRifornimAutovQuadroA = string;
	}

	/**
	 * @param string
	 */
	public void setInferioreIndirizzoUbicazioneImpianto(String string) {
		inferioreIndirizzoUbicazioneImpianto = string;
	}

	/**
	 * @param integer
	 */
	public void setInferioreNumeroFatture(BigInteger integer) {
		inferioreNumeroFatture = integer;
	}

	/**
	 * @param string
	 */
	public void setInferioreProvinciaUbicazioneImpianto(String string) {
		inferioreProvinciaUbicazioneImpianto = string;
	}

	/**
	 * @param decimal
	 */
	public void setInferioreTotaleImporto(BigDecimal decimal) {
		inferioreTotaleImporto = decimal;
	}

	/**
	 * @param integer
	 */
	public void setInferioreTotaleLitri(BigInteger integer) {
		inferioreTotaleLitri = integer;
	}

	/**
	 * @param string
	 */
	public void setSuperioreCodiceDitta(String string) {
		superioreCodiceDitta = string;
	}

	/**
	 * @param string
	 */
	public void setSuperioreGasolioUtilizzatoRifornimAutovQuadroA(String string) {
		superioreGasolioUtilizzatoRifornimAutovQuadroA = string;
	}

	/**
	 * @param integer
	 */
	public void setSuperioreNumeroFatture(BigInteger integer) {
		superioreNumeroFatture = integer;
	}

	/**
	 * @param decimal
	 */
	public void setSuperioreTotaleImporto(BigDecimal decimal) {
		superioreTotaleImporto = decimal;
	}

	/**
	 * @param integer
	 */
	public void setSuperioreTotaleLitri(BigInteger integer) {
		superioreTotaleLitri = integer;
	}

	/**
	 * @param string
	 */
	public void setTipoSerbatoio(String string) {
		tipoSerbatoio = string;
	}

	/**
	 * @return
	 */
	public String getTipoSerbatoio() {
		return tipoSerbatoio;
	}

	/**
	 * @return
	 */
	public String getGasolioUtilizzatoRifornimAutovQuadroA() {
		return gasolioUtilizzatoRifornimAutovQuadroA;
	}

	/**
	 * @param string
	 */
	public void setGasolioUtilizzatoRifornimAutovQuadroA(String string) {
		gasolioUtilizzatoRifornimAutovQuadroA = string;
	}
	
	public void setGasolioUtilizzatoRifornimAutovQuadroA(boolean bool) {
		if (bool) {
			setGasolioUtilizzatoRifornimAutovQuadroA("S");
		} else {
			setGasolioUtilizzatoRifornimAutovQuadroA("N");
		}
	}
	
	public boolean isGasolioUtilizzatoRifornimAutovQuadroA() {
			boolean retvalue = true;
			if( StringUtil.nullify(gasolioUtilizzatoRifornimAutovQuadroA) == null ||
					gasolioUtilizzatoRifornimAutovQuadroA.equals("N")) {
				retvalue = false;
			}
			
			return retvalue;
		}

	//	metodo di utilit per la stampa 
	  public Object[] getQuadroToArray(){		
		
		  if(tipoSerbatoio.equalsIgnoreCase("A"))
		 	 return new Object[]{superioreCodiceDitta,superioreNumeroFatture,superioreTotaleLitri,superioreTotaleImporto};
		 else if(tipoSerbatoio.equalsIgnoreCase("B"))
			return new Object[]{inferioreProvinciaUbicazioneImpianto,inferioreComuneUbicazioneImpianto,inferioreIndirizzoUbicazioneImpianto,inferioreCapacitaStoccaggioSerbatoio,
				inferioreNumeroFatture,inferioreTotaleLitri,inferioreTotaleImporto};
			 
		  return null;
	  }
}
