package it.finanze.dogane.accise.aautotrasportatori.ui;

import it.finanze.dogane.accise.aautotrasportatori.model.AutotrasportatoriQuadroA;
import it.finanze.dogane.accise.aautotrasportatori.model.Frontespizio;
import it.finanze.dogane.accise.aautotrasportatori.model.ProspettoConsumo;
import it.finanze.dogane.accise.aautotrasportatori.ui.quadri.Quadro;
import it.finanze.dogane.accise.aautotrasportatori.ui.tablemodel.AutotrasportatoriQuadroATM;
import it.finanze.dogane.accise.combo.AbstractTipo;
import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.ComboUtil;
import it.finanze.dogane.accise.combo.TipoPeriodo;
import it.finanze.dogane.accise.combo.TipoPossesso;
import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.pdf.PdfBuilder;
import it.finanze.dogane.accise.pdf.PdfPrintable;
import it.finanze.dogane.accise.ui.FullScreenLayoutManager;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.TableUtil;
import it.finanze.dogane.accise.ui.quadri.GestoreQuadro;
import it.finanze.dogane.accise.ui.quadri.dialog.QuadroDialog;
import it.finanze.dogane.accise.ui.validation.BigDecimalDocument;
import it.finanze.dogane.accise.ui.validation.BigIntegerDocument;
import it.finanze.dogane.accise.ui.validation.StringDocument;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class AutotrasportatoriQuadroA1Dialog
	extends AutotrasportatoriQuadroADialog
	implements
		ActionListener,
		ListSelectionListener,
		QuadroDialog,
		PdfPrintable,
		FocusListener {

	

	/**
	 * This is the default constructor
	 */
	public AutotrasportatoriQuadroA1Dialog(
											Frame frame,
											String description,
											String secondDescription) {
			
		super(frame, "Quadro A-1" , description, secondDescription);

		
	}

	public void plot(PdfBuilder builder) {
		
		super.plot( builder, titolo ); 
				
	}

	protected String getDataInizioPeriodo(){
		
		/*
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		BigInteger periodo = frontespizio.getPeriodoCarbontax();
		TipoPeriodo tipoPeriodo = ComboDataSource.getInstance().getPeriodo(frontespizio.getAnnoDic(), periodo);
		//ggmm
		BigInteger minInt = tipoPeriodo.getDataInizio();
		String minStr = minInt.toString();
		if (minStr.length()==3) minStr="0"+minStr;
		return minStr;
		*/
		return "0101";
	}

	protected String getDataFinePeriodo(){
		
		/*
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		BigInteger periodo = frontespizio.getPeriodoCarbontax();
		TipoPeriodo tipoPeriodo = ComboDataSource.getInstance().getPeriodo(frontespizio.getAnnoDic(), periodo);
		//ggmm
		BigInteger maxInt = tipoPeriodo.getDataFine();
		String maxStr = maxInt.toString();
		if (maxStr.length()==3) maxStr="0"+maxStr;
		return maxStr;
		*/		
		//return "3112"; // FHF
		
		//modifica 07/08/2008 data fine periodo di riferimento corrispondente con il 31/05 
		return "3105";
		
		//return "0210";
	}

	/**
	 * @param record
	 */
	protected void loadRecordFromUI(AutotrasportatoriQuadroA record) {

		record.setTipoQuadroA(Quadro.TIPO_QUADRO_A1);
		super.loadRecordFromUI( record );
		
	}
	

	protected String calcolaImporto() {
		
		BigDecimal importo=new BigDecimal(jTextFieldLitrCons.getText()).multiply(AutotrasportatoriQuadroA.ALIQUOTA_QUADRO_A1);
		importo=importo.setScale(AutotrasportatoriQuadroA.getDimImportoDec(),BigDecimal.ROUND_HALF_UP);
		return importo.toString();
		
	}
	
	protected void valorizzaDatiContabiliDelFrontespizio( BigInteger totaleLitri, BigDecimal totaleCredito ) {
		
		autotrasportatoriFrame.getJTextFieldLitriConsumatiA1().setText(totaleLitri.toString());
		autotrasportatoriFrame.getJTextFieldACreditoA1().setText(totaleCredito.toString());

	}


	/**************************************************************************************
	 * FINE GESTIONE EVENTI
	 **************************************************************************************/


	
	
} //  @jve:visual-info  decl-index=0 visual-constraint="10,10"