package it.finanze.dogane.accise.aautotrasportatori.ui;

import it.finanze.dogane.accise.aautotrasportatori.model.AutotrasportatoriQuadroA;
import it.finanze.dogane.accise.aautotrasportatori.model.Frontespizio;
import it.finanze.dogane.accise.aautotrasportatori.model.ProspettoConsumo;
import it.finanze.dogane.accise.aautotrasportatori.ui.quadri.Quadro;
import it.finanze.dogane.accise.aautotrasportatori.ui.tablemodel.AutotrasportatoriQuadroATM;
import it.finanze.dogane.accise.combo.AbstractTipo;
import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.ComboUtil;
import it.finanze.dogane.accise.combo.TipoPeriodo;
import it.finanze.dogane.accise.combo.TipoPossesso;
import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.pdf.PdfBuilder;
import it.finanze.dogane.accise.pdf.PdfPrintable;
import it.finanze.dogane.accise.ui.FullScreenLayoutManager;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.TableUtil;
import it.finanze.dogane.accise.ui.quadri.GestoreQuadro;
import it.finanze.dogane.accise.ui.quadri.dialog.QuadroDialog;
import it.finanze.dogane.accise.ui.validation.BigDecimalDocument;
import it.finanze.dogane.accise.ui.validation.BigIntegerDocument;
import it.finanze.dogane.accise.ui.validation.StringDocument;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class AutotrasportatoriQuadroSubADialog
	extends AutotrasportatoriQuadroADialog
	implements
		ActionListener,
		ListSelectionListener,
		QuadroDialog,
		PdfPrintable,
		FocusListener {

	private String dataInizioPossesso;
	private String dataFinePossesso;
	private double aliquota;
	

	/**
	 * This is the default constructor
	 */
	public AutotrasportatoriQuadroSubADialog(
											Frame frame,
											String title,
											String description,
											String secondDescription) {
			
		super(frame, title , description, secondDescription);

		
	}

	public void plot(PdfBuilder builder) {
		
		super.plot( builder, titolo ); 
				
	}

	protected String getDataInizioPeriodo(){
		
	
		return getDataInizioPossesso();
	}

	protected String getDataFinePeriodo(){
		
	
		return getDataFinePossesso();		
		
	}

	/**
	 * @param record
	 */
	protected void loadRecordFromUI(AutotrasportatoriQuadroA record) {

		//record.setTipoQuadroA(Quadro.TIPO_QUADRO_A);
		super.loadRecordFromUI( record );
		
	}
	

	
	
	protected void valorizzaDatiContabiliDelFrontespizio( BigInteger totaleLitri, BigDecimal totaleCredito ) {
		
		JTextField[] litriText = autotrasportatoriFrame.getArrayLitriConsumati();
		JTextField[] importiText = autotrasportatoriFrame.getArrayImportoACredito();
		
		litriText[getQuadroSelezionato()].setText(totaleLitri.toString());
		importiText[getQuadroSelezionato()].setText(totaleCredito.toString());

	}

	protected String calcolaImporto() {
	
		BigDecimal importo= null;
		try{
			importo=new BigDecimal(jTextFieldLitrCons.getText()).multiply(new BigDecimal(getAliquota()));
		}catch (NumberFormatException e) {importo=new BigDecimal("0");}
		
		importo=importo.setScale(AutotrasportatoriQuadroA.getDimImportoDec(),BigDecimal.ROUND_HALF_UP);
		return importo.toString();
		
	}


	/**************************************************************************************
	 * FINE GESTIONE EVENTI
	 **************************************************************************************/


	
	
	/**
	 * @return
	 */
	private String getDataFinePossesso() {
		return dataFinePossesso;
	}

	/**
	 * @return
	 */
	private String getDataInizioPossesso() {
		return dataInizioPossesso;
	}

	/**
	 * @param string
	 */
	public void setDataFinePossesso(String string) {
		dataFinePossesso = string;
	}

	/**
	 * @param string
	 */
	public void setDataInizioPossesso(String string) {
		dataInizioPossesso = string;
	}

	/**
	 * @return
	 */
	private double getAliquota() {
		return aliquota;
	}

	/**
	 * @param d
	 */
	public void setAliquota(double d) {
		aliquota = d;
	}

	

} //  @jve:visual-info  decl-index=0 visual-constraint="10,10"