package it.finanze.dogane.accise.aautotrasportatori.ui.tablemodel;

import it.finanze.dogane.accise.aautotrasportatori.model.AutotrasportatoriQuadroA;
import it.finanze.dogane.accise.pdf.PrintableTableModel;
import it.finanze.dogane.accise.util.StringUtil;

import java.math.BigInteger;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

public class AutotrasportatoriQuadroATM extends AbstractTableModel implements PrintableTableModel {

	private List listaRecord = null;

	public AutotrasportatoriQuadroATM(List lista) {
		listaRecord = lista;
		
				
	}

	public int getColumnCount() {
		return 9;
	}

	public int getRowCount() {
		return listaRecord.size();
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		AutotrasportatoriQuadroA record = (AutotrasportatoriQuadroA)listaRecord.get(rowIndex);
		
		Object retvalue = null;
		if(columnIndex == 0) {
			retvalue = record.getTarga();
		} else if(columnIndex == 1) {
			retvalue = record.getTitoloPossesso();
		} else if(columnIndex == 2) {
			//retvalue = record.getDataInizioPossesso();
			retvalue = formatDate(record.getDataInizioPossesso().toString());
		} else if(columnIndex == 3) {
			//retvalue = record.getDataFinePossesso();
			retvalue = formatDate(record.getDataFinePossesso().toString());
		} else if(columnIndex == 4) {
			retvalue = record.getNumeroFatture();
		} else if(columnIndex == 5) {
			retvalue = record.getNumeroSchede();
		} else if(columnIndex == 6) {
			retvalue = record.getLitriConsumati();
		} else if(columnIndex == 7) {
			retvalue = record.getChilometriPercorsi();
		} else if(columnIndex == 8) {
			retvalue = record.getImporto();
		}
		
		return retvalue;
	}

		
	private String formatDate(String dataStr) {
		dataStr = StringUtil.nullify(dataStr);
		if (dataStr.length() == 3)
			dataStr = "0" + dataStr;
		StringBuffer buffer = new StringBuffer(dataStr);
		buffer.insert(2, "/");
		return buffer.toString();
	}

	public String getColumnName(int columnIndex) {
		String retvalue = null;
		if(columnIndex == 0) {
			retvalue = "Targa";
		} else if(columnIndex == 1) {
			retvalue = "Titolo possesso";
		} else if(columnIndex == 2) {
			retvalue = "Data inizio pos.";
		} else if(columnIndex == 3) {
			retvalue = "Data fine pos.";
		} else if(columnIndex == 4) {
			retvalue = "N. fatture";
		} else if(columnIndex == 5) {
			retvalue = "N. schede";
		} else if(columnIndex == 6) {
			retvalue = "Litri consumati";
		} else if(columnIndex == 7) {
			retvalue = "Km percorsi";
		} else if(columnIndex == 8) {
			retvalue = "Importo";
		}
		
		return retvalue;
	}

	public AutotrasportatoriQuadroA getRecord(int selectedRow) {
		return (AutotrasportatoriQuadroA) listaRecord.get(selectedRow);
	}

	public List getRecords() {
		return listaRecord;
	}

	public void insertRecord(AutotrasportatoriQuadroA record) {
		listaRecord.add(record);
		
		this.fireTableRowsInserted(getRowCount() -1 , getRowCount() - 1);
	}

	public void removeRecord(int selectedRow) {
		listaRecord.remove(selectedRow);
		
		this.fireTableRowsDeleted(selectedRow, selectedRow);
	}
	

	public void setRecord(int selectedRow, AutotrasportatoriQuadroA record) {
		listaRecord.set(selectedRow, record);

		this.fireTableRowsUpdated(selectedRow, selectedRow);
	}

	public PrintableTableModel split(int index, int offset) {
		List newListaRecord = new LinkedList();
		
		Iterator it = listaRecord.iterator();
		int i = 0;
		while(it.hasNext()) {
			Object obj = it.next();
			if(i>=index && i<=index+offset-1) {
				newListaRecord.add(obj);
			}
			i++;
		}
		
		return new AutotrasportatoriQuadroATM(newListaRecord);
	}

	public PrintableTableModel split(int index) {
		return split(index, listaRecord.size() - index);
	}

}
