package it.finanze.dogane.accise.aautotrasportatori.ui.tablemodel;

import it.finanze.dogane.accise.aautotrasportatori.model.AutotrasportatoriQuadroC;
import it.finanze.dogane.accise.pdf.PrintableTableModel;
import it.finanze.dogane.accise.util.StringUtil;

import java.math.BigInteger;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

public class AutotrasportatoriQuadroCTM extends AbstractTableModel implements PrintableTableModel {

	private List listaRecord = null;

	public AutotrasportatoriQuadroCTM(List lista) {
		listaRecord = lista;
	}

	public int getColumnCount() {
		return 4;
	}

	public int getRowCount() {
		return listaRecord.size();
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		AutotrasportatoriQuadroC record = (AutotrasportatoriQuadroC)listaRecord.get(rowIndex);
		
		Object retvalue = null;
		if(columnIndex == 0) {
			retvalue = record.getTarga();
		} else if(columnIndex == 1) {
			retvalue = record.getTipoAutoveicolo();
		} else if(columnIndex == 2) {
			retvalue = formatDate(record.getDataInizioPossesso().toString());
		} else if(columnIndex == 3) {
			retvalue = formatDate(record.getDataFinePossesso().toString());
		}
		
		return retvalue;
	}

	private String formatDate(String dataStr) {
		dataStr = StringUtil.nullify(dataStr);
		if (dataStr.length() == 3)
			dataStr = "0" + dataStr;
		StringBuffer buffer = new StringBuffer(dataStr);
		buffer.insert(2, "/");
		return buffer.toString();
	}

	public String getColumnName(int columnIndex) {
		String retvalue = null;
		if(columnIndex == 0) {
			retvalue = "Targa";
		} else if(columnIndex == 1) {
			retvalue = "Tipo veicolo";
		} else if(columnIndex == 2) {
			retvalue = "Data inizio pos.";
		} else if(columnIndex == 3) {
			retvalue = "Data fine pos.";
		}
		
		return retvalue;
	}

	public AutotrasportatoriQuadroC getRecord(int selectedRow) {
		return (AutotrasportatoriQuadroC) listaRecord.get(selectedRow);
	}

	public List getRecords() {
		return listaRecord;
	}

	public void insertRecord(AutotrasportatoriQuadroC record) {
		listaRecord.add(record);
		
		this.fireTableRowsInserted(getRowCount() -1 , getRowCount() - 1);
	}

	public void removeRecord(int selectedRow) {
		listaRecord.remove(selectedRow);
		
		this.fireTableRowsDeleted(selectedRow, selectedRow);
	}
	

	public void setRecord(int selectedRow, AutotrasportatoriQuadroC record) {
		listaRecord.set(selectedRow, record);

		this.fireTableRowsUpdated(selectedRow, selectedRow);
	}

	public PrintableTableModel split(int index, int offset) {
		List newListaRecord = new LinkedList();
		
		Iterator it = listaRecord.iterator();
		int i = 0;
		while(it.hasNext()) {
			Object obj = it.next();
			if(i>=index && i<=index+offset-1) {
				newListaRecord.add(obj);
			}
			i++;
		}
		
		return new AutotrasportatoriQuadroCTM(newListaRecord);
	}

	public PrintableTableModel split(int index) {
		return split(index, listaRecord.size() - index);
	}

}
