/*
 * Creato il 31-gen-08
 *
 * Per modificare il modello associato a questo file generato, aprire
 * Finestra&gt;Preferenze&gt;Java&gt;Generazione codice&gt;Codice e commenti
 */
package it.finanze.dogane.accise.commonsfacade;

import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.TipoPeriodo;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.net.URL;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

/**
 * @author nsidev59
 *
 * Per modificare il modello associato al commento di questo tipo generato, aprire
 * Finestra&gt;Preferenze&gt;Java&gt;Generazione codice&gt;Codice e commenti
 */
public class TipoPeriodoFacade {
	private HashMap periodi = new HashMap();
	
	public static TipoPeriodo getPeriodo(BigInteger anno, Object codice, boolean bypass){
		TipoPeriodo tipPer=new TipoPeriodo();
		tipPer.setCodice(codice.toString());
		tipPer.setDescrizione(codice.toString());
		tipPer.setDescrizioneEstesa(codice.toString());
		return tipPer;		
	}
	
	
	
	public TipoPeriodo getPeriodo(BigInteger anno, BigInteger codice) {
		Iterator it = getPeriodi(anno).iterator();
		while (it.hasNext()) {
			TipoPeriodo tipoPeriodo = (TipoPeriodo) it.next();
			String itemCodice = tipoPeriodo.getCodice();
			String strCodice = String.valueOf(codice);
			if(strCodice.length() == 1) {
				itemCodice = tipoPeriodo.getCodicePeriodo();
			}
			if (itemCodice.equals(strCodice)) {
				return tipoPeriodo;
			}
		}
		return null;
	}
	
	public List getPeriodi(BigInteger anno) {
		List retvalue = (List)periodi.get(anno);
		if (retvalue == null) {
			retvalue = initPeriodi(anno);
		}
		return retvalue;
	}
	
	private List initPeriodi(BigInteger anno) {

		List retvalue = null;
		URL url =
			getClass().getClassLoader().getResource(
				"it/finanze/dogane/accise/combo/values/periodi/" + anno + ".txt");

		if (url == null) {
			throw new RuntimeException("File dei periodi non trovato per anno: " + anno);
		}

		InputStream is;
		try {
			is = url.openStream();

			BufferedReader reader =
				new BufferedReader(new InputStreamReader(is));

			String periodo = reader.readLine();
			retvalue = new LinkedList();
			while (periodo != null) {
				TipoPeriodo tipoPeriodo = new TipoPeriodo();
				tipoPeriodo.setDescrizioneEstesa(periodo);

				retvalue.add(tipoPeriodo);

				periodo = reader.readLine();
			}

			reader.close();
			is.close();
		} catch (IOException e) {
			e.printStackTrace();
			throw new RuntimeException(e.getMessage());
		}

		periodi.put(anno, retvalue);

		return retvalue;
	}


}
