package it.finanze.dogane.accise.model;
/*
 * Created on 5-ott-06
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
import java.io.File;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Calendar;
import java.util.Locale;

/**
 * @author Fiorello
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Interchange extends AbstractRecord  {
	//tracciato record interchange
	public final static int DIM_CODICE_UTENTE_ABILITATO=4;
	public final static int DIM_CAMPO_RISERVATO_1=12;
	public final static int DIM_NOME_FLUSSO=12;
	public final static int DIM_CAMPO_RISERVATO_2=12;
	public final static int DIM_CODICE_SEZIONE_DOGANALE=6;
	public final static int DIM_CAMPO_RISERVATO_3=4;
	public final static int DIM_CODICE_FISCALE_PARTITA_IVA=16;
	public final static int DIM_PROGRESSIVO_SEDE=3;
	public final static int DIM_CAMPO_RISERVATO_4=1;
	public final static int DIM_NUMERO_RECORD_PRESENTI_NEL_FLUSSO=5;
	
	//altri valori necessari per i controlli sulla gui
	public final static int DIM_GIORNO_INOLTRO=2;
	public final static int DIM_MESE_INOLTRO=2;
	public final static int DIM_PROGRESSIVO_INTERCHANGE=2;

	// variabili necessarie per il tracciato record del file da creare
	private String codiceUtenteAbilitato=null;
	private String campoRiservato1=null;
	private String nomeFlusso=null;
	private String campoRiservato2=null;
	private String codiceSezioneDoganale=null;
	private String campoRiservato3=null;
	private String codiceFiscalePartitaIva=null;
	private BigInteger progressivoSede=null;
	private String campoRiservato4=null;
	private BigInteger numeroRecordPresentiNelFlusso=null;

	// altre variabili utili per i controlli nella GUI
	private BigInteger giornoInoltro=null;
	private BigInteger meseInoltro=null;
	private String progressivoInterchange=null;
	private String fileNameInterchange=null;
	private Calendar data=null;

	public Interchange (){
		codiceSezioneDoganale="ITU000";
		data=Calendar.getInstance(Locale.ITALIAN);
		// setto mese e giorno alla data odierna (di sistema) e aggiorno il model
		this.setGiornoMese(data);
		codiceUtenteAbilitato="";
		progressivoSede=BigInteger.valueOf(0);
		codiceFiscalePartitaIva="";
		progressivoInterchange="";
		nomeFlusso="";
		fileNameInterchange="";
	}

	public void scriviOggetto(java.io.OutputStream out) throws IOException {
		super.scriviOggetto(out);
		out.write(normalizzaCampo(codiceUtenteAbilitato, DIM_CODICE_UTENTE_ABILITATO));
		out.write(normalizzaCampo(campoRiservato1, DIM_CAMPO_RISERVATO_1));
		out.write(normalizzaCampo(nomeFlusso, DIM_NOME_FLUSSO));
		out.write(normalizzaCampo(campoRiservato2, DIM_CAMPO_RISERVATO_2));
		out.write(normalizzaCampo(codiceSezioneDoganale, DIM_CODICE_SEZIONE_DOGANALE));
		out.write(normalizzaCampo(campoRiservato3, DIM_CAMPO_RISERVATO_3));
		out.write(normalizzaCampo(codiceFiscalePartitaIva, DIM_CODICE_FISCALE_PARTITA_IVA));
		out.write(normalizzaCampo(progressivoSede, DIM_PROGRESSIVO_SEDE));
		out.write(normalizzaCampo(campoRiservato4, DIM_CAMPO_RISERVATO_4));
		out.write(normalizzaCampo(numeroRecordPresentiNelFlusso, DIM_NUMERO_RECORD_PRESENTI_NEL_FLUSSO));
		
		scriviFineRiga(out);
	}
	
	public void leggiOggetto(java.io.InputStream in) throws IOException {
		super.leggiOggetto(in);
		codiceUtenteAbilitato = readFieldString(in, DIM_CODICE_UTENTE_ABILITATO); 
		campoRiservato1 = readFieldString(in, DIM_CAMPO_RISERVATO_1); 
		nomeFlusso = readFieldString(in, DIM_NOME_FLUSSO); 
		campoRiservato2 = readFieldString(in, DIM_CAMPO_RISERVATO_2); 
		codiceSezioneDoganale = readFieldString(in, DIM_CODICE_SEZIONE_DOGANALE); 
		campoRiservato3 = readFieldString(in, DIM_CAMPO_RISERVATO_3); 
		codiceFiscalePartitaIva = readFieldString(in, DIM_CODICE_FISCALE_PARTITA_IVA); 
		progressivoSede = readFieldBigInteger(in, DIM_PROGRESSIVO_SEDE); 
		campoRiservato4 = readFieldString(in, DIM_CAMPO_RISERVATO_4); 
		numeroRecordPresentiNelFlusso = readFieldBigInteger(in, DIM_NUMERO_RECORD_PRESENTI_NEL_FLUSSO); 
		saltaFineRiga(in);
	}

	public Object clone() throws CloneNotSupportedException {
		Interchange clonato = new Interchange();
		clonato.setCodiceUtenteAbilitato(this.getCodiceUtenteAbilitato());
		clonato.setCampoRiservato1(this.getCampoRiservato1());
		clonato.setNomeFlusso(this.getNomeFlusso());
		clonato.setCampoRiservato2(this.getCampoRiservato2());
		clonato.setCodiceSezioneDoganale(this.getCodiceSezioneDoganale());
		clonato.setCampoRiservato3(this.getCampoRiservato3());
		clonato.setCodiceFiscalePartitaIva(this.getCodiceFiscalePartitaIva());
		clonato.setProgressivoSede(this.getProgressivoSede());
		clonato.setCampoRiservato4(this.getCampoRiservato4());
		clonato.setNumeroRecordPresentiNelFlusso(this.getNumeroRecordPresentiNelFlusso());
		// clonato.setTipoRecord(this.getTipoRecord());
		return clonato;
	}

	/**
	 * @param data
	 */
	private void setGiornoMese(Calendar date) {
		setMeseInoltro(new BigInteger(String.valueOf(date.get(Calendar.MONTH)+1)));
		setGiornoInoltro(new BigInteger(String.valueOf(date.get(Calendar.DAY_OF_MONTH))));
	}


	/**
	 * @return
	 */
	public String getCodiceFiscalePartitaIva() {
		return codiceFiscalePartitaIva;
	}

	/**
	 * @return
	 */
	public String getCodiceUtenteAbilitato() {
		return codiceUtenteAbilitato;
	}

	/**
	 * @return
	 */
	public String getFileNameInterchange() {
		return fileNameInterchange;
	}

	/**
	 * @return
	 */
	public BigInteger getGiornoInoltro() {
		return giornoInoltro;
	}

	/**
	 * @return
	 */
	public BigInteger getMeseInoltro() {
		return meseInoltro;
	}

	/**
	 * @return
	 */
	public String getNomeFlusso() {
		return nomeFlusso;
	}

	/**
	 * @return
	 */
	public String getProgressivoInterchange() {
		return progressivoInterchange;
	}

	/**
	 * @return
	 */
	public BigInteger getProgressivoSede() {
		return progressivoSede;
	}

	/**
	 * @param string
	 */
	public void setCodiceFiscalePartitaIva(String string) {
		codiceFiscalePartitaIva = string;
	}

	/**
	 * @param string
	 */
	public void setCodiceUtenteAbilitato(String string) {
		codiceUtenteAbilitato = string;
	}

	/**
	 * @param string
	 */
	public void setFileNameInterchange(String f) {
		fileNameInterchange = f;
	}

	/**
	 * @param integer
	 */
	public void setGiornoInoltro(BigInteger integer) {
		giornoInoltro = integer;
	}

	/**
	 * @param integer
	 */
	public void setMeseInoltro(BigInteger integer) {
		meseInoltro = integer;
	}

	/**
	 * @param string
	 */
	public void setNomeFlusso(String string) {
		nomeFlusso = string;
	}

	/**
	 * @param string
	 */
	public void setProgressivoInterchange(String string) {
		progressivoInterchange = string;
	}

	/**
	 * @param integer
	 */
	public void setProgressivoSede(BigInteger integer) {
		progressivoSede = integer;
	}

	/**
	 * @return
	 */
	public String getCampoRiservato1() {
		return campoRiservato1;
	}

	/**
	 * @return
	 */
	public String getCampoRiservato2() {
		return campoRiservato2;
	}

	/**
	 * @return
	 */
	public String getCampoRiservato3() {
		return campoRiservato3;
	}

	/**
	 * @return
	 */
	public String getCampoRiservato4() {
		return campoRiservato4;
	}

	/**
	 * @return
	 */
	public String getCodiceSezioneDoganale() {
		return codiceSezioneDoganale;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordPresentiNelFlusso() {
		return numeroRecordPresentiNelFlusso;
	}

	/**
	 * @param string
	 */
	public void setCampoRiservato1(String string) {
		campoRiservato1 = string;
	}

	/**
	 * @param string
	 */
	public void setCampoRiservato2(String string) {
		campoRiservato2 = string;
	}

	/**
	 * @param string
	 */
	public void setCampoRiservato3(String string) {
		campoRiservato3 = string;
	}

	/**
	 * @param string
	 */
	public void setCampoRiservato4(String string) {
		campoRiservato4 = string;
	}

	/**
	 * @param integer
	 */
	public void setCodiceSezioneDoganale(String codice) {
		codiceSezioneDoganale = codice;
	}

	/**
	 * @param integer
	 */
	public void setNumeroRecordPresentiNelFlusso(BigInteger integer) {
		numeroRecordPresentiNelFlusso = integer;
	}

	public BigInteger getTipoRecord() {
		return BigInteger.valueOf(-1);
	}

	public void impostaCampiComuni(AbstractRecord in) {
	}

}
