package it.finanze.dogane.accise.model;

import it.finanze.dogane.accise.util.StringUtil;

import java.util.NoSuchElementException;
import java.util.StringTokenizer;

public class MixedDouble {

	private String intValue = "";
	private String decimalValue = "";
	
	public MixedDouble() {}

	public MixedDouble(String intValue, String decimalValue) {
		setIntValue(intValue);
		setDecimalValue(decimalValue);
	}

	public MixedDouble(String stringRappresentation) {
		
		StringTokenizer tokenizer = new StringTokenizer(stringRappresentation, ",.");
		
		try {
			setIntValue(tokenizer.nextToken());
		}
		catch(NoSuchElementException e) {
			setIntValue("");
		}

		try {
			setDecimalValue(tokenizer.nextToken());
		}
		catch(NoSuchElementException e) {
			setDecimalValue("");
		}
	}

	/**
	 * @return
	 */
	public String getDecimalValue() {
		return decimalValue;
	}

	/**
	 * @return
	 */
	public String getIntValue() {
		return intValue;
	}

	/**
	 * @param i
	 */
	public void setDecimalValue(String string) {
		StringBuffer buffer = new StringBuffer(string);
//		boolean found = false;
//		for(int i=0; i < buffer.length(); i++) {
//			if(buffer.charAt(i) != '0') {
//				found = true;
//				break;
//			}
//		}
//		if(found == true) {
//			decimalValue = buffer.toString();
//		} else { // Sono tutti zeri
//			decimalValue = "";
//		}
		while(buffer.length() > 0 && buffer.charAt(buffer.length() - 1) == '0') {
			buffer.deleteCharAt(buffer.length() - 1);
		}
		decimalValue = buffer.toString();
	}

	/**
	 * @param string
	 */
	public void setIntValue(String string) {
		StringBuffer buffer = new StringBuffer(string);
//		while(buffer.length() > 0 && buffer.charAt(0) == '0') {
//			buffer.deleteCharAt(0);
//		}
		intValue = buffer.toString();
	}

	public String toString() {
		String retvalue = intValue;
		if(StringUtil.nullify(decimalValue) != null) {
			retvalue += "." + decimalValue;
		}
		return retvalue;
	}

}
