package it.finanze.dogane.accise.pdf;

import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;

public class DefaultPrintableTableModel
	extends DefaultTableModel
	implements PrintableTableModel {

	public DefaultPrintableTableModel(TableModel model) {
		int columnCount = model.getColumnCount();
		int rowCount = model.getRowCount();
		
		// Imposto il numero di righe e colonne
		setRowCount(rowCount);
		setColumnCount(columnCount);
		
		// Imposto i nomi di colonna
		Object[] identifiers = new Object[columnCount];
		for(int i = 0; i < columnCount; i++) {
			identifiers[i] = model.getColumnName(i);
		}
		setColumnIdentifiers(identifiers);
		
		// Imposto i valori
		for(int i=0; i < columnCount; i++) {
			for(int j=0; j < rowCount; j++) {
				setValueAt(model.getValueAt(j, i), j, i);
			}			
		}
	}

	public PrintableTableModel split(int index, int offset) {
		return getSplitted(this, index, offset);
	}

	public PrintableTableModel split(int index) {
		return split(index, getRowCount() - index);
	}

	public static PrintableTableModel getSplitted(TableModel model, int index, int offset) {
		DefaultPrintableTableModel splitted = new DefaultPrintableTableModel(model);
		
		int rowCount = splitted.getRowCount();
		for(int i = rowCount - 1; i >= index + offset; i--) {
			splitted.removeRow(i);
		}
		for(int i = 0; i < index; i++) {
			splitted.removeRow(0);
		}
		return splitted;
	}

}
