package it.finanze.dogane.accise.ui;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dialog;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.jnlp.FileContents;
import javax.jnlp.FileOpenService;
import javax.jnlp.FileSaveService;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 * @author Fiorello
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ConfirmFileDialog extends JDialog implements ActionListener {
	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JTextField jTxtFile = null;
	private javax.swing.JButton jButtonSend = null;
	private javax.swing.JButton jButtonInterchange = null;
	private javax.swing.JButton jButtonAnnulla = null;

	private int actionRequested = 0;

	private boolean isInterchangeFile = false;
	private boolean isSendFile = false;
	private String fileName = null;
	private Component component = null;
	private boolean retvalue = false;
	private ByteArrayOutputStream byteArrayOutputStream=null;
	private String numeroSupporti=null;
	private FileSaveService fileSaveService = null;

	private javax.swing.JLabel jLblFileName = null;
	private javax.swing.JLabel jLblNumeroSupporti = null;
	
	/**
	 * This is the default constructor
	 */
	public ConfirmFileDialog (
		Component component,
		String title,
		String fileName,
		ByteArrayOutputStream byteArrayOutputStream,
		String numeroSupporti,
		FileSaveService fileSaveService
		) {

		// super((Dialog) component, title, true);
		this.setTitle(title); 
		this.setModal(true);

		initialize();

		if (!fileName.trim().equals("")) {
			jTxtFile.setText(fileName);
		}

		if (component instanceof InterchangeDialog) {
			isInterchangeFile = true;
			isSendFile = false;
		} else {
			isInterchangeFile = false;
			isSendFile = true;
		}

		jButtonSend.setVisible(isSendFile);
		jButtonSend.setEnabled(isSendFile);

		jLblNumeroSupporti.setVisible(isInterchangeFile);
		jButtonInterchange.setVisible(isInterchangeFile);
		jButtonInterchange.setEnabled(isInterchangeFile);

		jLblNumeroSupporti.setText("Supporti necessari per il salvataggio: "+numeroSupporti);

		this.fileName = fileName;
		this.component = component;
		this.byteArrayOutputStream=byteArrayOutputStream;
		this.numeroSupporti=numeroSupporti;
		this.fileSaveService=fileSaveService;
	}

	public int getActionRequested() {

		return actionRequested;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		// this.setSize(350, 268);
		this.setSize(RealDim.getAbsoluteXValue(350), RealDim.getAbsoluteYValue(268));

		int xDim = RealDim.getAbsoluteXDim();
		int yDim = RealDim.getAbsoluteYDim();
		int width = getSize().width;
		int height = getSize().height;

		this.setLocation((xDim - width) / 2, (yDim - height) / 2);

		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setModal(true);
		this.setDefaultCloseOperation(
			javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
	}

	/**************************************************************************************
	 * INIZIO GESTIONE EVENTI
	 **************************************************************************************/
	public void actionPerformed(ActionEvent event) {
		if (event.getSource() == jButtonSend) {
			doSendFile();
		} else if (event.getSource() == jButtonInterchange) {
			doCreaInterchange();
		} else if (event.getSource() == jButtonAnnulla) {
			doClose();
		}
	}

	protected void doClose() {
		this.setVisible(false);
	}

	private void doCreaInterchange() {
		doClose();
		File file = null;
		String[] extensions = {"dic", "DIC"};
		try {
			if(fileSaveService != null) {// Se si lancia attraverso Java Web Start
				ByteArrayInputStream is = new ByteArrayInputStream(byteArrayOutputStream.toByteArray());
				// dalle specifiche SUN il client potrebbe ignorare il nome suggerito !!!
				FileContents newContents = fileSaveService.saveFileDialog(null, extensions, is, fileName);
				if(newContents != null) {
					retvalue = true; 
				}
				is.close();
				
			} else {// Se non si lancia attraverso Java Web Start ma in modalit Client/Server Swing
				// posso salvarlo con il nome specificato ....
				JFileChooser fileChooser = new JFileChooser();
				fileChooser.setFileFilter(new DicFileFilter());
				fileChooser.setSelectedFile(new File(fileName));
				int userAction = fileChooser.showSaveDialog(component);
				if (userAction == JFileChooser.APPROVE_OPTION) {
					file = fileChooser.getSelectedFile();
					FileOutputStream fos = new FileOutputStream(file);
					byteArrayOutputStream.writeTo(fos);
					fos.close();
					retvalue = true;
				}
			}

			if(retvalue == true) {
			//	JOptionPane.showMessageDialog(component, "Salvataggio completato." ,"Ok",JOptionPane.INFORMATION_MESSAGE);
			}

		} catch (IOException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(component, "Errore durante il salvataggio del file: \n" + e.getMessage(),"Errore",JOptionPane.ERROR_MESSAGE);
		}

	}

	private void doSendFile() {
		doClose();

		String[] extensions = {"dic", "DIC"};
		try{
			if(fileSaveService != null) {// Se si lancia attraverso Java Web Start
			ByteArrayInputStream is = new ByteArrayInputStream(byteArrayOutputStream.toByteArray());
			// dalle specifiche SUN il client potrebbe ignorare il nome suggerito !!!
			FileContents newContents = fileSaveService.saveFileDialog(null, extensions, is, fileName);
			if(newContents != null) {
				retvalue = true; 
			}
			}else {// Se non si lancia attraverso Java Web Start
				JFileChooser fileChooser = new JFileChooser();
				//fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				fileChooser.setFileFilter(new DicFileFilter());
				fileChooser.setSelectedFile(new File(fileName));		

				int userAction = fileChooser.showSaveDialog(component);

				if (userAction == JFileChooser.APPROVE_OPTION) {
			
					File file = fileChooser.getSelectedFile();
					FileOutputStream fos = new FileOutputStream(file);
					byteArrayOutputStream.writeTo(fos);
					fos.close();
					retvalue = true;
				}
			}
			if(retvalue == true) {
				// JOptionPane.showMessageDialog(component, "Invio completato." ,"Ok",JOptionPane.INFORMATION_MESSAGE);
			}
		} catch (IOException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(component, "Errore durante il salvataggio del file: \n" + e.getMessage(),"Errore",JOptionPane.ERROR_MESSAGE);
		}

	}

	public boolean getRetValue(){
		return this.retvalue;
	}
	/**************************************************************************************
	 * FINE GESTIONE EVENTI
	 **************************************************************************************/

	/**
		 * This method initializes jContentPane
		 * 
		 * @return javax.swing.JPanel
		 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.setLayout(FullScreenLayoutManager.getInstance());
			jContentPane.add(getJTxtFile(), null);
			jContentPane.add(getJButtonSend(), null);
			jContentPane.add(getJButtonInterchange(), null);
			jContentPane.add(getJButtonAnnulla(), null);
			jContentPane.add(getJLblFileName(), null);
			jContentPane.add(getJLblNumeroSupporti(), null);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jTxtFile
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JTextField getJTxtFile() {
		if (jTxtFile == null) {
			jTxtFile = new javax.swing.JTextField();
			jTxtFile.setBounds(20, 84, 300, 25);
			jTxtFile.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jTxtFile.setEditable(false);
			jTxtFile.setEnabled(true);
			jTxtFile.setBackground(Color.WHITE);
			jTxtFile.setToolTipText("Seleziona e copia il nome del file");
		}
		return jTxtFile;
	}
	/**
	 * This method initializes jButtonSend
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonSend() {
		if (jButtonSend == null) {
			jButtonSend = new javax.swing.JButton();
			jButtonSend.setBounds(20, 118, 300, 25);
			jButtonSend.setText("Invia file");
			jButtonSend.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
			jButtonSend.setActionCommand("sendFile");
			jButtonSend.addActionListener(this);

		}
		return jButtonSend;
	}

	/**
	 * This method initializes jButtonInterchange
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonInterchange() {
		if (jButtonInterchange == null) {
			jButtonInterchange = new javax.swing.JButton();
			jButtonInterchange.setBounds(20, 118, 300, 25);
			jButtonInterchange.setText("Crea Interchange");
			jButtonInterchange.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
			jButtonInterchange.setActionCommand("creaInterchange");
			jButtonInterchange.addActionListener(this);

		}
		return jButtonInterchange;
	}
	/**
	 * This method initializes jButtonAnnulla
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonAnnulla() {
		if (jButtonAnnulla == null) {
			jButtonAnnulla = new javax.swing.JButton();
			jButtonAnnulla.setBounds(223, 159, 96, 23);
			jButtonAnnulla.setText("Chiudi");
			jButtonAnnulla.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonAnnulla.setActionCommand("chiudi");
			jButtonAnnulla.addActionListener(this);
		}
		return jButtonAnnulla;
	}
	/**
	 * This method initializes jLblFileName
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLblFileName() {
		if (jLblFileName == null) {
			jLblFileName = new javax.swing.JLabel();
			jLblFileName.setBounds(20, 50, 300, 25);
			jLblFileName.setText("Nome file consigliato:");
		}
		return jLblFileName;
	}
	/**
	 * This method initializes jLblNumeroSupporti
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLblNumeroSupporti() {
		if(jLblNumeroSupporti == null) {
			jLblNumeroSupporti = new javax.swing.JLabel();
			jLblNumeroSupporti.setBounds(20, 16, 300, 25);
			jLblNumeroSupporti.setText("");
		}
		return jLblNumeroSupporti;
	}
} //  @jve:visual-info  decl-index=0 visual-constraint="46,67"
