package it.finanze.dogane.accise.ui;

import it.finanze.dogane.accise.pdf.AbstractPdfProspectWriter;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JDialog;

public class PrintDialog extends JDialog implements ActionListener {

	private int actionRequested = AbstractPdfProspectWriter.PRINT_ANYTHING;

	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JRadioButton jRadioButtonFrontespizio = null;
	private javax.swing.JRadioButton jRadioButtonQuadro = null;
	private javax.swing.JRadioButton jRadioButtonTutto = null;
	private javax.swing.JButton jButtonStampa = null;
	private javax.swing.JButton jButtonAnnulla = null;
	
	private ButtonGroup buttonGroup = new ButtonGroup();
	
	public PrintDialog(Frame frame) {
		super(frame);
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 170);
		this.setContentPane(getJContentPane());
		this.setTitle("Stampa Dichiarazione");
		this.setModal(true);
	
		int xDim = RealDim.getAbsoluteXDim();
		int yDim = RealDim.getAbsoluteYDim();
		int width = getSize().width;
		int height = getSize().height;

		this.setLocation((xDim - width) / 2, (yDim - height) / 2);
	}

	/**
	 * Ritorna l'azione intrapresa dall'utente
	 * @return
	 */
	public int getActionRequested() {
		return actionRequested;
	}

/**********************************************************************************
 * INIZIO GESTIONE EVENTI
 **********************************************************************************/
	public void actionPerformed(ActionEvent event) {
		if(event.getSource() == jButtonStampa) {
			doPrint();
		} else if(event.getSource() == jButtonAnnulla) {
			doCancel();
		}
	}

	private void doPrint() {
		if(jRadioButtonFrontespizio.isSelected()) {
			actionRequested = AbstractPdfProspectWriter.PRINT_FRONTESPIZIO;
		} else if(jRadioButtonQuadro.isSelected()) {
			actionRequested = AbstractPdfProspectWriter.PRINT_QUADRO;
		} else if(jRadioButtonTutto.isSelected()) {
			actionRequested = AbstractPdfProspectWriter.PRINT_ALL;
		} else {
			actionRequested = AbstractPdfProspectWriter.PRINT_ANYTHING;
		}
		
		setVisible(false);
	}

	private void doCancel() {
		actionRequested = AbstractPdfProspectWriter.PRINT_ANYTHING;
		setVisible(false);
	}

/**********************************************************************************
 * FINE GESTIONE EVENTI
 **********************************************************************************/


/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getJRadioButtonFrontespizio(), null);
			jContentPane.add(getJRadioButtonQuadro(), null);
			jContentPane.add(getJRadioButtonTutto(), null);
			jContentPane.add(getJButtonStampa(), null);
			jContentPane.add(getJButtonAnnulla(), null);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jRadioButtonFrontespizio
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButtonFrontespizio() {
		if(jRadioButtonFrontespizio == null) {
			jRadioButtonFrontespizio = new javax.swing.JRadioButton();
			jRadioButtonFrontespizio.setBounds(10, 10, 99, 21);
			jRadioButtonFrontespizio.setText("Frontespizio");

			jRadioButtonFrontespizio.setSelected(true);
			buttonGroup.add(jRadioButtonFrontespizio);
		}
		return jRadioButtonFrontespizio;
	}
	/**
	 * This method initializes jRadioButtonQuadro
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButtonQuadro() {
		if(jRadioButtonQuadro == null) {
			jRadioButtonQuadro = new javax.swing.JRadioButton();
			jRadioButtonQuadro.setBounds(10, 40, 139, 21);
			jRadioButtonQuadro.setText("Quadri Selezionati");

			buttonGroup.add(jRadioButtonQuadro);
		}
		return jRadioButtonQuadro;
	}
	/**
	 * This method initializes jRadioButtonTutto
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButtonTutto() {
		if(jRadioButtonTutto == null) {
			jRadioButtonTutto = new javax.swing.JRadioButton();
			jRadioButtonTutto.setBounds(10, 70, 150, 21);
			jRadioButtonTutto.setText("Tutta la Dichiarazione");

			buttonGroup.add(jRadioButtonTutto);
		}
		return jRadioButtonTutto;
	}
	/**
	 * This method initializes jButtonStampa
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonStampa() {
		if(jButtonStampa == null) {
			jButtonStampa = new javax.swing.JButton();
			jButtonStampa.setBounds(200, 10, 80, 25);
			jButtonStampa.setText("Stampa");
			
			jButtonStampa.addActionListener(this);
		}
		return jButtonStampa;
	}
	/**
	 * This method initializes jButtonAnnulla
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonAnnulla() {
		if(jButtonAnnulla == null) {
			jButtonAnnulla = new javax.swing.JButton();
			jButtonAnnulla.setBounds(200, 40, 80, 25);
			jButtonAnnulla.setText("Annulla");

			jButtonAnnulla.addActionListener(this);
		}
		return jButtonAnnulla;
	}

}  //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
