package it.finanze.dogane.accise.ui.quadri;

import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.net.URL;

import javax.swing.DefaultListCellRenderer;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;

public class QuadroListCellRenderer extends DefaultListCellRenderer {

	private static Icon iconV = null;
	private static Icon iconNull = null;
	private static boolean iconInitialized = false;
	
	public Component getListCellRendererComponent(
												JList list, 
												Object value, 
												int index, 
												boolean isSelected, 
												boolean cellHasFocus) {

		if(!(value instanceof EtichettaQuadro)) {
			throw new RuntimeException("La lista "+ list +" contiene un oggetto che non  di tipo EtichettaQuadro. Tipo:" + value.getClass().getName());
		}

		if(!iconInitialized) {
			URL urlV = getClass().getClassLoader().getResource("it/finanze/dogane/accise/ui/icons/Tick.gif");
			URL urlNull = getClass().getClassLoader().getResource("it/finanze/dogane/accise/ui/icons/Nullo.gif");
			if(urlV != null) {
				iconV = new ImageIcon(urlV);
			}
			if(urlNull != null) {
				iconNull = new ImageIcon(urlNull);
			}
			iconInitialized = true;
		}

		JLabel label = (JLabel)super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus); 

		EtichettaQuadro etichettaQuadro = (EtichettaQuadro)value;

		if(iconV == null || iconNull == null) { // Se non sono stato in grado di leggere le icone
			if(etichettaQuadro.isEmpty()) {
				label.setText("  " + label.getText());
			} else {
				label.setText("V " + label.getText());
			}
		} else { // Altrimenti facciamole vedere no?
			if(etichettaQuadro.isEmpty()) {
				label.setIcon(iconNull);
			} else {
				label.setIcon(iconV);
			}
		}

		if(etichettaQuadro.isComplex()) {
			label.setText(label.getText() + " >>>");
		}

		return label;
	}

}
