package it.finanze.dogane.accise.util;

import java.util.StringTokenizer;

/**
 * Classe di utilit che contiene dei metodi capaci di manipolare
 * delle stringhe. 
 */
public class StringUtil {

	/**
	 * Ritorna la stringa passata come parametro se e solo se
	 *  diversa da null, dalla stringa vuota o da una stringa
	 * contenente caratteri che possono essere "trimmati".
	 * Altrimenti torna null.
	 * @param string
	 * @return
	 */
	public static String nullify(String string) {
		if(string == null || string.trim().equals("")) {
			return null;
		} else {
			return string;
		}
	}  
	
	public static String nullifyZero(String string) {
		if(string == null || string.trim().equals("") || string.trim().equals("0")) {
			return null;
		} else {
			return string;
		}
	}  

	/**
	 * Ritorna la stringa passata come parametro se e solo se
	 *  diversa da null, dalla stringa vuota o da una stringa
	 * contenente caratteri che possono essere "trimmati".
	 * Altrimenti torna la string vuota.
	 * @param string
	 * @return
	 */
	public static String denullify(String string) {
		if(string == null || string.trim().equals("")) {
			return "";
		} else {
			return string;
		}
	}

	/**
	 * Esegue la string.trim() facendo attenzione a non
	 * generare un null pointer exception
	 * @param string
	 * @return
	 */
	public static String trim(String string) {
		if(string == null) {
			return null;
		} else {
			return string.trim();
		}
	}
	
	public static String replaceZero(String string)
	{
		int numeroDiZero = 0;
		if (string==null) return null;
		string = string.trim();
		int lunghezzaStringa = string.length();
		for (int i=0;i<lunghezzaStringa;i++)
		{
			if (string.charAt(i)=='0')
				numeroDiZero++;
			else
				break;
		}
		if (numeroDiZero==lunghezzaStringa)
			return "";
		else
			return string;
	}
	
	public static String replaceZeroIniziali(String string)
	{
		if (string==null) return null;
		string = string.trim();
		int lunghezzaStringa = string.length();
		int indice = 0;
		
		for (int i=0;i<lunghezzaStringa;i++)
		{
			if ( string.charAt(i)!='0' )
				break;
			else
				indice++;
		}	
		return string.substring(indice);
	}
	
}
