package it.finanze.dogane.accise.aautotrasportatori.ui;
import it.finanze.dogane.accise.aautotrasportatori.config.Contatori;
import it.finanze.dogane.accise.aautotrasportatori.config.VisualConfig;
import it.finanze.dogane.accise.aautotrasportatori.model.AutotrasportatoriQuadroA;
import it.finanze.dogane.accise.aautotrasportatori.model.DatiContabiliObject;
import it.finanze.dogane.accise.aautotrasportatori.model.DatiContabiliRecord;
import it.finanze.dogane.accise.aautotrasportatori.model.Frontespizio;
import it.finanze.dogane.accise.aautotrasportatori.model.ProspettoConsumo;
import it.finanze.dogane.accise.aautotrasportatori.pdf.PdfProspectWriter;
import it.finanze.dogane.accise.aautotrasportatori.ui.quadri.Quadro;
import it.finanze.dogane.accise.combo.AbstractTipo;
import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.ComboUtil;
import it.finanze.dogane.accise.combo.TipoPeriodo;
import it.finanze.dogane.accise.combo.TipoProvincia;
import it.finanze.dogane.accise.commonsfacade.TipoPeriodoFacade;
import it.finanze.dogane.accise.risorse.Risorse;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.actions.AboutAction;
import it.finanze.dogane.accise.ui.actions.BaseAbstractAction;
import it.finanze.dogane.accise.ui.actions.ExitAction;
import it.finanze.dogane.accise.ui.actions.HelpAction;
import it.finanze.dogane.accise.ui.actions.InterchangeAction;
import it.finanze.dogane.accise.ui.actions.NewAction;
import it.finanze.dogane.accise.ui.actions.OpenAction;
import it.finanze.dogane.accise.ui.actions.SendAction;
import it.finanze.dogane.accise.ui.laf.LAFManager;
import it.finanze.dogane.accise.ui.quadri.QuadroListCellRenderer;
import it.finanze.dogane.accise.ui.validation.BigDecimalDocument;
import it.finanze.dogane.accise.ui.validation.BigIntegerDocument;
import it.finanze.dogane.accise.ui.validation.StringDocument;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.DefaultListModel;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.ScrollPaneConstants;
import javax.swing.border.Border;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.plaf.basic.BasicComboBoxRenderer;
import javax.swing.text.Document;

public class AutotrasportatoriFrame extends JFrame implements ActionListener, ListSelectionListener, MouseListener, FocusListener {
	private ProspettoConsumo prospettoConsumo = new ProspettoConsumo();
	private javax.swing.JPanel mainPanel = null;
	private javax.swing.JMenuBar mainMenuBar = null;
	private javax.swing.JMenu fileMenu = null;
	private javax.swing.JMenu helpMenu = null;
	private NewAction newAction = null;
	private OpenAction openAction = null;
	private SendAction sendAction = null;
	private ExitAction exitAction = null;
	private AboutAction aboutAction = null;
	private HelpAction helpAction = null;
	private javax.swing.JPanel workPanel = null;
	private javax.swing.JToolBar jToolBar = null;
	private javax.swing.JPanel jPanelCodiceDitta = null;
	private javax.swing.JLabel jLCodiceDitta = null;
	private javax.swing.JTextField jTextCodiceDitta1 = null;
	private javax.swing.JTextField jTextCodiceDitta2 = null;
	//	private javax.swing.JLabel jLAnno = null;
	//	private javax.swing.JTextField jTextAnno = null;
	private javax.swing.JPanel jPanelDichiarante = null;
	private javax.swing.JLabel jLabelDichiarante = null;
	private javax.swing.JLabel jLabelDenominazioneDic = null;
	private javax.swing.JTextField jTextIndirizzoDic = null;
	private javax.swing.JPanel jPanelUfficioAmministrativo = null;
	private javax.swing.JLabel jLabelUffAmm = null;
	private javax.swing.JLabel jLabelProvinciaUffAmm = null;
	private javax.swing.JLabel jLabelIndirizzoUffAmm = null;
	private javax.swing.JComboBox jComboBoxProvinciaUffAmm = null;
	private javax.swing.JLabel jLabelComuneUffAmm = null;
	private javax.swing.JComboBox jComboBoxComuneUffAmm = null;
	private javax.swing.JPanel jPanel3 = null;
	private javax.swing.JLabel jLabelQuadriDettaglio = null;
	private javax.swing.JLabel jLabelPercorsoFile = null;
	private javax.swing.JLabel JLabelIcon = null;
	private javax.swing.JLabel jLabel = null;
	private javax.swing.JComboBox jComboBoxUfficio = null;
	private javax.swing.JLabel jLabel1 = null;
	private javax.swing.JTextField jTextFieldAnno = null;
	private javax.swing.JLabel jLabel2 = null;
	private javax.swing.JComboBox jComboBoxPeriodo = null;
	private javax.swing.JPanel jPanel = null;
	private javax.swing.JLabel jLabel4 = null;
	private javax.swing.JTextField jTextFieldCognome = null;
	private javax.swing.JLabel jLabel5 = null;
	private javax.swing.JTextField jTextFieldNome = null;
	private javax.swing.JLabel jLabel6 = null;
	private javax.swing.JTextField jTextFieldCodFiscale = null;
	private javax.swing.JLabel jLabel7 = null;
	private javax.swing.JComboBox jComboBoxNellaQualitaDi = null;
	private javax.swing.JPanel jPanel1 = null;
	private javax.swing.JTabbedPane jTabbedPane = null;
	private javax.swing.JPanel jPanel2 = null;
	private javax.swing.JLabel jLabel8 = null;
	private javax.swing.JTextField jTextFieldPartitaIva = null;
	private javax.swing.JLabel jLabel9 = null;
	private javax.swing.JCheckBox jCheckBoxNazionale = null;
	private javax.swing.JLabel jLabel10 = null;
	private javax.swing.JComboBox jComboBoxComunatario = null;
	private javax.swing.JLabel jLabel11 = null;
	private javax.swing.JTextField jTextFieldDenominazione = null;
	private javax.swing.JLabel jLabel12 = null;
	private javax.swing.JComboBox jComboBoxTipoEsercente = null;
	private javax.swing.JPanel jPanel31 = null;
	private javax.swing.JLabel jLabel14 = null;
	private javax.swing.JComboBox jComboBoxProvinciaSedeLegale = null;
	private javax.swing.JLabel jLabel15 = null;
	private javax.swing.JComboBox jComboBoxComuneSedeLegale = null;
	private javax.swing.JLabel jLabel16 = null;
	private javax.swing.JTextField jTextFieldIndirizzoSedeLegale = null;
	private javax.swing.JPanel startupPanel = null;
	private javax.swing.JLabel jLabel22 = null;
	private javax.swing.JComboBox jComboBoxCodAttivita = null;
	private javax.swing.JLabel jLabel23 = null;
	private javax.swing.JRadioButton jRadioButtonContoProprioAutoTraspMerci = null;
	private javax.swing.JRadioButton jRadioButtonContoTerziAutoTraspMerci = null;
	private javax.swing.JLabel jLabel24 = null;
	private javax.swing.JTextField jTextFieldEstremiLicenza = null;
	private javax.swing.JLabel jLabel25 = null;
	private javax.swing.JLabel jLabel26 = null;
	private javax.swing.JTextField jTextFieldCertificatoImmatr = null;
	private javax.swing.JLabel jLabel27 = null;
	private javax.swing.JTextField jTextFieldTitoloPossesso = null;
	private javax.swing.JButton jButtonChiudi = null;
	private javax.swing.JButton jButtonStampa = null;
	private javax.swing.JButton jButtonSave = null;
	private javax.swing.JButton jButtonSaveAs = null;
	private javax.swing.JPanel jPanel4 = null;
	private javax.swing.JLabel jLabel28 = new javax.swing.JLabel();
	private javax.swing.JTextField jTextFieldCCP = new javax.swing.JTextField();
	private javax.swing.JLabel jLabel29 = new javax.swing.JLabel();
	private javax.swing.JTextField jTextFieldTOTACredito = new javax.swing.JTextField();
	private javax.swing.JRadioButton jRadioButtonEuro = new javax.swing.JRadioButton();
	private javax.swing.JRadioButton jRadioButtonLire = null;
	private javax.swing.JLabel jLabel21 = null;
	private javax.swing.JLabel jLabel31 = null;
	private javax.swing.JLabel jLabel32 = new javax.swing.JLabel();
	private javax.swing.JLabel jLabel33 = new javax.swing.JLabel();
	private javax.swing.JTextField jTextFieldIban = new javax.swing.JTextField();
	private javax.swing.JLabel jLabel34 = new javax.swing.JLabel();
	private javax.swing.JTextField jTextFieldBIC = new javax.swing.JTextField();
	private javax.swing.JLabel jLabel35 = new javax.swing.JLabel();
	private javax.swing.JTextField jTextFieldCCN =  new javax.swing.JTextField();
	private javax.swing.JLabel jLabel36 = new javax.swing.JLabel();
	private javax.swing.JRadioButton jRadioButtonCoordinatePostaliNaz = new javax.swing.JRadioButton();
	private javax.swing.JLabel jLabel37 = new javax.swing.JLabel();
	private javax.swing.JLabel jLabel38 = new javax.swing.JLabel();
	private javax.swing.JTextField jTextFieldCodABI =  new javax.swing.JTextField();
	private javax.swing.JLabel jLabel39 = new javax.swing.JLabel();
	private javax.swing.JLabel jLabel40 = new javax.swing.JLabel();
	private javax.swing.JLabel jLabel41 = new javax.swing.JLabel();
	private javax.swing.JTextField jTextFieldCodCAB =  new javax.swing.JTextField();
	private javax.swing.JLabel jLabel42 = new javax.swing.JLabel();
	private javax.swing.JTextField jTextFieldTOTLitriConsumati = new javax.swing.JTextField();
	private javax.swing.JLabel jLabel43 = new javax.swing.JLabel();
	private javax.swing.JRadioButton jRadioButton7 = null;
	private javax.swing.JRadioButton jRadioButtonCoordinateBancarieEuropee = new javax.swing.JRadioButton();
	private javax.swing.JPanel jPanel5 = null;
	private javax.swing.JLabel jLabel30 = new javax.swing.JLabel();
	private javax.swing.JPanel jPanel6 = null;
	private javax.swing.JLabel jLabel3 = null;
	private javax.swing.JComboBox jComboBoxProvinciaSedeAmm = null;
	private javax.swing.JLabel jLabel13 = null;
	private javax.swing.JComboBox jComboBoxComuneSedeAmm = null;
	private javax.swing.JTextField jTextFieldIndirizzoSedeAmm = null;
	private javax.swing.JLabel jLabel17 = null;
	private javax.swing.JLabel jLabel18 = new javax.swing.JLabel();
	private javax.swing.JLabel jLabel19 = new javax.swing.JLabel();
	private javax.swing.JRadioButton jRadioButtonCoordinateBancarieNaz = new javax.swing.JRadioButton();
	private javax.swing.JRadioButton jRadioButtonModalitaPrescelta = new javax.swing.JRadioButton();
	private javax.swing.JMenu InterchMenu = null;
	private boolean sendActionMode = false;
	private InterchangeAction interchangeAction = null;
	private javax.swing.JPanel jPanelComunitario = null;
	private javax.swing.JLabel jLabel20 = null;
	private ButtonGroup buttonGroupDatiContabili = new ButtonGroup();
	private ButtonGroup buttonGroupAutotrasportoMerci = new ButtonGroup();
	private ButtonGroup buttonGroupValuta = new ButtonGroup();
	private javax.swing.JTextField jTextFieldCittaPanelloComunitario = null;
	private javax.swing.JLabel jLabel211 = null;
	private javax.swing.JTextField jTextFieldIndirizzoPannelloComunitario = null;
	private javax.swing.JPanel jPanelOpzionePeriodo = null;
	private javax.swing.JLabel jLabel213 = null;
	private javax.swing.JLabel jLabel214 = null;
	private javax.swing.JLabel jLabel212 = null;
	private javax.swing.JTextField jTextFieldLitriConsumatiMassaSup_INF = null;
	private javax.swing.JLabel jLabel215 = null;
	private javax.swing.JTextField jTextFieldImportoCreditoMassaSUP_INF = null;
	private javax.swing.JLabel jLabel216 = null;
	private javax.swing.JLabel jLabel217 = null;
	private javax.swing.JTextField jTextFieldLitriConsumatiMassaInf = null;
	private javax.swing.JLabel jLabel218 = null;
	private javax.swing.JTextField jTextFieldImportoCreditoiMassaInf11 = null;
	private javax.swing.JCheckBox jCheckBoxCarbonTaxPresentata = null;
	
	private javax.swing.JLabel jLabelAlertPerc = null;
	
	
	private BigInteger totRecordInFile = BigInteger.valueOf(0);
	private javax.swing.JList jListListaQuadri = null;
	private JScrollPane scrollPane = null;
	// aggiunti reply
	private JLabel jLabelDate1 = null;
	private JLabel jLabelDate2 = null;
	private JLabel jLabelLitriConsumati = null;
	private JLabel jLabelImportoAcredito = null;
	private JLabel jLabelLitriConsumati2 = null;
	private JLabel jLabelImportoAcredito2 = null;
	private JTextField jTextFieldLitriConsumatiA1 = null;
	private JTextField jTextFieldLitriConsumatiA2 = null;
	private JTextField jTextFieldACreditoA1 = null;
	private JTextField jTextFieldACreditoA2 = null;
	private JTextField jTextFieldPeriodo = null;
	
	
	private JTextField[]arrayLitriConsumati = null;
	private JTextField[]arrayImportoACredito = null;
	private JLabel[]arrayLabelPeriodi = null;
	private double[]arrayAliquote = null;
	private String[]arrayPeriodiDalAliquote = null;
	private String[]arrayPeriodiAlAliquote = null;
	
	
	private static String[]arrayStringPeriodi = null;
	private static String  annoRiferimento= null;
	private static String  periodo = null;
	
	//private static Set setStringDecretiLegge = null;
	private static Vector setStringDecretiLegge = null;
	
	private static int NumeroAliquote;
	private static int numeroPeriodo;
	
	private int[]arrayPercentualeDecurtazione = null;
	
	
	private javax.swing.JLabel jLabelEuroZero = null;
	private javax.swing.JCheckBox jCheckBoxEuroZero = null;
	


	public static void main(String[] args) {
		AutotrasportatoriFrame frame = new AutotrasportatoriFrame();
		//		frame.pack();
		frame.setVisible(true); 
	}
	/**
	 * This is the default constructor
	 */
	public AutotrasportatoriFrame() {
		super();
		initialize();
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		/*
		JOptionPane.showMessageDialog(this,"A partire dall'anno 2008 "+
		 "sono ammessi al beneficio i veicoli adibiti al trasporto merci\n con massa massima complessiva  "+
		"pari o superiore a 7,5 tonnellate" ,"Attenzione",JOptionPane.WARNING_MESSAGE);
		*/		
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		
		this.inizializzaRisorse();
		this.initActions();
		//int widthPane=(VisualConfig.FORCED_800_600_MODE)?800:RealDim.getAbsoluteXValue(800);
		//int heigthPane=(VisualConfig.FORCED_800_600_MODE)?600:RealDim.getAbsoluteXValue(600);
		this.setSize(
		//	widthPane,
		//	heigthPane
			RealDim.getAbsoluteXValue(800),
			RealDim.getAbsoluteYValue(600)
		);
		//		this.setSize(800,	600);

		this.setContentPane(getMainPanel());
		this.setJMenuBar(getMainMenuBar());
		this.setResizable(false);
		this.setTitle("Agevolazioni Autotrasportatori");
		setStartupPanel();
		//	setWorkPanel();
		
		
	}

	private void initJLabelFont(JLabel label,String text, Font font, int align,int x,int y,int width,int height) {				
	
			label.setBounds(
					RealDim.getAbsoluteXValue(x),
					RealDim.getAbsoluteYValue(y),
					RealDim.getAbsoluteXValue(width),
					RealDim.getAbsoluteYValue(height));
				
			label.setText(text);
			if(align != -1)
				label.setHorizontalAlignment(align);
			
			label.setFont(font);
	
		}
	
	
	private void inizializzaRisorse() {
		
		List listDatiContabili = Risorse.getInstance().getListDatiContabili();
		int listSize = listDatiContabili.size();
		
		arrayLitriConsumati = new JTextField[listSize];
		arrayImportoACredito = new JTextField[listSize];
		arrayLabelPeriodi = new JLabel[listSize];
		arrayAliquote = new double[listSize];
		arrayPeriodiDalAliquote = new String[listSize];
		arrayPeriodiAlAliquote = new String[listSize];
		arrayPercentualeDecurtazione = new int[listSize];
		arrayStringPeriodi = new String[listSize];
		//setStringDecretiLegge = new TreeSet();
		setStringDecretiLegge = new Vector();
		NumeroAliquote = listSize;
		 
				
		for (int i = 0; i < listSize; i++) { 
			
			DatiContabiliObject element = (DatiContabiliObject) listDatiContabili.get(i);
			
			if (i == 0) {//record frontespizio
				
				annoRiferimento= String.valueOf(element.getAnno());
				periodo =  element.getPeriodoDiRiferimento();
				numeroPeriodo = element.getNumeroPeriodo().intValue();
			}
			
			arrayLitriConsumati[i] = new JTextField();
			arrayImportoACredito[i] = new JTextField(); 			
			arrayLabelPeriodi[i]= new JLabel(element.getProgressivoRiga() +") Dal "+element.getDescrDa()+" al "+element.getDescrA());
			arrayStringPeriodi[i] = new String(element.getProgressivoRiga() +") Dal "+element.getDescrDa()+" al "+element.getDescrA());
			arrayAliquote[i] = element.getAliquota().doubleValue(); 
			arrayPeriodiDalAliquote[i]= element.getPeriodoDa();
			arrayPeriodiAlAliquote[i]= element.getPeriodoA();
			arrayPercentualeDecurtazione[i] = element.getPercentualeDecurtazione();
			setStringDecretiLegge.add(element.getDecreto());
			
		}	
		
	
	}

	private void setStartupPanel() {
		mainPanel = new javax.swing.JPanel();
		mainPanel.setLayout(new java.awt.BorderLayout());
		mainPanel.add(getJToolBar(), java.awt.BorderLayout.NORTH);
		mainPanel.add(getStartupPanel(), java.awt.BorderLayout.CENTER);
		this.setContentPane(mainPanel);
		
		
		
	}

	private void setWorkPanel() {
		mainPanel = new javax.swing.JPanel();
		mainPanel.setLayout(new java.awt.BorderLayout());
		mainPanel.add(getJToolBar(), java.awt.BorderLayout.NORTH);
		mainPanel.add(getWorkPanel(), java.awt.BorderLayout.CENTER);
		this.setContentPane(mainPanel);
	}

	// This method should be called before creating the UI 
	// to create all the Actions
	private void initActions() {

		newAction = new NewAction();
		registerAction(newAction);

		openAction = new OpenAction();
		registerAction(openAction);

		sendAction = new SendAction();
		registerAction(sendAction);

		exitAction = new ExitAction();
		registerAction(exitAction);

		aboutAction = new AboutAction("Agevolazioni Autotrasportatori", "v1.0");
		registerAction(aboutAction);
		
		helpAction = new HelpAction();
		registerAction(helpAction);

		interchangeAction = new InterchangeAction("", "");
		registerAction(interchangeAction);

	}

	private void registerAction(BaseAbstractAction action) {
		action.addActionListener(this);
	}

	private void initQuadri() {

		DefaultListModel model = new DefaultListModel();
		jListListaQuadri.setModel(model);
		
		//modifica 05/08/2008 quadro A-2 abilitato
		jListListaQuadri.setCellRenderer(new QuadroListCellRenderer());
		//jListListaQuadri.setCellRenderer(new QuadroListRendererWithDisabled());
		
		Quadro etichetta = null;
		int contatoreQuadri = 1;
		//tanti Quadri A quante sono le aliquote definite nel PERIODI.TXT
		List listaQuadriA = Quadro.initListaQuadroA(getNumeroAliquote());
		//String massaA = "Autoveicoli massa superiore a 3,5 T";
		String massaA = "Autoveicoli massa pari o superiore a 7,5 T";
		
		for (int i = 0; i < getNumeroAliquote(); i++) {
			
			etichetta = new Quadro((int[])listaQuadriA.get(i));
			etichetta.setTitle("Quadro A-"+contatoreQuadri);
			etichetta.setDataInizioPossesso(arrayPeriodiDalAliquote[i].replaceAll("/",""));
			etichetta.setDataFinePossesso(arrayPeriodiAlAliquote[i].replaceAll("/",""));
			etichetta.setAliquota(arrayAliquote[i]);
			
			etichetta.setPercentualeDecurtazione(arrayPercentualeDecurtazione[i]);
			
			etichetta.setQuadroSelezionato(i);
			
			etichetta.setDescription("Quadro A-"+contatoreQuadri+"- "+massaA+" ("+arrayPeriodiDalAliquote[i]+" - "+arrayPeriodiAlAliquote[i]+")");
			etichetta.setSecondDescription(massaA);
			etichetta.setComplex(false);
			etichetta.setEmpty(true);
			model.addElement(etichetta);
			contatoreQuadri++;
			
		}
		

		etichetta = new Quadro(Quadro.QUADRO_B);
		etichetta.setTitle("Quadro B");
		etichetta.setDescription(
			"Quadro B - Esercente distributore privato carburante");
		etichetta.setSecondDescription(
			"Esercente distributore privato carburante");
		etichetta.setComplex(false);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.QUADRO_C);
		etichetta.setTitle("Quadro C");
		etichetta.setDescription(
			"Quadro C - Altri automezzi...distributore privato");
		etichetta.setSecondDescription(
			"Altri automezzi...distributore privato ");
		etichetta.setComplex(false);
		etichetta.setEmpty(true);
		model.addElement(etichetta);
	}

	private void setQuadri(ProspettoConsumo prospettoConsumo) {
		DefaultListModel model = (DefaultListModel) jListListaQuadri.getModel();

		Enumeration enumeration = model.elements();
		while (enumeration.hasMoreElements()) {
			Quadro quadro = (Quadro) enumeration.nextElement();
			quadro.setProspect(prospettoConsumo);
		}
	}

	public synchronized void setTitle(String title) {
		if (StringUtil.nullify(title) == null) {
			super.setTitle("Agevolazioni autotrasportatori");
		} else if (title.trim().equals("Agevolazioni autotrasportatori")) {
			super.setTitle("Agevolazioni autotrasportatori");
		} else {
			super.setTitle("Agevolazioni autotrasportatori - " + title);
		}
	}

	public void valueChanged(ListSelectionEvent event) {
		try {
			if (event.getSource() == jListListaQuadri) {
				//showDescription();
			}
		} catch (Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(
				this,
				"Errore durante l'operazione richiesta: \n" + e.getMessage(),
				"Errore",
				JOptionPane.ERROR_MESSAGE);
		}
	}

	/*************************************************************************
		 * INIZIO GESTIONE EVENTI
	***************************************************************************/

	public void actionPerformed(ActionEvent event) {

		try {
			if (aboutAction
				.getActionCommand()
				.equals(event.getActionCommand())) {
				GestoreEventi.showHelp(this, aboutAction);
			} else if (helpAction.getActionCommand().equals(event.getActionCommand())) {
				GestoreEventi.showGuida();
			}else if (
				openAction.getActionCommand().equals(
					event.getActionCommand())) {
				doOpen();
			} else if (
				newAction.getActionCommand().equals(
					event.getActionCommand())) {
				//				int ret = JOptionPane.showConfirmDialog(
				//								this,
				//								"Dichiarazione periodica (D.L. 21 febbraio 2005)\n"+
				//								"Autoveicoli con massa massima complessiva superiore a 3,5 tonnellate.\n"+
				//								"Prossima scadenza 30 giugno 2006 per il periodo 22 febbraio - 31 dicembre 2005\n"+
				//								"Aliquota 9,78609 Euro per mille litri.\nConfermi ?",
				//								"Nuova Dichiarazione",
				//								JOptionPane.YES_NO_OPTION, 
				//								JOptionPane.QUESTION_MESSAGE);
				//				if( ret == JOptionPane.YES_OPTION ) {
				prospettoConsumo = new ProspettoConsumo();
				setWorkPanel();
				clearUI();
				//				}
				//				else if( ret == JOptionPane.NO_OPTION) {
				//					//....
				//				}
			} else if (
				sendAction.getActionCommand().equals(
					event.getActionCommand())) {
				sendFile();
			} else if (
				interchangeAction.getActionCommand().equals(
					event.getActionCommand())) {
				doOpenInterchageSession();
			} else if (
				exitAction.getActionCommand().equals(
					event.getActionCommand())) {
				GestoreEventi.exitApplication();
			} else if (event.getSource() == jButtonChiudi) {
				prospettoConsumo = new ProspettoConsumo();
				clearUI();
				setStartupPanel();
			} else if (event.getSource() == jButtonSave) {
				boolean chechIsOk = checkAllParameter();
				if (chechIsOk){
					Contatori.azzeraCounters();
					doSave(false);					
				}

			} else if (event.getSource() == jButtonSaveAs) {
				boolean chechIsOk = checkAllParameter();
				if (chechIsOk){
					Contatori.azzeraCounters();
					doSave(true);					
				}

			} else if (event.getSource() == jButtonStampa) {
				doPrint();
			} else if (event.getSource() == jComboBoxProvinciaSedeLegale) {
				updateComboDic();
			} else if (event.getSource() == jComboBoxProvinciaSedeAmm) {
				updateComboUffAm();
			} else if (
				interchangeAction.getActionCommand().equals(
					event.getActionCommand())) {
				//GestoreEventi.Interchange(this, interchangeAction);
			} else if (event.getSource() == getJCheckBoxNazionale()) {
				validateProspettoNazionale();
			} else if (
//				event.getSource() == getJRadioButtonCoordinateBancarieNaz()
//					|| event.getSource() == getJRadioButtonCoordinatePostaliNaz()
//					|| 
					event.getSource() == getJRadioButton62()
					|| event.getSource() == getJRadioButtonModalitaPrescelta()) {
				validaCampiDatiContabili();
			} else if (event.getSource() == getJComboBoxPeriodo()) {
				validateProspettoInBasePeriodo();
			}

		} catch (Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(
				this,
				"Errore durante l'operazione richiesta: \n" + e.getMessage(),
				"Errore",
				JOptionPane.ERROR_MESSAGE);
		}
	}

	/**
	 * @return
	 */
	private boolean checkAllParameter() {
		boolean checkIsOk = false;
		String message = "";
		
			

		if (this.jComboBoxUfficio.getSelectedIndex() == -1) {
			message = "Selezionare l'ufficio destinatario della dichiarazione";
		} else if (
			StringUtil.nullify(this.jTextFieldCognome.getText()) == null) {
			message = "Digitare il cognome";
		} else if (StringUtil.nullify(this.jTextFieldNome.getText()) == null) {
			message = "Digitare il nome";
		} else if (
			StringUtil.nullify(this.jTextFieldCodFiscale.getText()) == null) {
			message = "Digitare il codice fiscale";
		} else if (this.jTextFieldCodFiscale.getText().length() != 16) {
			message = "Codice fiscale 16 caratteri";
		} else if (this.jComboBoxNellaQualitaDi.getSelectedIndex() == -1) {
			message = "Selezionare la qualifica";
		} else if (
			this.jCheckBoxNazionale.isSelected()
				&& StringUtil.nullify(this.jTextFieldPartitaIva.getText())
					== null) {
			message = "Digitare la partita Iva (dati impresa)";
		} else if (
			this.jCheckBoxNazionale.isSelected()
				&& this.jTextFieldPartitaIva.getText().length() != 11) {
			message =
				"La Partita Iva dell'esercente nazionale deve essere di 11 caratteri (dati impresa)";
		} else if (
			StringUtil.nullify(this.jTextFieldDenominazione.getText())
				== null) {
			message = "Digitare la denominazione (dati impresa)";
		} else if (this.jComboBoxTipoEsercente.getSelectedIndex() == -1) {
			message = "Selezionare il tipo esercente";
		} else if (
			this.jCheckBoxNazionale.isSelected() == false
				&& this.jComboBoxComunatario.getSelectedIndex() == -1) {
			message = "Selezionare se l'esercente  nazionale o comunitario";
		} else if (
			this.jCheckBoxNazionale.isSelected() == true
				&& this.jComboBoxComunatario.getSelectedIndex() != -1) {
			message = "Selezionare se l'esercente  nazionale o comunitario";
			// se nazionale
		} else if (
			isNazionale()
				&& this.jComboBoxProvinciaSedeLegale.getSelectedIndex() == -1) {
			message = "Selezionare la provincia della sede legale";
		} else if (
			isNazionale()
				&& this.jComboBoxComuneSedeLegale.getSelectedIndex() == -1) {
			message = "Selezionare il comune della sede legale";
		} else if (
			isNazionale()
				&& StringUtil.nullify(
					this.jTextFieldIndirizzoSedeLegale.getText())
					== null) {
			message = "Digitare l'indirizzo della sede legale";
		} else if (
			isNazionale()
				&& this.jComboBoxProvinciaSedeAmm.getSelectedIndex() == -1) {
			message = "Selezionare la provincia della sede amministrativa";
		} else if (
			isNazionale()
				&& this.jComboBoxComuneSedeAmm.getSelectedIndex() == -1) {
			message = "Selezionare il comune della sede amministrativa";
		} else if (
			isNazionale()
				&& StringUtil.nullify(this.jTextFieldIndirizzoSedeAmm.getText())
					== null) {
			message = "Digitare l'indirizzo della sede amministrativa";
			// se comunitario
		} else if (
			!isNazionale()
				&& StringUtil.nullify(
					this.jTextFieldCittaPanelloComunitario.getText())
					== null) {
			message = "Digitare la citt della sede";
		} else if (
			!isNazionale()
				&& StringUtil.nullify(
					this.jTextFieldIndirizzoPannelloComunitario.getText())
					== null) {
			message = "Digitare l'indirizzo della sede";
		} else if (
			StringUtil.nullify(this.jTextFieldEstremiLicenza.getText())
				== null) {
			message = "Digitare estremi licenza/iscrizione albo/codice ident.";
		}  else if (!this.jCheckBoxEuroZero.isSelected()) {
			message = "E' obbligatorio selezionare dichiarazione veicoli euro 2 o inferiore";
		} else if (
			StringUtil.nullify(this.jTextFieldTOTLitriConsumati.getText())
				== null) {
			message = "Digitare il totale litri consumati";
		}
		if (StringUtil.nullify(message) == null) {
			checkIsOk = true;
		} else {
			JOptionPane.showMessageDialog(
				this,
				message,
				"Attenzione",
				JOptionPane.ERROR_MESSAGE);

		}		
		return checkIsOk;
	}

	private boolean isNazionale() {
		boolean isNazionale =
			this.jCheckBoxNazionale.isSelected() == true
				&& this.jComboBoxComunatario.getSelectedIndex() == -1;
		return isNazionale;
	}

	private void loadModelFromUI(ProspettoConsumo prospettoConsumo) {

		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		frontespizio.initArrayLitriImporti(getNumeroAliquote());//

		AbstractTipo ufficio =
			(AbstractTipo) this.jComboBoxUfficio.getSelectedItem();
		if (ufficio != null)
			frontespizio.setCodUffTecnicoFinanza(ufficio.getCodice());

		frontespizio.setCognomeRappresentanteDichiarazione(
			this.jTextFieldCognome.getText());
		frontespizio.setNomeRappresentanteDichiarazione(
			this.jTextFieldNome.getText());
		frontespizio.setCodicefiscaleRappresentanteDichiarazione(
			this.jTextFieldCodFiscale.getText());

		String qualifica =
			(String) this.jComboBoxNellaQualitaDi.getSelectedItem();
		if (qualifica != null) {
			frontespizio.setQualificaRappresentanteDichiarazione(qualifica);
		} else {
			frontespizio.setQualificaRappresentanteDichiarazione("");
		}
		frontespizio.setDenominazione(jTextFieldDenominazione.getText());
		frontespizio.setAnnoDic(new BigInteger(this.jTextFieldAnno.getText()));

		TipoPeriodo periodo =
			(TipoPeriodo) this.jComboBoxPeriodo.getSelectedItem();
		//frontespizio.setPeriodoCarbontax(new BigInteger(periodo.getCodicePeriodo()));

		frontespizio.setPartitaIva(this.jTextFieldPartitaIva.getText());

		if (jCheckBoxNazionale.isSelected()) {
			frontespizio.setEsercente("1");
			frontespizio.setComuneSedeLegale(
				jTextFieldCittaPanelloComunitario.getText());

			AbstractTipo provinceSedeLegale =
				(AbstractTipo) this
					.jComboBoxProvinciaSedeLegale
					.getSelectedItem();
			if (provinceSedeLegale != null)
				frontespizio.setProvinciaSedeLegale(
					provinceSedeLegale.getCodice());
			AbstractTipo comuneSedeLegale =
				(AbstractTipo) this.jComboBoxComuneSedeLegale.getSelectedItem();
			if (comuneSedeLegale != null)
				frontespizio.setComuneSedeLegale(
					comuneSedeLegale.getDescrizione());

			frontespizio.setIndirizzoSedeAmministrativa(
				jTextFieldIndirizzoSedeAmm.getText());
			frontespizio.setIndirizzoSedeLegale(
				jTextFieldIndirizzoSedeLegale.getText());

			AbstractTipo provinceSedeAmm =
				(AbstractTipo) this.jComboBoxProvinciaSedeAmm.getSelectedItem();
			if (provinceSedeAmm != null)
				frontespizio.setProvinciaSedeAmministrativa(
					provinceSedeAmm.getCodice());
			AbstractTipo comuneSedeAmm =
				(AbstractTipo) this.jComboBoxComuneSedeAmm.getSelectedItem();
			if (comuneSedeAmm != null)
				frontespizio.setComuneSedeAmministrativa(
					comuneSedeAmm.getDescrizione());

			AbstractTipo codAttivita =
				(AbstractTipo) this.jComboBoxCodAttivita.getSelectedItem();
			if (codAttivita != null)
				frontespizio.setCodiceAttivita(codAttivita.getCodice());

			if (jRadioButtonContoProprioAutoTraspMerci.isSelected()) {
				frontespizio.setAutoTrasportoMerci("1");
			} else if (jRadioButtonContoTerziAutoTraspMerci.isSelected()) {
				frontespizio.setAutoTrasportoMerci("2");
			}

		} else {
			frontespizio.setEsercente("2");
			AbstractTipo stato =
				(AbstractTipo) this.jComboBoxComunatario.getSelectedItem();
			if (stato != null) {
				frontespizio.setProvinciaSedeLegale(stato.getCodice());
			} else {
				frontespizio.setProvinciaSedeLegale("");
			}
			frontespizio.setProvinciaSedeAmministrativa("");
			frontespizio.setComuneSedeAmministrativa("");
			frontespizio.setIndirizzoSedeAmministrativa("");
			frontespizio.setCodiceAttivita("");
			frontespizio.setComuneSedeLegale(
				jTextFieldCittaPanelloComunitario.getText());
			frontespizio.setIndirizzoSedeLegale(
				jTextFieldIndirizzoPannelloComunitario.getText());
		}

		AbstractTipo tipoEsercente =
			(AbstractTipo) this.jComboBoxTipoEsercente.getSelectedItem();
		if (tipoEsercente != null)
			frontespizio.setTipoEsercente(
				new BigInteger(tipoEsercente.getCodice()));

		frontespizio.setEstremiLicenza(this.jTextFieldEstremiLicenza.getText());
		if (StringUtil.nullify(this.jTextFieldCertificatoImmatr.getText())
			== null)
			frontespizio.setAllegatiCertificatiImmatricolazione(
				BigInteger.valueOf(0));
		else
			frontespizio.setAllegatiCertificatiImmatricolazione(
				new BigInteger(this.jTextFieldCertificatoImmatr.getText()));

		if (StringUtil.nullify(this.jTextFieldTitoloPossesso.getText())
			== null)
			frontespizio.setAllegatiTitoliPossesso(BigInteger.valueOf(0));
		else
			frontespizio.setAllegatiTitoliPossesso(
				new BigInteger(this.jTextFieldTitoloPossesso.getText()));

		//INIZIO DATI CONTABILI

		// aggiunto reply
		/*String str = StringUtil.nullify(this.jTextFieldLitriConsumatiA1.getText());
		if (str == null)
			str = "0";
		frontespizio.setTotaleLitriConsumatiA1(new BigInteger(str));

		str = StringUtil.nullify(this.jTextFieldLitriConsumatiA2.getText());
		if (str == null)
			str = "0";
		frontespizio.setTotaleLitriConsumatiA2(new BigInteger(str));

		str = StringUtil.nullify(this.jTextFieldACreditoA1.getText());
		if (str == null)
			str = "0";
		frontespizio.setImportoAcreditoA1(new BigDecimal(str));

		str = StringUtil.nullify(this.jTextFieldACreditoA2.getText());
		if (str == null)
			str = "0";
		frontespizio.setImportoAcreditoA2(new BigDecimal(str));
		// fine
		*/

		String str = null;
		
		int totaleDatiContabili = 0;
		
		for (int i = 0; i < getNumeroAliquote(); i++) {
			
			JTextField litri = arrayLitriConsumati[i];
			JTextField importi = arrayImportoACredito[i];
			
					
			String strLitri = StringUtil.nullify(litri.getText());
			
			if(strLitri != null && !(strLitri.equals("") || strLitri.equals("0")))
				totaleDatiContabili++;
			
			if (strLitri == null)
				strLitri = "0";			
				
			frontespizio.setArrayLitriConsumati(i,new BigInteger(strLitri));
			
			String strImporti = StringUtil.nullify(importi.getText());
			if (strImporti == null) 
				strImporti = "0";
			frontespizio.setArrayImportoACredito(i,new BigDecimal(strImporti));
			
			
		}


		frontespizio.setNumeroTotaleDatiContabili(new BigInteger(""+totaleDatiContabili));

		str = StringUtil.nullify(this.jTextFieldTOTLitriConsumati.getText());
		if (str == null)
			str = "0";
		frontespizio.setTotaleLitriConsumati(new BigInteger(str));

		str = StringUtil.nullify(this.jTextFieldTOTACredito.getText());
		if (str == null)
			str = "0";
		frontespizio.setTotaleImportCredito(new BigDecimal(str));

		if (jRadioButtonModalitaPrescelta.isSelected()) {
			frontespizio.setModalitaFruizioneCredito("1");

		} 
//		else if (jRadioButtonCoordinateBancarieNaz.isSelected()) {
//			frontespizio.setModalitaFruizioneCredito("2");
//
//			str = StringUtil.nullify(this.jTextFieldCodABI.getText());
//			if (str == null)
//				str = "0";
//			frontespizio.setBancaABI(new BigInteger(str));
//
//			str = StringUtil.nullify(this.jTextFieldCodCAB.getText());
//			if (str == null)
//				str = "0";
//			frontespizio.setBancaCAB(new BigInteger(str));
//
//			frontespizio.setBancaContoCorrente(this.jTextFieldCCN.getText());
//
//		} else if (jRadioButtonCoordinatePostaliNaz.isSelected()) {
//			frontespizio.setModalitaFruizioneCredito("3");
//			frontespizio.setPostaContoCorrente(this.jTextFieldCCP.getText());
//
//		} 
		else if (jRadioButtonCoordinateBancarieEuropee.isSelected()) {
			frontespizio.setModalitaFruizioneCredito("4");
			frontespizio.setIBAN(this.jTextFieldIban.getText());
			frontespizio.setBIC(this.jTextFieldBIC.getText());

		}

		/* commentato reply
		if(jPanelOpzionePeriodo.isVisible()){
			if(jCheckBoxCarbonTaxPresentata.isSelected()){
				frontespizio.setPresentataProspettoCarbontaxStessoAnno("X");
			}
			
			frontespizio.setAnnoDic(BigInteger.valueOf(2004));
			frontespizio.setPartitaIva(jTextFieldPartitaIva.getText());
		
			str=StringUtil.nullify(this.jTextFieldLitriConsumatiMassaSup_INF.getText());
			if (str==null) str="0";
			frontespizio.setTotaleLitriConsumatiAutoveicoliMassaMassimaSupa3(new BigInteger(str));
		
			str=StringUtil.nullify(this.jTextFieldLitriConsumatiMassaInf.getText());
			if (str==null) str="0";
			frontespizio.setTotaleLitriConsumatiAutoveicoliMassaMassimaNonInf11(new BigInteger(str));
		
			str=StringUtil.nullify(this.jTextFieldImportoCreditoMassaSUP_INF.getText());
			if (str==null) str="0";
			frontespizio.setTotaleImportoCreditoAutoveicoliMassaMassima3(new BigDecimal(str));
		
			str=StringUtil.nullify(this.jTextFieldImportoCreditoiMassaInf11.getText());
			if (str==null) str="0";
			frontespizio.setTotaleImportoCreditoAutoveicoliMassaMassimaNonInf11(new BigDecimal(str));
		
			frontespizio.setValuta("E");
			BigInteger numeroSupportiDichiarazione = null;
			numeroSupportiDichiarazione = (frontespizio.getNumeroSupportiDichiarazione().add(BigInteger.valueOf(1)));
			frontespizio.setNumeroSupportiDichiarazione(numeroSupportiDichiarazione);				
		}
		*/

		if (jPanelComunitario.isVisible()) {
			AbstractTipo statoE =
				(AbstractTipo) jComboBoxComunatario.getSelectedItem();
			if (statoE != null)
				frontespizio.setComuneSedeLegale(statoE.getCodice());
			else
				frontespizio.setComuneSedeLegale("");

			frontespizio.setComuneSedeLegale(
				jTextFieldCittaPanelloComunitario.getText());
			frontespizio.setIndirizzoSedeLegale(
				jTextFieldIndirizzoPannelloComunitario.getText());
		}
		//modifica 27/08/2008 eliminare radio button Lire
		/*if (jRadioButtonLire.isSelected()) {
			frontespizio.setValuta("L");
		} else*/ if (jRadioButtonEuro.isSelected()) {
			frontespizio.setValuta("E");
		}

		frontespizio.setPeriodoDich(new BigInteger(""+AutotrasportatoriFrame.getNumeroPeriodo()));
		frontespizio.setFlagAllegatoQuadroBbis("0");
		//per ora fisso a zero (reply)
		
		if (jCheckBoxEuroZero.isSelected()) {
			frontespizio.setEuroZero("A");
		}
		
	}

	private void doSave(boolean saveAs) {
		loadModelFromUI(prospettoConsumo);
		boolean boolTotale = getJTextFieldTOTLitriConsumati().getText().trim().equals("0")
							|| getJTextFieldTOTLitriConsumati().getText().trim().equals("");
		
		if(boolTotale) {
			JOptionPane.showMessageDialog(
				this,
				" Inserire almeno i dati relativi ad una aliquota. ",
				"Attenzione",
				JOptionPane.WARNING_MESSAGE);
		} 
		else {

			List listaQuadroA = prospettoConsumo.getListaQuadro(Quadro.QUADRO_A, null);
			
			ArrayList<String> listaQuadriACompilati = new ArrayList<String>(); 
			
			if(listaQuadroA.size()!=0){
				
				for (int i=0; i<listaQuadroA.size(); i++){
					if (listaQuadroA.get(i) != null && listaQuadroA.get(i) instanceof AutotrasportatoriQuadroA){
						AutotrasportatoriQuadroA quadroA = (AutotrasportatoriQuadroA)listaQuadroA.get(i);
						listaQuadriACompilati.add(quadroA.getTipoQuadroA());
					}
				}
				
				boolean checkLitriA = false;
				List<String> warning = new ArrayList<String>();
				List<String> error = new ArrayList<String>();
				
				int contatore = 0;
				
				for (int i = 0; i < getNumeroAliquote(); i++) {
					JTextField importo = arrayImportoACredito[i];
					JTextField litri = arrayLitriConsumati[i];
					
					if (!litri.getText().equals("0")) {
						if (!listaQuadriACompilati.contains(""+(i+1))){
							error.add(new String("A"+(i+1)));	
						}
					}
					
					checkLitriA = checkTotLitriA(prospettoConsumo,i,importo,litri);
					
					if (!checkLitriA) {					
						contatore = i;					
						warning.add(new String("A"+(++contatore)));	
					}
				}
				
				if (error.isEmpty()) {
				
					for (int i = 0; i < warning.size(); i++) {
						JOptionPane.showMessageDialog(
							this,
							"Il \"Totale Litri\" e/o il \"Totale importo digitato\" sono differenti da quelli calcolati su quadro "+warning.get(i) ,
							"Attenzione",
							JOptionPane.WARNING_MESSAGE);
					}			
		
					boolean checkTotali = checkTotali(prospettoConsumo);
					if (!checkTotali) {
						JOptionPane.showMessageDialog(
							this,
							"Il \"Totale Litri\" e/o il \"Totale importo digitato\" sono differenti dalla somma di quelli relativi ai periodi",
							"Attenzione",
							JOptionPane.WARNING_MESSAGE);
					}
			
			//modifica 27/08/2008 inserimento controllo modalit fruizione credito
//			if (jRadioButtonCoordinateBancarieNaz.isSelected()){
//				
//				if((StringUtil.nullify(this.jTextFieldCodABI.getText())== null || jTextFieldCodABI.getText().equals("0")) ||
//				(StringUtil.nullify(this.jTextFieldCodCAB.getText())== null || jTextFieldCodCAB.getText().equals("0")) ||
//				(StringUtil.nullify(this.jTextFieldCCN.getText())== null || jTextFieldCCN.getText().equals("0"))){
//					JOptionPane.showMessageDialog(
//						this,
//						"Inserire Coordinate Bancarie Nazionali valide.",
//						"Attenzione",JOptionPane.WARNING_MESSAGE);
//					return; 
//				}
//			}
//			if (jRadioButtonCoordinatePostaliNaz.isSelected() && 
//				(StringUtil.nullify(this.jTextFieldCCP.getText())== null ||  
//				this.jTextFieldCCP.getText().equals("0"))) {
//				JOptionPane.showMessageDialog(
//					this,
//					"Inserire Coordinate Postali Nazionali valide",
//					"Attenzione",JOptionPane.WARNING_MESSAGE);
//				return;
//			}
					if (jRadioButtonCoordinateBancarieEuropee.isSelected() && 
						  (StringUtil.nullify(this.jTextFieldIban.getText()) == null 
								  || this.jTextFieldIban.getText().trim().equals("") 
								  || this.jTextFieldIban.getText().trim().equals("0") 
						   ) 
						) {
						JOptionPane.showMessageDialog(
							this,
							"Inserire Coordinate Bancarie Europee valide.",
							"Attenzione",JOptionPane.WARNING_MESSAGE);
						return;
					}
					if (!saveAs) {
						GestoreEventi.saveProspect(this, prospettoConsumo);
					}
					else {
						if (GestoreEventi.saveAsProspect(this, prospettoConsumo)) {
							this.setTitle(
								prospettoConsumo.getResourceAccess().getFileName());
						}
					}
				}
				else {
					for (int i = 0; i < error.size(); i++) {
						JOptionPane.showMessageDialog(
							this,
							"Obbligatorio compilare il quadro "+error.get(i) ,
							"Attenzione",
							JOptionPane.ERROR_MESSAGE);
					}			
				}
			}
			else{
				JOptionPane.showMessageDialog(
					this,
					"Obbligatorio compilare il quadro A",
					"Attenzione",
					JOptionPane.ERROR_MESSAGE);
			}
		}
	}

	
	// nuovo reply
	private boolean checkTotLitriA1(ProspettoConsumo prospettoConsumo) {

		boolean areEquals = false;
		List listaQuadro =
			prospettoConsumo.getListaQuadroA(Quadro.TIPO_QUADRO_A1);

		// calcolo il totale dei litri e degli importi
		Iterator i = listaQuadro.iterator();
		BigInteger totaleLitri = BigInteger.valueOf(0);
		BigDecimal totaleCredito = BigDecimal.valueOf(0);
		while (i.hasNext()) {
			AutotrasportatoriQuadroA record =
				(AutotrasportatoriQuadroA) i.next();
			totaleLitri = totaleLitri.add(record.getLitriConsumati());
			totaleCredito = totaleCredito.add(record.getImporto());
		}

		BigDecimal totaleCreditoRound =
			totaleCredito.setScale(0, BigDecimal.ROUND_HALF_UP);
		BigDecimal tOTACreditoRound = null;
		if (StringUtil.nullify(getJTextFieldACreditoA1().getText()) != null)
			tOTACreditoRound =
				(new BigDecimal(getJTextFieldACreditoA1().getText())).setScale(
					0,
					BigDecimal.ROUND_HALF_UP);
		else
			tOTACreditoRound =
				(new BigDecimal("0")).setScale(0, BigDecimal.ROUND_HALF_UP);

		if (StringUtil.nullify(getJTextFieldLitriConsumatiA1().getText())
			!= null
			&& totaleLitri.equals(
				new BigInteger(getJTextFieldLitriConsumatiA1().getText()))
			&& totaleCreditoRound.equals(tOTACreditoRound)) {
			areEquals = true;
		}
		return areEquals;
	}

	// nuovo reply
	private boolean checkTotLitriA(ProspettoConsumo prospettoConsumo,int quadro,JTextField importo,JTextField litri ) {

		boolean areEquals = false;
		
		
		
			List listaQuadro =
				prospettoConsumo.getListaQuadroA(Quadro.getTipoQuadroA(quadro));
			
			
	
			// calcolo il totale dei litri e degli importi
			Iterator i = listaQuadro.iterator();
			BigInteger totaleLitri = BigInteger.valueOf(0);
			BigDecimal totaleCredito = BigDecimal.valueOf(0);
			while (i.hasNext()) {
				AutotrasportatoriQuadroA record =
					(AutotrasportatoriQuadroA) i.next();
				totaleLitri = totaleLitri.add(record.getLitriConsumati());
				totaleCredito = totaleCredito.add(record.getImporto());
			}
	
			BigDecimal totaleCreditoRound =
				totaleCredito.setScale(0, BigDecimal.ROUND_HALF_UP);
				
			BigDecimal tOTACreditoRound = null;
			if (StringUtil.nullify(importo.getText()) != null)
				tOTACreditoRound =
					(new BigDecimal(importo.getText())).setScale(
						0,
						BigDecimal.ROUND_HALF_UP);
			else
				tOTACreditoRound =
					(new BigDecimal("0")).setScale(0, BigDecimal.ROUND_HALF_UP);
	
			if (StringUtil.nullify(litri.getText())
				!= null
				&& totaleLitri.equals(
					new BigInteger(litri.getText()))
				&& totaleCreditoRound.equals(tOTACreditoRound)) {
				areEquals = true;
			}
		
		
		return areEquals;
	}

	// nuovo reply
	private boolean checkTotali(ProspettoConsumo prospettoConsumo) {

		boolean controllo = false;

		// calcolo il totale dei litri e degli importi
		
		/*

		BigInteger totaleLitriCalcolati =
			new BigInteger(getJTextFieldLitriConsumatiA1().getText()).add(
				new BigInteger(getJTextFieldLitriConsumatiA2().getText()));
		BigDecimal totaleCreditoCalcolati =
			new BigDecimal(getJTextFieldACreditoA1().getText()).add(
				new BigDecimal(getJTextFieldACreditoA2().getText()));*/
				
						
				
		BigInteger totaleLitriCalcolati = new BigInteger("0");
		BigDecimal totaleCreditoCalcolati =	new BigDecimal("0");
		
		for (int i = 0; i < getNumeroAliquote(); i++) {
			
			JTextField litri = arrayLitriConsumati[i];
			JTextField importi = arrayImportoACredito[i];
			String strLitri = litri.getText().trim();
			String strImporti = importi.getText().trim();
			if(strLitri == null || strLitri.trim().equals(""))
				strLitri ="0";
			if(strImporti == null || strImporti.trim().equals(""))
				strImporti ="0";	
			
			totaleLitriCalcolati = new BigInteger(totaleLitriCalcolati.toString()).add(new BigInteger(strLitri));
			totaleCreditoCalcolati = new BigDecimal(totaleCreditoCalcolati.toString()).add(new BigDecimal(strImporti));
		}	
				

		BigInteger totaleLitriInseriti =
			new BigInteger(getJTextFieldTOTLitriConsumati().getText());
		BigDecimal totaleCreditoInseriti =
			new BigDecimal(getJTextFieldTOTACredito().getText());

		if (totaleLitriCalcolati.compareTo(totaleLitriInseriti) == 0
			&& totaleCreditoCalcolati.compareTo(totaleCreditoInseriti) == 0)
			controllo = true;

		return controllo;

	}

	private void doSaveAs(String fileName) {
		boolean saved = false;
		saved = GestoreEventi.saveAsProspect(this, prospettoConsumo, fileName);
		if (saved) {
			this.setTitle(prospettoConsumo.getResourceAccess().getFileName());
		}
	}

	private void doPrint() {
		if (checkAllParameter()){
			loadModelFromUI(prospettoConsumo);
			new PdfProspectWriter().print(jListListaQuadri, this, prospettoConsumo);
		}
		
	}

	public void mouseClicked(MouseEvent event) {
		try {
			Frontespizio frontespizio = prospettoConsumo.getFrontespizio();

			if (event.getSource() == jListListaQuadri) {
				
				if (event.getClickCount() == 2) {
					loadModelFromUI(prospettoConsumo);
					//-----
					//- Richiesta : oscurare questo controllo. Aggiungo FALSE in testa, al momento. 
					if (false && StringUtil.nullify(frontespizio.getCodiceAttivita())
						== null) {
						JOptionPane.showMessageDialog(
							this,
							"Inserire Codice Accisa");
					} else {
						mostraQuadro();
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(
				this,
				"Errore durante l'operazione richiesta: \n" + e.getMessage(),
				"Errore",
				JOptionPane.ERROR_MESSAGE);
		}
	}

	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
	}
	public void mousePressed(MouseEvent e) {
	}
	public void mouseReleased(MouseEvent e) {
	}

	private void updateComboDic() {
		AbstractTipo tipo =
			(AbstractTipo) jComboBoxProvinciaSedeLegale.getSelectedItem();
		if (tipo == null) {
			tipo = (AbstractTipo) jComboBoxProvinciaSedeLegale.getItemAt(0);
		}
		ComboUtil.setValues(
			jComboBoxComuneSedeLegale,
			ComboDataSource.getInstance().getComuni(tipo.getCodice()));
	}

	private void updateComboUffAm() {
		AbstractTipo tipo =
			(AbstractTipo) jComboBoxProvinciaSedeAmm.getSelectedItem();
		if (tipo == null) {
			tipo = (AbstractTipo) jComboBoxProvinciaSedeAmm.getItemAt(0);
		}
		ComboUtil.setValues(
			jComboBoxComuneSedeAmm,
			ComboDataSource.getInstance().getComuni(tipo.getCodice()));
	}

	private void sendFile() {
		setSendActionMode(true);

		ProspettoConsumo prospettoAperto = GestoreEventi.openProspect(this);
		if (prospettoAperto != null) {
			prospettoConsumo = prospettoAperto;

			doSaveAs(
				prospettoConsumo.getFrontespizio().getCodiceAttivita()
					+ "_"
					+ prospettoConsumo.getFrontespizio().getAnnoDic()
					+ ".dic");
		}
	}
	public boolean isSendActionMode() {
		return sendActionMode;
	}

	public void setSendActionMode(boolean sendMode) {
		sendActionMode = sendMode;
	}

	private void doOpenInterchageSession() {
		AutotrasportatoriInterchangeDialog dialogInterchange =
			new AutotrasportatoriInterchangeDialog(this);
		dialogInterchange.setVisible(true);
	}

	private void mostraQuadro() {
		Quadro quadro = (Quadro) jListListaQuadri.getSelectedValue();
		if (quadro != null) {
			quadro.setProspect(prospettoConsumo);
			quadro.showDialog(this);
		}
	}

	private void doOpen() {

		ProspettoConsumo prospettoAperto = GestoreEventi.openProspect(this);
		if (prospettoAperto != null) {
			prospettoConsumo = prospettoAperto;
			setWorkPanel();
			loadUIFromModel(prospettoConsumo);
		}
		
		//MAC 28/05/2012 - MAC APERTURA DICHIARAZIONI ANNI PRECEDENTI
		if (prospettoConsumo.getFrontespizio().isPeriodoDiverso()) {
			JOptionPane.showMessageDialog(
					this,
					"La dichiarazione aperta  di un periodo diverso.\n " +
					"I dati eventualmente presenti nei Quadri se non confermati NON verranno salvati",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
			
			
		}

	}

	private void loadUIFromModel(ProspettoConsumo prospettoConsumo) {

		this.setTitle(prospettoConsumo.getResourceAccess().getFileName());
		
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		jComboBoxComuneSedeLegale.removeActionListener(this);
		jComboBoxComuneSedeAmm.removeActionListener(this);
		jComboBoxProvinciaSedeLegale.removeActionListener(this);
		jComboBoxProvinciaSedeAmm.removeActionListener(this);
		jTextFieldIndirizzoPannelloComunitario.setText(
			frontespizio.getIndirizzoSedeLegale());

		//INIZIO DATI IMPRESA

		jTextFieldAnno.setText(getAnnoRiferimento());
		jTextFieldCognome.setText(
			"" + frontespizio.getCognomeRappresentanteDichiarazione());
		jTextFieldNome.setText(
			frontespizio.getNomeRappresentanteDichiarazione());
		jTextFieldCodFiscale.setText(
			frontespizio.getCodicefiscaleRappresentanteDichiarazione());
		jTextFieldPartitaIva.setText(frontespizio.getPartitaIva());

		if (frontespizio.getEsercente().equals("1")) {
			jCheckBoxNazionale.setSelected(true);
			validateProspettoNazionale();
		} else {
			validateProspettoComunitario();
			jTextFieldCittaPanelloComunitario.setText(
				frontespizio.getComuneSedeLegale());
			ComboUtil.setValues(
				jComboBoxProvinciaSedeLegale,
				ComboDataSource.getInstance().getProvince());
			AbstractTipo provSedeLegale =
				(AbstractTipo) jComboBoxProvinciaSedeLegale.getSelectedItem();
			ComboUtil.setValues(
				jComboBoxComuneSedeLegale,
				ComboDataSource.getInstance().getComuni(
					provSedeLegale.getCodice()));
			ComboUtil.setValues(
				jComboBoxProvinciaSedeAmm,
				ComboDataSource.getInstance().getProvince());
			AbstractTipo provSedeAmm =
				(AbstractTipo) jComboBoxProvinciaSedeAmm.getSelectedItem();
			ComboUtil.setValues(
				jComboBoxComuneSedeAmm,
				ComboDataSource.getInstance().getComuni(
					provSedeAmm.getCodice()));

		}
		jTextFieldDenominazione.setText(frontespizio.getDenominazione());
		jTextFieldIndirizzoSedeLegale.setText(
			frontespizio.getIndirizzoSedeLegale());
		jTextFieldIndirizzoSedeAmm.setText(
			frontespizio.getIndirizzoSedeAmministrativa());

		if (frontespizio.getAutoTrasportoMerci().equals("1")) {
			jRadioButtonContoProprioAutoTraspMerci.setSelected(true);
		} else if (frontespizio.getAutoTrasportoMerci().equals("2")) {
			jRadioButtonContoTerziAutoTraspMerci.setSelected(true);
		}
		jTextFieldEstremiLicenza.setText(frontespizio.getEstremiLicenza());
		jTextFieldCertificatoImmatr.setText(
			String.valueOf(
				frontespizio
					.getAllegatiCertificatiImmatricolazione()
					.intValue()));
		jTextFieldTitoloPossesso.setText(
			String.valueOf(
				frontespizio.getAllegatiTitoliPossesso().intValue()));

		ComboUtil.setValues(
			jComboBoxUfficio,
			ComboDataSource.getInstance().getUffici());
		jComboBoxUfficio.setSelectedItem(
			ComboDataSource.getInstance().getUfficio(
				frontespizio.getCodUffTecnicoFinanza()));
		//preparo lista periodi con un solo valore

		List periodi = new LinkedList();
		periodi.add(
				//"A"
			TipoPeriodoFacade.getPeriodo(frontespizio.getAnnoDic(),"A",true)
//			ComboDataSource.getInstance().getPeriodo(
//				frontespizio.getAnnoDic(),
//				frontespizio.getPeriodoCarbontax())
				);
		ComboUtil.setValues(jComboBoxPeriodo, periodi);
		if (frontespizio.getPeriodoCarbontax().equals(BigInteger.valueOf(7))) {
			jPanelOpzionePeriodo.setVisible(true);

		}
		//jComboBoxPeriodo.setSelectedItem(ComboDataSource.getInstance().getPeriodo(frontespizio.getPeriodoCarbontax()));

		ComboUtil.setValues(
			jComboBoxNellaQualitaDi,
			ComboDataSource.getInstance().getQualificheDichiarante());
		if (frontespizio
			.getQualificaRappresentanteDichiarazione()
			.equals("")) {
			jComboBoxNellaQualitaDi.setSelectedIndex(-1);
		} else {

			jComboBoxNellaQualitaDi.setSelectedItem(
				frontespizio.getQualificaRappresentanteDichiarazione());
		}

		ComboUtil.setValues(
			jComboBoxTipoEsercente,
			ComboDataSource.getInstance().getEsercenti());
		jComboBoxTipoEsercente.setSelectedItem(
			ComboDataSource.getInstance().getEsercente(
				frontespizio.getTipoEsercente()));

		ComboUtil.setValues(
			jComboBoxCodAttivita,
			ComboDataSource.getInstance().getAttivitaLista());
		jComboBoxCodAttivita.setSelectedItem(
			ComboDataSource.getInstance().getAttivita(
				frontespizio.getCodiceAttivita()));

		ComboUtil.setValues(
			jComboBoxComunatario,
			ComboDataSource.getInstance().getStati());
		jComboBoxComunatario.setSelectedIndex(-1);

		if (jCheckBoxNazionale.isSelected()) {
			ComboUtil.setValues(
				jComboBoxProvinciaSedeLegale,
				ComboDataSource.getInstance().getProvince());
			jComboBoxProvinciaSedeLegale.setSelectedItem(
				ComboDataSource.getInstance().getProvincia(
					frontespizio.getProvinciaSedeLegale()));

			ComboUtil.setValues(
				jComboBoxComuneSedeLegale,
				ComboDataSource.getInstance().getComuni(
					frontespizio.getProvinciaSedeLegale()));
			jComboBoxComuneSedeLegale.setSelectedItem(
				ComboDataSource.getInstance().getComunePerDescrizione(
					frontespizio.getProvinciaSedeLegale(),
					frontespizio.getComuneSedeLegale()));

			ComboUtil.setValues(
				jComboBoxProvinciaSedeAmm,
				ComboDataSource.getInstance().getProvince());
			jComboBoxProvinciaSedeAmm.setSelectedItem(
				ComboDataSource.getInstance().getProvincia(
					frontespizio.getProvinciaSedeAmministrativa()));

			ComboUtil.setValues(
				jComboBoxComuneSedeAmm,
				ComboDataSource.getInstance().getComuni(
					frontespizio.getProvinciaSedeAmministrativa()));
			jComboBoxComuneSedeAmm.setSelectedItem(
				ComboDataSource.getInstance().getComunePerDescrizione(
					frontespizio.getProvinciaSedeAmministrativa(),
					frontespizio.getComuneSedeAmministrativa()));

		} else {
			jComboBoxComunatario.setSelectedItem(
				ComboDataSource.getInstance().getStato(
					frontespizio.getProvinciaSedeLegale()));
			jTextFieldIndirizzoPannelloComunitario.setText(
				frontespizio.getIndirizzoSedeLegale());
		}
		//		FINE DATI IMPRESA

		//		INIZIO DATI CONTABILI

		//if (frontespizio.getAnnoDic().toString().equals(VisualConfig.ANNO_DI_RIFERIMENTO)) {
			jTextFieldTOTLitriConsumati.setText(String.valueOf(frontespizio.getTotaleLitriConsumati().intValue()));
			jTextFieldTOTACredito.setText(String.valueOf(frontespizio.getTotaleImportCredito()));
		/*} else {
			jTextFieldTOTLitriConsumati.setText("0");
			jTextFieldTOTACredito.setText("0");
		}*/
		//modifica 27/08/2008 eliminare radio button Lire
		/*if (frontespizio.getValuta().equals("L")) {
			jRadioButtonLire.setSelected(true);
		} else*/ if (frontespizio.getValuta().equals("E")) {
			jRadioButtonEuro.setSelected(true);
		}
		
		
		if (frontespizio.getEuroZero().equals("A")) {
			jCheckBoxEuroZero.setSelected(true);
		}


		if (frontespizio.getModalitaFruizioneCredito().equals("1")) {
			jRadioButtonModalitaPrescelta.setSelected(true);
		} 
//		else if (frontespizio.getModalitaFruizioneCredito().equals("2")) {
//			jRadioButtonCoordinateBancarieNaz.setSelected(true);
//		} else if (frontespizio.getModalitaFruizioneCredito().equals("3")) {
//			jRadioButtonCoordinatePostaliNaz.setSelected(true);
//		} 
		else if (frontespizio.getModalitaFruizioneCredito().equals("4")) {
			jRadioButtonCoordinateBancarieEuropee.setSelected(true);
		}
//		if (jRadioButtonCoordinateBancarieNaz.isSelected()) {
//			jTextFieldCodABI.setText(
//				String.valueOf(frontespizio.getBancaABI().intValue()));
//			jTextFieldCodCAB.setText(
//				String.valueOf(frontespizio.getBancaCAB().intValue()));
//			jTextFieldCCN.setText(frontespizio.getBancaContoCorrente());
//		}
//		if (jRadioButtonCoordinatePostaliNaz.isSelected()) {
//			jTextFieldCCP.setText(frontespizio.getPostaContoCorrente());
//		}
		if (jRadioButtonCoordinateBancarieEuropee.isSelected()) {
			jTextFieldIban.setText(frontespizio.getIBAN());
			jTextFieldBIC.setText(frontespizio.getBIC());

		}
		
		/*
		// modica per i nuovi campi reply
		jTextFieldLitriConsumatiA1.setText(
			String.valueOf(frontespizio.getTotaleLitriConsumatiA1()));
		jTextFieldLitriConsumatiA2.setText(
			String.valueOf(frontespizio.getTotaleLitriConsumatiA2()));
		jTextFieldACreditoA1.setText(
			String.valueOf(frontespizio.getImportoAcreditoA1()));
		jTextFieldACreditoA2.setText(
			String.valueOf(frontespizio.getImportoAcreditoA2()));
		// fine
		*/
		
		List lDatiContabili = prospettoConsumo.getListaDatiContabili();
		List listDatiContabili = Risorse.getInstance().getListDatiContabili();//da Periodi.TXT
		
		int lenDatiContabili = lDatiContabili.size();			
		int listSize = listDatiContabili.size();//da Periodi.TXT
		
		//MAC 28/05/2012 - MAC APERTURA DICHIARAZIONI ANNI PRECEDENTI
		int len = (lenDatiContabili < listSize ? lenDatiContabili : listSize);
		
		for (int i = 0; i < len; i++) {
			
			DatiContabiliRecord record = (DatiContabiliRecord) lDatiContabili.get(i);
			int riga = record.getProgressivoRiga().intValue()-1;
			
			JTextField litri = arrayLitriConsumati[riga];
			JTextField importi = arrayImportoACredito[riga];
			
			litri.setText(String.valueOf(record.getTotaleLitri()));
			importi.setText(String.valueOf(record.getTotaleImportoCredito()));
		}
		

		//FINE DATI CONTABILI

		jComboBoxComuneSedeLegale.addActionListener(this);
		jComboBoxComuneSedeAmm.addActionListener(this);
		jComboBoxProvinciaSedeLegale.addActionListener(this);
		jComboBoxProvinciaSedeAmm.addActionListener(this);

		setQuadri(prospettoConsumo);
		validate();
		//updateListaQuadri();
		validaCampiDatiContabili();
		
		//MAC 28/05/2012 - MAC APERTURA DICHIARAZIONI ANNI PRECEDENTI
		boolean isPeriodoDiverso = frontespizio.isPeriodoDiverso();
		if (isPeriodoDiverso) {
			jButtonSave.setEnabled(false);
		} else {
			jButtonSave.setEnabled(true);
		}

	}

	public void focusGained(FocusEvent event) {
		if (event.getSource() == getJComboBoxComunatario()) {
			validateProspettoComunitario();
		}
	}

	/**
	 * 
	 */
	private void validateProspettoInBasePeriodo() {

		TipoPeriodo tipo = (TipoPeriodo) jComboBoxPeriodo.getSelectedItem();
		if (tipo == null) {
			tipo = (TipoPeriodo) jComboBoxPeriodo.getItemAt(0);
		} else if (tipo.getCodicePeriodo().equals("7")) {
			jPanelOpzionePeriodo.setVisible(true);
		} else
			jPanelOpzionePeriodo.setVisible(false);

	}
	/**
	* 
	*/
	private void validateProspettoNazionale() {

		jPanelComunitario.setVisible(false);

		jPanel6.setVisible(true);
		jPanel31.setVisible(true);

		jLabel10.setVisible(true);
		jComboBoxCodAttivita.setVisible(true);
		jRadioButtonContoTerziAutoTraspMerci.setVisible(true);
		jRadioButtonContoProprioAutoTraspMerci.setVisible(true);
		jLabel23.setVisible(true);
		jLabel22.setVisible(true);
		jComboBoxComunatario.setSelectedIndex(-1);

		/*Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		ComboUtil.setValues(jComboBoxProvinciaSedeLegale,ComboDataSource.getInstance().getProvince());	
		AbstractTipo provSedeLegale = (AbstractTipo)jComboBoxProvinciaSedeLegale.getSelectedItem();
		ComboUtil.setValues(jComboBoxComuneSedeLegale,ComboDataSource.getInstance().getComuni(provSedeLegale.getCodice()));
		ComboUtil.setValues(jComboBoxProvinciaSedeAmm,ComboDataSource.getInstance().getProvince());
		AbstractTipo provSedeAmm = (AbstractTipo)jComboBoxProvinciaSedeAmm.getSelectedItem();
		ComboUtil.setValues(jComboBoxComuneSedeAmm,	ComboDataSource.getInstance().getComuni(provSedeAmm.getCodice()));
		*/

	}
	/**
	 * 
	 */
	private void validateProspettoComunitario() {
		jPanelComunitario.setVisible(true);

		jPanel6.setVisible(false);
		jPanel31.setVisible(false);
		jComboBoxCodAttivita.setVisible(false);
		jRadioButtonContoTerziAutoTraspMerci.setVisible(false);
		jRadioButtonContoProprioAutoTraspMerci.setVisible(false);
		jLabel23.setVisible(false);
		jLabel22.setVisible(false);
		jCheckBoxNazionale.setSelected(false);

	}

	private void clearUIProspettoNazionale() {
		jComboBoxProvinciaSedeLegale.setSelectedIndex(-1);
		jComboBoxComuneSedeLegale.setSelectedIndex(-1);
		jTextFieldIndirizzoSedeLegale.setText("");
		jComboBoxProvinciaSedeAmm.setSelectedItem("");
		jComboBoxComuneSedeAmm.setSelectedItem("");
		jTextFieldIndirizzoSedeAmm.setText("");

	}

	private void clearUIProspettoComunitario() {

		jTextFieldCittaPanelloComunitario.setText("");
		jTextFieldIndirizzoPannelloComunitario.setText("");

	}

	private void clearUI() {
		this.setTitle("");
		jComboBoxComuneSedeLegale.removeActionListener(this);
		jComboBoxComuneSedeAmm.removeActionListener(this);
		jComboBoxProvinciaSedeLegale.removeActionListener(this);
		jComboBoxProvinciaSedeAmm.removeActionListener(this);

		clearUIProspettoNazionale();
		clearUIProspettoComunitario();

		jTextFieldAnno.setText(getAnnoRiferimento());

		jTextFieldCognome.setText("");
		jTextFieldNome.setText("");
		jTextFieldPartitaIva.setText("");
		jTextFieldCodFiscale.setText("");
		jTextFieldEstremiLicenza.setText("");
		jTextFieldCertificatoImmatr.setText("");
		jTextFieldTitoloPossesso.setText("");
		// aggiunti reply
		/*jTextFieldACreditoA1.setText("0");
		jTextFieldACreditoA2.setText("0");
		jTextFieldLitriConsumatiA1.setText("0");
		jTextFieldLitriConsumatiA2.setText("0");*///fine
		
		//azzeriamo i textfield relativi ai litri consumati e all'importo a credito
		for (int i = 0; i < arrayLitriConsumati.length; i++) {
			//arrayLitriConsumati e arrayImportoACredito hanno la stessa lunghezza		
			arrayLitriConsumati[i].setText("0");
			arrayImportoACredito[i].setText("0");
		} 
		
		
		jTextFieldTOTLitriConsumati.setText("0");
		jTextFieldTOTACredito.setText("0");
		jTextFieldBIC.setText("");
		jTextFieldCCN.setText("");
		jTextFieldCCP.setText("");
		jTextFieldCittaPanelloComunitario.setText("");
		jTextFieldCodABI.setText("");
		jTextFieldCodCAB.setText("");
		jTextFieldDenominazione.setText("");
		jTextFieldIban.setText("");
		//jTextFieldImportoCreditoiMassaInf11.setText("");
		//jTextFieldImportoCreditoMassaSUP_INF.setText("");
		jTextFieldIndirizzoPannelloComunitario.setText("");
		jTextFieldIndirizzoSedeAmm.setText("");
		jTextFieldIndirizzoSedeLegale.setText("");
		//jTextFieldLitriConsumatiMassaInf.setText("");
		//jTextFieldLitriConsumatiMassaSup_INF.setText("");
		jTextFieldTOTACredito.setText("");
		jTextFieldTitoloPossesso.setText("");
		jTextFieldTOTLitriConsumati.setText("");

		jComboBoxPeriodo.setSelectedIndex(-1);
		jRadioButtonContoProprioAutoTraspMerci.setSelected(true);
		jRadioButtonModalitaPrescelta.setSelected(true);

		ComboUtil.setValues(
			jComboBoxComunatario,
			ComboDataSource.getInstance().getStati());
		jComboBoxComunatario.setSelectedIndex(-1);

		ComboUtil.setValues(
			jComboBoxUfficio,
			ComboDataSource.getInstance().getUffici());
		jComboBoxUfficio.setSelectedIndex(-1);

		/*ComboUtil.setValues(
			jComboBoxPeriodo,
			ComboDataSource.getInstance().getPeriodi(
				BigInteger.valueOf(VisualConfig.ANNO_DI_RIFERIMENTO_LONG)));*/
		/**
		Iterator it=ComboDataSource.getInstance().getPeriodi().iterator();
		while (it.hasNext()){
			String desc=((TipoPeriodo)it.next()).getDescrizione();
			setToolTipText(desc);
		}
		**/
		ComboUtil.setValues(
			jComboBoxNellaQualitaDi,
			ComboDataSource.getInstance().getQualificheDichiarante());
		jComboBoxNellaQualitaDi.setSelectedIndex(-1);

		ComboUtil.setValues(
			jComboBoxTipoEsercente,
			ComboDataSource.getInstance().getEsercenti());
		jComboBoxTipoEsercente.setSelectedIndex(-1);

		ComboUtil.setValues(
			jComboBoxCodAttivita,
			ComboDataSource.getInstance().getAttivitaLista());
		//jComboBoxCodAttivita.setSelectedItem(
		//	ComboDataSource.getInstance().getAttivita("60240"));
		jComboBoxCodAttivita.setSelectedIndex(643);

		ComboUtil.setValues(
			jComboBoxProvinciaSedeLegale,
			ComboDataSource.getInstance().getProvince());
		String codiceProvincia =
			((TipoProvincia) jComboBoxProvinciaSedeLegale.getSelectedItem())
				.getCodice();
		ComboUtil.setValues(
			jComboBoxComuneSedeLegale,
			ComboDataSource.getInstance().getComuni(codiceProvincia));

		ComboUtil.setValues(
			jComboBoxProvinciaSedeAmm,
			ComboDataSource.getInstance().getProvince());
		codiceProvincia =
			((TipoProvincia) jComboBoxProvinciaSedeAmm.getSelectedItem())
				.getCodice();
		ComboUtil.setValues(
			jComboBoxComuneSedeAmm,
			ComboDataSource.getInstance().getComuni(codiceProvincia));

		jComboBoxComuneSedeAmm.setSelectedIndex(-1);
		jComboBoxComuneSedeLegale.setSelectedIndex(-1);
		jComboBoxProvinciaSedeAmm.setSelectedIndex(-1);
		jComboBoxProvinciaSedeLegale.setSelectedIndex(-1);

		jComboBoxComuneSedeAmm.addActionListener(this);
		jComboBoxComuneSedeLegale.addActionListener(this);
		jComboBoxProvinciaSedeAmm.addActionListener(this);
		jComboBoxProvinciaSedeLegale.addActionListener(this);

		initQuadri();

		jCheckBoxNazionale.setSelected(true);
		
		jCheckBoxEuroZero.setSelected(false);
		validateProspettoNazionale();
	}

	/**
	* This is here to fix the swing bug. Setting a tooltip on the JComboBox
	* doesn't work as expected.
	*/
	public void setToolTipText(String text) {
		Component[] c = jComboBoxPeriodo.getComponents();
		for (int k = 0; k < c.length; k++) {
			if (c[k] instanceof JComponent) {
				((JComponent) c[k]).setToolTipText(text);
			}
		}
	}

	public void focusLost(FocusEvent event) {

		try {
			
			Object sourceEvent = event.getSource();
			
			for (int i = 0; i < arrayImportoACredito.length; i++) {
				
				JTextField litri = arrayLitriConsumati[i];
				JTextField importi = arrayImportoACredito[i];
				double aliquota = arrayAliquote[i];
				double perc = arrayPercentualeDecurtazione[i];
				
				if(sourceEvent == litri){
					if(litri.getText().trim().length()== 0)
						litri.setText("0");
						
					BigDecimal importo = new BigDecimal(litri.getText()).multiply(new BigDecimal(aliquota));
					
					//se per il periodo  impostata una percentuale di decurtazione, l'importo a credito viene decurtato del valore della percentuale
					//specificata nel file di properties (periodi.txt)
					if (perc>0){
						BigDecimal importoPerc =  importo.multiply(new BigDecimal(perc)).divide(new BigDecimal(100));
						importo = importo.subtract(importoPerc);
					}
					
					importo = importo.setScale(Frontespizio.getDimImportoAcreditoA1Dec(),
												BigDecimal.ROUND_HALF_UP);
											
					importi.setText(importo.toString());
					
					break;
				}
				
				if(sourceEvent == importi){					
					if (importi.getText().trim().equals(""))
						importi.setText("0");
						
					break;					
					
				}
				
			}			
			
			if (sourceEvent == getJTextFieldTOTACredito()) {

				if (getJTextFieldTOTACredito().getText().trim().equals(""))
						getJTextFieldTOTACredito().setText("0");
						return; // cio in questo caso non aggiorno i totali
			}
			

			/*if (event.getSource() == getJTextFieldLitriConsumatiA1()) {

				if (getJTextFieldLitriConsumatiA1().getText().trim().length()
					== 0)
					getJTextFieldLitriConsumatiA1().setText("0");

				BigDecimal importo =
					new BigDecimal(
						getJTextFieldLitriConsumatiA1().getText()).multiply(
						AutotrasportatoriQuadroA.ALIQUOTA_QUADRO_A1);
				importo =
					importo.setScale(
						Frontespizio.getDimImportoAcreditoA1Dec(),
						BigDecimal.ROUND_HALF_UP);
				this.getJTextFieldACreditoA1().setText(importo.toString());

			} else if (event.getSource() == getJTextFieldLitriConsumatiA2()) {

				if (getJTextFieldLitriConsumatiA2().getText().trim().length()
					== 0)
					getJTextFieldLitriConsumatiA2().setText("0");

				BigDecimal importo =
					new BigDecimal(
						getJTextFieldLitriConsumatiA2().getText()).multiply(
						AutotrasportatoriQuadroA.ALIQUOTA_QUADRO_A2);
				importo =
					importo.setScale(
						Frontespizio.getDimImportoAcreditoA2Dec(),
						BigDecimal.ROUND_HALF_UP);
				this.getJTextFieldACreditoA2().setText(importo.toString());

			} else if (event.getSource() == getJTextFieldACreditoA1()) {

				if (getJTextFieldACreditoA1().getText().trim().equals(""))
					getJTextFieldACreditoA1().setText("0");

			} else if (event.getSource() == getJTextFieldACreditoA2()) {

				if (getJTextFieldACreditoA2().getText().trim().equals(""))
					getJTextFieldACreditoA2().setText("0");

			} if (sourceEvent == getJTextFieldTOTACredito()) {

				if (getJTextFieldTOTACredito().getText().trim().equals(""))
					getJTextFieldTOTACredito().setText("0");
				return; // cio in questo caso non aggiorno i totali

			} */

		} catch (NumberFormatException e) {
			//e.printStackTrace();
		}

		this.aggiornaTotaliSuiDatiContabili();

	}

	private void validaCampiDatiContabili() {

//		if (getJRadioButtonCoordinateBancarieNaz().isSelected()) {
//			jTextFieldCodABI.setEditable(true);
//			jTextFieldCodABI.setEnabled(true);
//			jTextFieldCodCAB.setEditable(true);
//			jTextFieldCodCAB.setEnabled(true);
//			jTextFieldCCN.setEditable(true);
//			jTextFieldCCN.setEnabled(true);
//		} else {
//			jTextFieldCodABI.setEditable(false);
//			jTextFieldCodABI.setEnabled(false);
//			jTextFieldCodCAB.setEditable(false);
//			jTextFieldCodCAB.setEnabled(false);
//			jTextFieldCCN.setEditable(false);
//			jTextFieldCCN.setEnabled(false);
//			clearCoordinateBancarieNazionali();
//		}
//		if (getJRadioButtonCoordinatePostaliNaz().isSelected()) {
//			jTextFieldCCP.setEditable(true);
//			jTextFieldCCP.setEnabled(true);
//
//		} else {
//			jTextFieldCCP.setEditable(false);
//			jTextFieldCCP.setEnabled(false);
//			clearCoordinatePostaliNazionali();
//		}
		if (getJRadioButton62().isSelected()) {
			jTextFieldIban.setEditable(true);
			jTextFieldIban.setEnabled(true);
			jTextFieldBIC.setEditable(true);
			jTextFieldBIC.setEnabled(true);
		} else {
			jTextFieldIban.setEditable(false);
			jTextFieldIban.setEnabled(false);
			jTextFieldBIC.setEditable(false);
			jTextFieldBIC.setEnabled(false);
			clearCoordinateBancarueEuropee();
		}

	}

	private void validateButtonGroupDatiContabili() {
		if (jRadioButtonCoordinatePostaliNaz.isSelected()) {
			jTextFieldCodABI.setEditable(true);
			jTextFieldCodABI.setEnabled(true);
		}
	}

	private void clearCoordinateBancarieNazionali() {

		jTextFieldCodABI.setText("");
		jTextFieldCodCAB.setText("");
		jTextFieldCCN.setText("");
	}

	private void clearCoordinatePostaliNazionali() {
		jTextFieldCCP.setText("");
	}
	private void clearCoordinateBancarueEuropee() {
		jTextFieldBIC.setText("");
		jTextFieldIban.setText("");
	}

	// aggiunto reply
	protected void aggiornaTotaliSuiDatiContabili() {
		
		BigInteger totaleLitri = new BigInteger("0");
		BigDecimal totaleImporto = new BigDecimal("0");
		
		for (int i = 0; i < arrayImportoACredito.length; i++) {
			
			JTextField litri = arrayLitriConsumati[i];
			JTextField importi = arrayImportoACredito[i];
			
			String strLitri = litri.getText().trim();
			if(strLitri.length() == 0)
				strLitri = "0";
			totaleLitri = new BigInteger(totaleLitri.toString()).add(new BigInteger(strLitri));
			
			String strImporti = importi.getText().trim();
			if(strImporti.length() == 0)
				strImporti = "0";
			totaleImporto = new BigDecimal(totaleImporto.toString()).add(new BigDecimal(strImporti));
						
			
		}
		
		this.getJTextFieldTOTLitriConsumati().setText(totaleLitri.toString());
		this.getJTextFieldTOTACredito().setText(totaleImporto.toString());

		// litri
		/*String litriA1String =
			this.getJTextFieldLitriConsumatiA1().getText().trim();
		if (litriA1String.length() == 0)
			litriA1String = "0";

		String litriA2String =
			this.getJTextFieldLitriConsumatiA2().getText().trim();
		if (litriA2String.length() == 0)
			litriA2String = "0";

		BigInteger totaleLitri =
			new BigInteger(litriA1String).add(new BigInteger(litriA2String));
		this.getJTextFieldTOTLitriConsumati().setText(totaleLitri.toString());

		//importo
		String importoA1String =
			this.getJTextFieldACreditoA1().getText().trim();
		if (importoA1String.length() == 0)
			importoA1String = "0";

		String importoA2String =
			this.getJTextFieldACreditoA2().getText().trim();
		if (importoA2String.length() == 0)
			importoA2String = "0";

		BigDecimal totaleImporto =
			new BigDecimal(importoA1String).add(
				new BigDecimal(importoA2String));
		this.getJTextFieldTOTACredito().setText(totaleImporto.toString());
		
		*/
		
		

	}

	/*************************************************************************
		 * FINE GESTIONE EVENTI
	**************************************************************************/

	/**
	 * This method initializes mainPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	protected javax.swing.JPanel getMainPanel() {
		if (mainPanel == null) {
			mainPanel = new javax.swing.JPanel();
			mainPanel.setLayout(new java.awt.BorderLayout());
			mainPanel.add(getJToolBar(), java.awt.BorderLayout.NORTH);
			mainPanel.add(getWorkPanel(), java.awt.BorderLayout.CENTER);
			// mainPanel.add(getStartupPanel(), java.awt.BorderLayout.CENTER);

			/***
			mainPanel = new javax.swing.JPanel();
			mainPanel.setLayout(null);
			mainPanel.add(getWorkPanel(), null);
			mainPanel.add(getJToolBar(), null);
			mainPanel.add(getStartupPanel(), null);
			***/
		}
		return mainPanel;
	}

	/**
	 * This method initializes mainMenuBar
	 * 
	 * @return javax.swing.JMenuBar
	 */
	protected javax.swing.JMenuBar getMainMenuBar() {
		if (mainMenuBar == null) {
			mainMenuBar = new javax.swing.JMenuBar();
			mainMenuBar.add(getFileMenu());
			mainMenuBar.add(getInterchange());
			LAFManager.getInstance().initLookMenu(mainMenuBar, this);
			mainMenuBar.add(getHelpMenu());

			//mainMenuBar.add(getInterchange());
		}
		return mainMenuBar;
	}
	/**
	 * This method initializes fileMenu
	 * 
	 * @return javax.swing.JMenu
	 */
	protected javax.swing.JMenu getFileMenu() {
		if (fileMenu == null) {
			fileMenu = new javax.swing.JMenu();
			fileMenu.setText("Dichiarazione");
			fileMenu.setMnemonic(java.awt.event.KeyEvent.VK_F);

			JMenuItem menuItem;
			menuItem = fileMenu.add(newAction);
			menuItem = fileMenu.add(openAction);
			fileMenu.addSeparator();
			//menuItem = fileMenu.add(sendAction);
			//fileMenu.addSeparator();
			menuItem = fileMenu.add(exitAction);
		}
		return fileMenu;
	}
	/**
	 * This method initializes helpMenu
	 * 
	 * @return javax.swing.JMenu
	 */
	protected javax.swing.JMenu getHelpMenu() {
		if (helpMenu == null) {
			helpMenu = new javax.swing.JMenu();

			helpMenu.setText("?");
			//helpMenu.setText("Aiuto");
			//JMenuItem menuItemHelp = helpMenu.add(helpAction);
			JMenuItem menuItem = helpMenu.add(aboutAction);
			
		}
		return helpMenu;
	}

	protected javax.swing.JMenu getInterchange() {
		if (InterchMenu == null) {
			InterchMenu = new javax.swing.JMenu();
			InterchMenu.setText("Interchange");
			InterchMenu.setMnemonic(java.awt.event.KeyEvent.VK_F);
			JMenuItem menuItem;
			menuItem = InterchMenu.add(interchangeAction);
		}
		return InterchMenu;
	}

	/**
	 * This method initializes workPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	protected javax.swing.JPanel getWorkPanel() {
		if (workPanel == null) {
			workPanel = new javax.swing.JPanel();
			workPanel.setLayout(null);
			workPanel.add(getJLabel(), null);
			workPanel.add(getJComboBoxUfficio(), null);
			workPanel.add(getJLabel1(), null);
			workPanel.add(getJTextFieldAnno(), null);
			workPanel.add(getJLabel2(), null);
			// modifica reply
			//workPanel.add(getJComboBoxPeriodo(), null);
			getJComboBoxPeriodo();
			workPanel.add(getJTextFieldPeriodo(), null);
			// fine
			workPanel.add(getJPanel(), null);
			workPanel.add(getJPanel1(), null);
			workPanel.add(getJButtonChiudi(), null);
			workPanel.add(getJButtonStampa(), null);
			workPanel.add(getJButtonSave(), null);
			workPanel.add(getJButtonSaveAs(), null);
			workPanel.add(getJPanel3(), null);
			workPanel.setDoubleBuffered(false);
			workPanel.setToolTipText("");
		}
		return workPanel;
	}

	/**
	 * This method initializes jToolBar
	 * 
	 * @return javax.swing.JToolBar
	 */
	protected javax.swing.JToolBar getJToolBar() {
		if (jToolBar == null) {
			jToolBar = new javax.swing.JToolBar();
			jToolBar.setBounds(0, 0, 794, 4);

			jToolBar.add(newAction);
			jToolBar.add(openAction);
			jToolBar.addSeparator();
			// jToolBar.add(sendAction);
			jToolBar.addSeparator();
			jToolBar.add(exitAction);
		}
		return jToolBar;
	}

	private javax.swing.JPanel getStartupPanel() {
		if (startupPanel == null) {
			startupPanel = new javax.swing.JPanel();
			startupPanel.setLayout(new java.awt.BorderLayout());
			startupPanel.add(getJLabelIcon(), java.awt.BorderLayout.CENTER);
			//startupPanel.setBounds(5, 559, 799, 530);
			startupPanel.setBounds(
				RealDim.getAbsoluteXValue(5),
				RealDim.getAbsoluteYValue(559),
				RealDim.getAbsoluteXValue(799),
				RealDim.getAbsoluteYValue(530));

		}
		return startupPanel;
	}

	private javax.swing.JLabel getJLabelIcon() {
		if (JLabelIcon == null) {
			JLabelIcon = new javax.swing.JLabel();
			JLabelIcon.setText("");
			JLabelIcon.setIcon(
				new javax.swing.ImageIcon(
					getClass().getResource(
						"/it/finanze/dogane/accise/ui/icons/Repub.jpg")));
			JLabelIcon.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			JLabelIcon.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return JLabelIcon;
	}

	private javax.swing.JLabel getJLabel() {
		if (jLabel == null) {
			jLabel = new javax.swing.JLabel();
			//jLabel.setBounds(33, 20, 53, 21);
			jLabel.setBounds(
				RealDim.getAbsoluteXValue(33),
				RealDim.getAbsoluteYValue(15),
				RealDim.getAbsoluteXValue(53),
				RealDim.getAbsoluteYValue(21));
			jLabel.setText("Ufficio");
			jLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel;
	}
	/**
	 * This method initializes jComboBoxUfficio
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxUfficio() {
		if (jComboBoxUfficio == null) {
			jComboBoxUfficio = new javax.swing.JComboBox();
			//jComboBoxUfficio.setBounds(97, 20, 129, 17);
			jComboBoxUfficio.setBounds(
				RealDim.getAbsoluteXValue(97),
				RealDim.getAbsoluteYValue(16),
				RealDim.getAbsoluteXValue(129),
				RealDim.getAbsoluteYValue(17));
		}
		return jComboBoxUfficio;
	}
	/**
	 * This method initializes jLabel1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if (jLabel1 == null) {
			jLabel1 = new javax.swing.JLabel();
			//jLabel1.setBounds(230, 21, 125, 20);
			jLabel1.setBounds(
				RealDim.getAbsoluteXValue(230),
				RealDim.getAbsoluteYValue(16),
				RealDim.getAbsoluteXValue(125),
				RealDim.getAbsoluteYValue(20));
			jLabel1.setText("Anno di riferimento");
			jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel1.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabel1;
	}
	/**
	 * This method initializes jTextFieldAnno
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldAnno() {
		if (jTextFieldAnno == null) {
			jTextFieldAnno = new javax.swing.JTextField();
			//	jTextFieldAnno.setBounds(360, 21, 95, 20);			
			jTextFieldAnno.setText(getAnnoRiferimento());
			jTextFieldAnno.setEditable(false);
			jTextFieldAnno.setBounds(
				RealDim.getAbsoluteXValue(360),
				RealDim.getAbsoluteYValue(16),
				RealDim.getAbsoluteXValue(95),
				RealDim.getAbsoluteYValue(20));
			jTextFieldAnno.setDocument(
				new BigIntegerDocument(Frontespizio.getDimAnnoDic()));
		}
		return jTextFieldAnno;
	}
	/**
	 * This method initializes jLabel2
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel2() {
		if (jLabel2 == null) {
			jLabel2 = new javax.swing.JLabel();
			//jLabel2.setBounds(472, 21, 91, 19);
			jLabel2.setBounds(
				RealDim.getAbsoluteXValue(472),
				RealDim.getAbsoluteYValue(16),
				RealDim.getAbsoluteXValue(91),
				RealDim.getAbsoluteYValue(19));
			jLabel2.setText("Periodo");
			jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel2;
	}
	/**
	 * This method initializes jComboBoxPeriodo
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxPeriodo() {
		if (jComboBoxPeriodo == null) {
			jComboBoxPeriodo = new javax.swing.JComboBox();
			//jComboBoxPeriodo.setBounds(567, 21, 211, 17);
			jComboBoxPeriodo.setBounds(
				RealDim.getAbsoluteXValue(567),
				RealDim.getAbsoluteYValue(16),
				RealDim.getAbsoluteXValue(135),
				RealDim.getAbsoluteYValue(17));
			jComboBoxPeriodo.addActionListener(this);
		}
		return jComboBoxPeriodo;
	}

	private JTextField getJTextFieldPeriodo() {
		if (jTextFieldPeriodo == null) {
			jTextFieldPeriodo =
				new JTextField(
						getPeriodo() +" "
						+ getAnnoRiferimento());
			jTextFieldPeriodo.setEditable(false);
			jTextFieldPeriodo.setBounds(
				RealDim.getAbsoluteXValue(567),
				RealDim.getAbsoluteYValue(16),
				RealDim.getAbsoluteXValue(150),
				RealDim.getAbsoluteYValue(17));

		}
		return jTextFieldPeriodo;
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new javax.swing.JPanel();
			jPanel.setLayout(null);
			jPanel.add(getJLabel4(), null);
			jPanel.add(getJTextFieldCognome(), null);
			jPanel.add(getJLabel5(), null);
			jPanel.add(getJTextFieldNome(), null);
			jPanel.add(getJLabel6(), null);
			jPanel.add(getJTextFieldCodFiscale(), null);
			jPanel.add(getJLabel7(), null);
			jPanel.add(getJComboBoxNellaQualitaDi(), null);
			//jPanel.setBounds(18, 56, 765, 85);
			jPanel.setBounds(
				RealDim.getAbsoluteXValue(18),
				RealDim.getAbsoluteYValue(50),
				RealDim.getAbsoluteXValue(765),
				RealDim.getAbsoluteYValue(85));
			jPanel.setBackground(java.awt.Color.lightGray);
			jPanel.setBorder(
				javax.swing.BorderFactory.createTitledBorder(
					null,
					"Presentata e sottoscritta sotto la propria responsabilit, da",
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION,
					new java.awt.Font("Dialog", java.awt.Font.BOLD, 12),
					java.awt.Color.black));
		}
		return jPanel;
	}
	/**
	 * This method initializes jLabel4
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel4() {
		if (jLabel4 == null) {
			jLabel4 = new javax.swing.JLabel();
			//	jLabel4.setBounds(6, 23, 84, 19);
			jLabel4.setBounds(
				RealDim.getAbsoluteXValue(6),
				RealDim.getAbsoluteYValue(23),
				RealDim.getAbsoluteXValue(84),
				RealDim.getAbsoluteYValue(19));
			jLabel4.setText("Cognome");
		}
		return jLabel4;
	}
	/**
	 * This method initializes jTextFieldCognome
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldCognome() {
		if (jTextFieldCognome == null) {
			jTextFieldCognome = new javax.swing.JTextField();
			//	jTextFieldCognome.setBounds(95, 23, 275, 19);
			jTextFieldCognome.setBounds(
				RealDim.getAbsoluteXValue(95),
				RealDim.getAbsoluteYValue(23),
				RealDim.getAbsoluteXValue(275),
				RealDim.getAbsoluteYValue(19));
			jTextFieldCognome.setDocument(
				new StringDocument(
					Frontespizio.getDimCognomeRappresentanteDichiarazione()));
		}
		return jTextFieldCognome;
	}
	/**
	 * This method initializes jLabel5
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel5() {
		if (jLabel5 == null) {
			jLabel5 = new javax.swing.JLabel();
			//jLabel5.setBounds(403, 23, 65, 16);
			jLabel5.setBounds(
				RealDim.getAbsoluteXValue(403),
				RealDim.getAbsoluteYValue(23),
				RealDim.getAbsoluteXValue(65),
				RealDim.getAbsoluteYValue(16));
			jLabel5.setText("Nome");
			jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel5;
	}
	/**
	 * This method initializes jTextFieldNome
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldNome() {
		if (jTextFieldNome == null) {
			jTextFieldNome = new javax.swing.JTextField();
			//jTextFieldNome.setBounds(475, 23, 275, 19);
			jTextFieldNome.setBounds(
				RealDim.getAbsoluteXValue(475),
				RealDim.getAbsoluteYValue(23),
				RealDim.getAbsoluteXValue(275),
				RealDim.getAbsoluteYValue(19));
			jTextFieldNome.setDocument(
				new StringDocument(
					Frontespizio.getDimNomeRappresentanteDichiarazione()));
		}
		return jTextFieldNome;
	}
	/**
	 * This method initializes jLabel6
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel6() {
		if (jLabel6 == null) {
			jLabel6 = new javax.swing.JLabel();
			//jLabel6.setBounds(7, 52, 84, 20);
			jLabel6.setBounds(
				RealDim.getAbsoluteXValue(7),
				RealDim.getAbsoluteYValue(52),
				RealDim.getAbsoluteXValue(84),
				RealDim.getAbsoluteYValue(20));
			jLabel6.setText("Codice Fiscale");
		}
		return jLabel6;
	}
	/**
	 * This method initializes jTextFieldCodFiscale
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldCodFiscale() {
		if (jTextFieldCodFiscale == null) {
			jTextFieldCodFiscale = new javax.swing.JTextField();
			//jTextFieldCodFiscale.setBounds(96, 53, 275, 19);
			jTextFieldCodFiscale.setBounds(
				RealDim.getAbsoluteXValue(96),
				RealDim.getAbsoluteYValue(53),
				RealDim.getAbsoluteXValue(275),
				RealDim.getAbsoluteYValue(19));
			jTextFieldCodFiscale.setDocument(
				new StringDocument(
					Frontespizio
						.getDimCodicefiscaleRappresentanteDichiarazione()));
		}
		return jTextFieldCodFiscale;
	}
	/**
	 * This method initializes jLabel7
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel7() {
		if (jLabel7 == null) {
			jLabel7 = new javax.swing.JLabel();
			//	jLabel7.setBounds(383, 50, 84, 21);
			jLabel7.setBounds(
				RealDim.getAbsoluteXValue(395),
				RealDim.getAbsoluteYValue(50),
				RealDim.getAbsoluteXValue(84),
				RealDim.getAbsoluteYValue(21));
			jLabel7.setText("Nella qualit di");
		}
		return jLabel7;
	}
	/**
	 * This method initializes jComboBoxNellaQualitaDi
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxNellaQualitaDi() {
		if (jComboBoxNellaQualitaDi == null) {
			jComboBoxNellaQualitaDi = new javax.swing.JComboBox();
			//	jComboBoxNellaQualitaDi.setBounds(474, 50, 275, 17);
			jComboBoxNellaQualitaDi.setBounds(
				RealDim.getAbsoluteXValue(474),
				RealDim.getAbsoluteYValue(55),
				RealDim.getAbsoluteXValue(275),
				RealDim.getAbsoluteYValue(17));

		}
		return jComboBoxNellaQualitaDi;
	}
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new javax.swing.JPanel();
			jPanel1.setLayout(null);
			jPanel1.add(getJTabbedPane(), null);
			//jPanel1.setBounds(19, 151, 764, 314);

			jPanel1.setBounds(
				RealDim.getAbsoluteXValue(19),
				RealDim.getAbsoluteYValue(140),
				RealDim.getAbsoluteXValue(764),
				RealDim.getAbsoluteYValue(306));
			jPanel1.setBackground(java.awt.Color.lightGray);
		}
		return jPanel1;
	}
	/**
	 * This method initializes jTabbedPane
	 * 
	 * @return javax.swing.JTabbedPane
	 */
	private javax.swing.JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new javax.swing.JTabbedPane();
			jTabbedPane.addTab("Dati Impresa", null, getJPanel2(), null);
			jTabbedPane.addTab("Dati Contabili", null, getJPanel4(), null);
			jTabbedPane.setBounds(6, 9, 749, 303);
			jTabbedPane.setBounds(
				RealDim.getAbsoluteXValue(6),
				RealDim.getAbsoluteYValue(5),
				RealDim.getAbsoluteXValue(749),
				RealDim.getAbsoluteYValue(296));
			jTabbedPane.setBorder(
				javax.swing.BorderFactory.createLineBorder(
					java.awt.Color.black,
					1));
			jTabbedPane.setName("");
			jTabbedPane.setDoubleBuffered(true);
			jTabbedPane.setToolTipText("");
			
			
		}
		return jTabbedPane;
	}
	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new javax.swing.JPanel();
			jPanel2.setLayout(null);
			jPanel2.add(getJLabel8(), null);
			jPanel2.add(getJTextFieldPartitaIva(), null);
			jPanel2.add(getJLabel9(), null);
			jPanel2.add(getJCheckBoxNazionale(), null);
			//jPanel2.add(getJCheckBoxEuroZero(), null);
			
			jPanel2.add(getJLabel10(), null);
			jPanel2.add(getJComboBoxComunatario(), null);
			jPanel2.add(getJLabel11(), null);
			jPanel2.add(getJTextFieldDenominazione(), null);
			jPanel2.add(getJLabel12(), null);
			jPanel2.add(getJComboBoxTipoEsercente(), null);
			jPanel2.add(getJPanel31(), null);
			jPanel2.add(getJLabel22(), null);
			jPanel2.add(getJComboBoxCodAttivita(), null);
			jPanel2.add(getJLabel23(), null);
			jPanel2.add(getJRadioButtonContoProprioAutoTraspMerci(), null);
			jPanel2.add(getJRadioButtonContoTerziAutoTraspMerci(), null);
			jPanel2.add(getJLabel24(), null);
			jPanel2.add(getJTextFieldEstremiLicenza(), null);
			jPanel2.add(getJLabel25(), null);
			jPanel2.add(getJLabel26(), null);
			jPanel2.add(getJTextFieldCertificatoImmatr(), null);			
						
			jPanel2.add(getJLabel27(), null);
			jPanel2.add(getJTextFieldTitoloPossesso(), null);
			
			jPanel2.add(getJCheckBoxEuroZero(), null);
						
			jPanel2.add(getJPanel6(), null);
			jPanel2.add(getJPanelComunitario(), null);
			jPanel2.setBorder(
				javax.swing.BorderFactory.createLineBorder(
					java.awt.Color.black,
					1));
		}
		return jPanel2;
	}
	/**
	 * This method initializes jLabel8
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel8() {
		if (jLabel8 == null) {
			jLabel8 = new javax.swing.JLabel();
			//jLabel8.setBounds(6, 6, 77, 12);
			jLabel8.setBounds(
				RealDim.getAbsoluteXValue(6),
				RealDim.getAbsoluteYValue(6),
				RealDim.getAbsoluteXValue(77),
				RealDim.getAbsoluteYValue(12));
			jLabel8.setText("Partita Iva");
		}
		return jLabel8;
	}
	/**
	 * This method initializes jTextFieldPartitaIva
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldPartitaIva() {
		if (jTextFieldPartitaIva == null) {
			jTextFieldPartitaIva = new javax.swing.JTextField();
			//jTextFieldPartitaIva.setBounds(86, 5, 185, 17);
			jTextFieldPartitaIva.setBounds(
				RealDim.getAbsoluteXValue(86),
				RealDim.getAbsoluteYValue(5),
				RealDim.getAbsoluteXValue(185),
				RealDim.getAbsoluteYValue(17));
			jTextFieldPartitaIva.setDocument(
				new StringDocument(Frontespizio.getDimPartitaIvaItaliana()));
		}
		return jTextFieldPartitaIva;
	}
	/**
	 * This method initializes jLabel9
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel9() {
		if (jLabel9 == null) {
			jLabel9 = new javax.swing.JLabel();
			//jLabel9.setBounds(278, 5, 61, 14);
			jLabel9.setBounds(
				RealDim.getAbsoluteXValue(278),
				RealDim.getAbsoluteYValue(5),
				RealDim.getAbsoluteXValue(61),
				RealDim.getAbsoluteYValue(14));
			jLabel9.setText("Esercente");
		}
		return jLabel9;
	}
	/**
	 * This method initializes jCheckBoxNazionale
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private javax.swing.JCheckBox getJCheckBoxNazionale() {
		if (jCheckBoxNazionale == null) {
			jCheckBoxNazionale = new javax.swing.JCheckBox();
			//	jCheckBoxNazionale.setBounds(345, 5, 81, 17);
			jCheckBoxNazionale.setBounds(
				RealDim.getAbsoluteXValue(345),
				RealDim.getAbsoluteYValue(5),
				RealDim.getAbsoluteXValue(81),
				RealDim.getAbsoluteYValue(17));
			jCheckBoxNazionale.setText("Nazionale");
			jCheckBoxNazionale.addActionListener(this);
		}
		return jCheckBoxNazionale;
	}
	/**
	 * This method initializes jLabel10
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel10() {
		if (jLabel10 == null) {
			jLabel10 = new javax.swing.JLabel();
			//jLabel10.setBounds(446, 5, 110, 14);
			jLabel10.setBounds(
				RealDim.getAbsoluteXValue(446),
				RealDim.getAbsoluteYValue(5),
				RealDim.getAbsoluteXValue(110),
				RealDim.getAbsoluteYValue(14));
			jLabel10.setText("Comunitario");
			jLabel10.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel10.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabel10;
	}
	/**
	 * This method initializes jComboBoxComunatario
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxComunatario() {
		if (jComboBoxComunatario == null) {
			jComboBoxComunatario = new javax.swing.JComboBox();
			//jComboBoxComunatario.setBounds(562, 5, 169, 17);
			jComboBoxComunatario.setBounds(
				RealDim.getAbsoluteXValue(562),
				RealDim.getAbsoluteYValue(5),
				RealDim.getAbsoluteXValue(169),
				RealDim.getAbsoluteYValue(17));
			jComboBoxComunatario.addFocusListener(this);
		}
		return jComboBoxComunatario;
	}
	/**
	 * This method initializes jLabel11
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel11() {
		if (jLabel11 == null) {
			jLabel11 = new javax.swing.JLabel();
			//jLabel11.setBounds(7, 25, 104, 16);
			jLabel11.setBounds(
				RealDim.getAbsoluteXValue(7),
				RealDim.getAbsoluteYValue(25),
				RealDim.getAbsoluteXValue(104),
				RealDim.getAbsoluteYValue(16));
			jLabel11.setText("Denominazione");
		}
		return jLabel11;
	}
	/**
	 * This method initializes jTextFieldDenominazione
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldDenominazione() {
		if (jTextFieldDenominazione == null) {
			jTextFieldDenominazione = new javax.swing.JTextField();
			//jTextFieldDenominazione.setBounds(118, 25, 614, 17);
			jTextFieldDenominazione.setBounds(
				RealDim.getAbsoluteXValue(118),
				RealDim.getAbsoluteYValue(25),
				RealDim.getAbsoluteXValue(614),
				RealDim.getAbsoluteYValue(17));
			jTextFieldDenominazione.setDocument(
				new StringDocument(Frontespizio.getDimDenominazione()));
		}
		return jTextFieldDenominazione;
	}
	/**
	 * This method initializes jLabel12
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel12() {
		if (jLabel12 == null) {
			jLabel12 = new javax.swing.JLabel();
			//jLabel12.setBounds(8, 46, 102, 14);
			jLabel12.setBounds(
				RealDim.getAbsoluteXValue(8),
				RealDim.getAbsoluteYValue(46),
				RealDim.getAbsoluteXValue(102),
				RealDim.getAbsoluteYValue(14));
			jLabel12.setText("Tipo Esercente");
		}
		return jLabel12;
	}
	/**
	 * This method initializes jComboBoxTipoEsercente
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxTipoEsercente() {
		if (jComboBoxTipoEsercente == null) {
			jComboBoxTipoEsercente = new javax.swing.JComboBox();
			//jComboBoxTipoEsercente.setBounds(117, 45, 616, 17);
			jComboBoxTipoEsercente.setBounds(
				RealDim.getAbsoluteXValue(117),
				RealDim.getAbsoluteYValue(45),
				RealDim.getAbsoluteXValue(616),
				RealDim.getAbsoluteYValue(17));
		}
		return jComboBoxTipoEsercente;
	}
	/**
	 * This method initializes jPanel31
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel31() {
		if (jPanel31 == null) {
			jPanel31 = new javax.swing.JPanel();
			jPanel31.setLayout(null);
			jPanel31.add(getJLabel14(), null);
			jPanel31.add(getJComboBoxProvinciaSedeLegale(), null);
			jPanel31.add(getJLabel15(), null);
			jPanel31.add(getJComboBoxComuneSedeLegale(), null);
			jPanel31.add(getJLabel16(), null);
			jPanel31.add(getJTextFieldIndirizzoSedeLegale(), null);
			jPanel31.setBounds(8, 65, 733, 43);
			jPanel31.setBounds(
				RealDim.getAbsoluteXValue(8),
				RealDim.getAbsoluteYValue(65),
				RealDim.getAbsoluteXValue(733),
				RealDim.getAbsoluteYValue(43));
			jPanel31.setBackground(java.awt.Color.lightGray);
			jPanel31.setBorder(
				javax.swing.BorderFactory.createTitledBorder(
					null,
					"Sede legale",
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION,
					null,
					null));
		}
		return jPanel31;
	}
	/**
	 * This method initializes jLabel14
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel14() {
		if (jLabel14 == null) {
			jLabel14 = new javax.swing.JLabel();
			//jLabel14.setBounds(7, 20, 57, 17);
			jLabel14.setBounds(
				RealDim.getAbsoluteXValue(7),
				RealDim.getAbsoluteYValue(20),
				RealDim.getAbsoluteXValue(57),
				RealDim.getAbsoluteYValue(17));
			jLabel14.setText("Provincia");
		}
		return jLabel14;
	}
	/**
	 * This method initializes jComboBoxProvinciaSedeLegale
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxProvinciaSedeLegale() {
		if (jComboBoxProvinciaSedeLegale == null) {
			jComboBoxProvinciaSedeLegale = new javax.swing.JComboBox();
			//jComboBoxProvinciaSedeLegale.setBounds(70, 20, 155, 17);
			jComboBoxProvinciaSedeLegale.setBounds(
				RealDim.getAbsoluteXValue(70),
				RealDim.getAbsoluteYValue(20),
				RealDim.getAbsoluteXValue(155),
				RealDim.getAbsoluteYValue(17));
			jComboBoxProvinciaSedeLegale.addActionListener(this);
		}
		return jComboBoxProvinciaSedeLegale;
	}
	/**
	 * This method initializes jLabel15
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel15() {
		if (jLabel15 == null) {
			jLabel15 = new javax.swing.JLabel();
			//jLabel15.setBounds(238, 20, 61, 15);
			jLabel15.setBounds(
				RealDim.getAbsoluteXValue(238),
				RealDim.getAbsoluteYValue(20),
				RealDim.getAbsoluteXValue(61),
				RealDim.getAbsoluteYValue(15));
			jLabel15.setText("Comune");
		}
		return jLabel15;
	}
	/**
	 * This method initializes jComboBoxComuneSedeLegale
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxComuneSedeLegale() {
		if (jComboBoxComuneSedeLegale == null) {
			jComboBoxComuneSedeLegale = new javax.swing.JComboBox();
			//jComboBoxComuneSedeLegale.setBounds(296, 20, 87, 17);
			jComboBoxComuneSedeLegale.addActionListener(this);
			jComboBoxComuneSedeLegale.setBounds(
				RealDim.getAbsoluteXValue(296),
				RealDim.getAbsoluteYValue(20),
				RealDim.getAbsoluteXValue(87),
				RealDim.getAbsoluteYValue(17));
			jComboBoxComuneSedeLegale.setRenderer(new ComuneComboBoxRenderer());
		}
		return jComboBoxComuneSedeLegale;
	}
	/**
	 * This method initializes jLabel16
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel16() {
		if (jLabel16 == null) {
			jLabel16 = new javax.swing.JLabel();
			//jLabel16.setBounds(390, 20, 56, 17);
			jLabel16.setBounds(
				RealDim.getAbsoluteXValue(390),
				RealDim.getAbsoluteYValue(20),
				RealDim.getAbsoluteXValue(56),
				RealDim.getAbsoluteYValue(17));
			jLabel16.setText("Indirizzo");
			jLabel16.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel16.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabel16;
	}
	/**
	 * This method initializes jTextFieldIndirizzoSedeLegale
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldIndirizzoSedeLegale() {
		if (jTextFieldIndirizzoSedeLegale == null) {
			jTextFieldIndirizzoSedeLegale = new javax.swing.JTextField();
			//	jTextFieldIndirizzoSedeLegale.setBounds(444, 20, 284, 17);
			jTextFieldIndirizzoSedeLegale.setBounds(
				RealDim.getAbsoluteXValue(444),
				RealDim.getAbsoluteYValue(20),
				RealDim.getAbsoluteXValue(284),
				RealDim.getAbsoluteYValue(17));
			jTextFieldIndirizzoSedeLegale.setDocument(
				new StringDocument(Frontespizio.getDimIndirizzoSedeLegale()));
		}
		return jTextFieldIndirizzoSedeLegale;
	}
	/**
	 * This method initializes jLabel22
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel22() {
		if (jLabel22 == null) {
			jLabel22 = new javax.swing.JLabel();
			//jLabel22.setBounds(8, 166, 90, 17);
			jLabel22.setBounds(
				RealDim.getAbsoluteXValue(8),
				RealDim.getAbsoluteYValue(166),
				RealDim.getAbsoluteXValue(90),
				RealDim.getAbsoluteYValue(17));
			jLabel22.setText("Codice Attivita");
		}
		return jLabel22;
	}
	/**
	 * This method initializes jComboBoxCodAttivita
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxCodAttivita() {
		if (jComboBoxCodAttivita == null) {
			jComboBoxCodAttivita = new javax.swing.JComboBox();
			//	jComboBoxCodAttivita.setBounds(103, 167, 629, 17);
			jComboBoxCodAttivita.setBounds(
				RealDim.getAbsoluteXValue(103),
				RealDim.getAbsoluteYValue(167),
				RealDim.getAbsoluteXValue(629),
				RealDim.getAbsoluteYValue(17));
				
			
				
		}
		return jComboBoxCodAttivita;
	}
	/**
	 * This method initializes jLabel23
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel23() {
		if (jLabel23 == null) {
			jLabel23 = new javax.swing.JLabel();
			//	jLabel23.setBounds(8, 190, 119, 21);
			jLabel23.setBounds(
				RealDim.getAbsoluteXValue(8),
				RealDim.getAbsoluteYValue(190),
				RealDim.getAbsoluteXValue(119),
				RealDim.getAbsoluteYValue(21));
			jLabel23.setText("Autotrasporto Merci");
		}
		return jLabel23;
	}
	/**
	 * This method initializes jRadioButtonContoProprioAutoTraspMerci
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax
		.swing
		.JRadioButton getJRadioButtonContoProprioAutoTraspMerci() {
		if (jRadioButtonContoProprioAutoTraspMerci == null) {
			jRadioButtonContoProprioAutoTraspMerci =
				new javax.swing.JRadioButton();
			//jRadioButtonContoProprioAutoTraspMerci.setBounds(133, 191, 109, 16);
			jRadioButtonContoProprioAutoTraspMerci.setBounds(
				RealDim.getAbsoluteXValue(133),
				RealDim.getAbsoluteYValue(191),
				RealDim.getAbsoluteXValue(109),
				RealDim.getAbsoluteYValue(16));
			jRadioButtonContoProprioAutoTraspMerci.setText("Conto Proprio");
			buttonGroupAutotrasportoMerci.add(
				jRadioButtonContoProprioAutoTraspMerci);
		}
		return jRadioButtonContoProprioAutoTraspMerci;
	}
	/**
	 * This method initializes jRadioButtonContoTerziAutoTraspMerci
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax
		.swing
		.JRadioButton getJRadioButtonContoTerziAutoTraspMerci() {
		if (jRadioButtonContoTerziAutoTraspMerci == null) {
			jRadioButtonContoTerziAutoTraspMerci =
				new javax.swing.JRadioButton();
			//jRadioButtonContoTerziAutoTraspMerci.setBounds(247, 192, 89, 17);
			jRadioButtonContoTerziAutoTraspMerci.setBounds(
				RealDim.getAbsoluteXValue(247),
				RealDim.getAbsoluteYValue(192),
				RealDim.getAbsoluteXValue(89),
				RealDim.getAbsoluteYValue(17));
			jRadioButtonContoTerziAutoTraspMerci.setText("Conto Terzi");
			buttonGroupAutotrasportoMerci.add(
				jRadioButtonContoTerziAutoTraspMerci);
		}
		return jRadioButtonContoTerziAutoTraspMerci;
	}
	/**
	 * This method initializes jLabel24
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel24() {
		if (jLabel24 == null) {
			jLabel24 = new javax.swing.JLabel();
			//	jLabel24.setBounds(7, 214, 472, 16);
			jLabel24.setBounds(
				RealDim.getAbsoluteXValue(7),
				RealDim.getAbsoluteYValue(214),
				RealDim.getAbsoluteXValue(472),
				RealDim.getAbsoluteYValue(16));
			jLabel24.setText(
				"Estremi Licenza / Iscrizione Albo Trasportatori / Codic iden. Esercente comunitario");
		}
		return jLabel24;
	}
	/**
	 * This method initializes jTextFieldEstremiLicenza
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldEstremiLicenza() {
		if (jTextFieldEstremiLicenza == null) {
			jTextFieldEstremiLicenza = new javax.swing.JTextField();
			//jTextFieldEstremiLicenza.setBounds(483, 213, 236, 17);
			jTextFieldEstremiLicenza.setBounds(
				RealDim.getAbsoluteXValue(483),
				RealDim.getAbsoluteYValue(213),
				RealDim.getAbsoluteXValue(236),
				RealDim.getAbsoluteYValue(17));
			jTextFieldEstremiLicenza.setDocument(
				new StringDocument(Frontespizio.getDimEstremiLicenza()));

		}
		return jTextFieldEstremiLicenza;
	}
	/**
	 * This method initializes jLabel25
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel25() {
		if (jLabel25 == null) {
			jLabel25 = new javax.swing.JLabel();
			//jLabel25.setBounds(7, 235, 105, 17);
			jLabel25.setBounds(
				RealDim.getAbsoluteXValue(7),
				RealDim.getAbsoluteYValue(235),
				RealDim.getAbsoluteXValue(105),
				RealDim.getAbsoluteYValue(17));
			jLabel25.setText("Numero Allegati :");
		}
		return jLabel25;
	}
	/**
	 * This method initializes jLabel26
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel26() {
		if (jLabel26 == null) {
			jLabel26 = new javax.swing.JLabel();
			//jLabel26.setBounds(120, 235, 167, 15);
			jLabel26.setBounds(
				RealDim.getAbsoluteXValue(120),
				RealDim.getAbsoluteYValue(235),
				RealDim.getAbsoluteXValue(167),
				RealDim.getAbsoluteYValue(15));
			jLabel26.setText("Certificati di Immatricolazione");
			jLabel26.setFont(
				new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12));
		}
		return jLabel26;
	}
	

	
	
	private javax.swing.JCheckBox getJCheckBoxEuroZero() {
		if (jCheckBoxEuroZero == null) {
			jCheckBoxEuroZero = new javax.swing.JCheckBox();			
			jCheckBoxEuroZero.setBounds(
					RealDim.getAbsoluteXValue(7),
					RealDim.getAbsoluteYValue(255),
					RealDim.getAbsoluteXValue(605),
					RealDim.getAbsoluteYValue(17));
			jCheckBoxEuroZero.setText("Dichiara che il gasolio consumato, per cui si chiede il beneficio, non  stato impiegato per il rifornimento di veicoli di categoria Euro 2 o inferiore");
			jCheckBoxEuroZero.addActionListener(this);
		}
		return jCheckBoxEuroZero;
	}
	
	
	/**
	 * This method initializes jTextFieldCertificatoImmatr
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldCertificatoImmatr() {
		if (jTextFieldCertificatoImmatr == null) {
			jTextFieldCertificatoImmatr = new javax.swing.JTextField();
			//jTextFieldCertificatoImmatr.setBounds(290, 235, 78, 17);
			jTextFieldCertificatoImmatr.setBounds(
				RealDim.getAbsoluteXValue(290),
				RealDim.getAbsoluteYValue(235),
				RealDim.getAbsoluteXValue(78),
				RealDim.getAbsoluteYValue(17));
			jTextFieldCertificatoImmatr.setDocument(
				new BigIntegerDocument(
					Frontespizio.getDimAllegatiCertificatiImmatricolazione()));
		}
		return jTextFieldCertificatoImmatr;
	}
	/**
	 * This method initializes jLabel27
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel27() {
		if (jLabel27 == null) {
			jLabel27 = new javax.swing.JLabel();
			//jLabel27.setBounds(372, 235, 118, 17);
			jLabel27.setBounds(
				RealDim.getAbsoluteXValue(372),
				RealDim.getAbsoluteYValue(235),
				RealDim.getAbsoluteXValue(118),
				RealDim.getAbsoluteYValue(17));
			jLabel27.setText("Titoli di Possesso");
			jLabel27.setFont(
				new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12));
		}
		return jLabel27;
	}
	/**
	 * This method initializes jTextFieldTitoloPossesso
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTitoloPossesso() {
		if (jTextFieldTitoloPossesso == null) {
			jTextFieldTitoloPossesso = new javax.swing.JTextField();
			//jTextFieldTitoloPossesso.setBounds(493, 235, 125, 17);
			jTextFieldTitoloPossesso.setBounds(
				RealDim.getAbsoluteXValue(483),
				RealDim.getAbsoluteYValue(235),
				RealDim.getAbsoluteXValue(125),
				RealDim.getAbsoluteYValue(17));
			jTextFieldTitoloPossesso.setDocument(
				new BigIntegerDocument(
					Frontespizio.getDimAllegatiCertificatiImmatricolazione()));
		}
		return jTextFieldTitoloPossesso;
	}
	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonChiudi() {
		if (jButtonChiudi == null) {
			jButtonChiudi = new javax.swing.JButton();
			//jButton.setBounds(657, 476, 126, 34);
			jButtonChiudi.setBounds(
				RealDim.getAbsoluteXValue(657),
				RealDim.getAbsoluteYValue(477),
				RealDim.getAbsoluteXValue(126),
				RealDim.getAbsoluteYValue(34));
			jButtonChiudi.setText("Chiudi");
			jButtonChiudi.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
			jButtonChiudi.addActionListener(this);

		}
		return jButtonChiudi;
	}
	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonStampa() {
		if (jButtonStampa == null) {
			jButtonStampa = new javax.swing.JButton();
			//jButton1.setBounds(524, 476, 126, 34);
			jButtonStampa.setBounds(
				RealDim.getAbsoluteXValue(524),
				RealDim.getAbsoluteYValue(477),
				RealDim.getAbsoluteXValue(126),
				RealDim.getAbsoluteYValue(34));
			jButtonStampa.setText("Stampa");
			jButtonStampa.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonStampa.addActionListener(this);
		}
		return jButtonStampa;
	}
	/**
	 * This method initializes jButton2
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonSave() {
		if (jButtonSave == null) {
			jButtonSave = new javax.swing.JButton();
			//jButton2.setBounds(392, 477, 126, 34);
			jButtonSave.setText("Salva");
			jButtonSave.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
			jButtonSave.setBounds(
				RealDim.getAbsoluteXValue(392),
				RealDim.getAbsoluteYValue(477),
				RealDim.getAbsoluteXValue(126),
				RealDim.getAbsoluteYValue(34));
			jButtonSave.addActionListener(this);
		}
		return jButtonSave;
	}
	/**
	 * This method initializes jButton3
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonSaveAs() {
		if (jButtonSaveAs == null) {
			jButtonSaveAs = new javax.swing.JButton();
			//jButton3.setBounds(260, 477, 126, 34);
			jButtonSaveAs.setBounds(
				RealDim.getAbsoluteXValue(260),
				RealDim.getAbsoluteYValue(477),
				RealDim.getAbsoluteXValue(126),
				RealDim.getAbsoluteYValue(34));
			jButtonSaveAs.setText("Salva Con Nome");
			jButtonSaveAs.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
			jButtonSaveAs.addActionListener(this);
		}
		return jButtonSaveAs;
	}
	/**
	 * This method initializes jPanel33
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel3() {
		if (jPanel3 == null) {
			jPanel3 = new javax.swing.JPanel();
			jPanel3.setLayout(null);

			jPanel3.add(getScrollPane(), null);

			//jPanel3.setBounds(19, 465, 229, 72);
			jPanel3.setBackground(java.awt.Color.lightGray);
			jPanel3.setBorder(
				javax.swing.BorderFactory.createLineBorder(
					java.awt.Color.black,
					1));
			/*				RealDim.getAbsoluteYValue(465),
			*/
			jPanel3.setBounds(
				RealDim.getAbsoluteXValue(20),
				RealDim.getAbsoluteYValue(447),
				RealDim.getAbsoluteXValue(229),
				RealDim.getAbsoluteYValue(65));

		}
		return jPanel3;
	}
	/**
	 * This method initializes jList
	 * 
	 * @return javax.swing.JList
	 */
	private javax.swing.JList getJlistListaQuadri() {
		if (jListListaQuadri == null) {
			//Create a list, overriding the getToolTipText() method
			//String[] items = {"Quadro A - Autoveicoli massa superiore a 3,5 T", "Quadro B - Esercente distributore privato carburante", "Quadro C - Altri automezzi...distributore privato"};
			jListListaQuadri = new javax.swing.JList() {
					// This method is called as the cursor moves within the list.
	public String getToolTipText(MouseEvent evt) {
						// Get item index
	int index = locationToIndex(evt.getPoint());

					// Get item
					Object item = getModel().getElementAt(index);

					// Return the tool tip text
					return item.toString();
				}
			};

			//jListListaQuadri.setBounds(7, 7, 214, 59);

			/*spostato sotto reply
			jListListaQuadri.setBounds(
				RealDim.getAbsoluteXValue(7),
				RealDim.getAbsoluteYValue(7),
				RealDim.getAbsoluteXValue(230),
				RealDim.getAbsoluteYValue(50));
			
			*/

			initQuadri();
			jListListaQuadri.addListSelectionListener(this);
			jListListaQuadri.addMouseListener(this);

		}
		return jListListaQuadri;
	}

	// nuovo metodo reply
	private JScrollPane getScrollPane() {

		/*
		JPanel appoPane = new JPanel();
		FlowLayout appoLayout = new FlowLayout( FlowLayout.LEFT);
		appoLayout.setHgap(1);
		appoLayout.setVgap(5);
		appoPane.setLayout( appoLayout );
		appoPane.add( getJlistListaQuadri() );
		*/
		if (scrollPane == null) {

			scrollPane =
				new JScrollPane(
					getJlistListaQuadri(),
					JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
					JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			scrollPane.setBounds(
				RealDim.getAbsoluteXValue(7),
				RealDim.getAbsoluteYValue(7),
				RealDim.getAbsoluteXValue(214),
				RealDim.getAbsoluteYValue(50));

		}

		return scrollPane;

	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JScrollPane getJPanel4() {
		
		
		JScrollPane jc = new JScrollPane(getJPanel5());	
		jc.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
		
		
		return jc;
	}

	//------------------------------------metodi aggiunti reply-----------------------------------------------------------------------

	private JLabel getJLabelDate1() {

		if (jLabelDate1 == null) {
			jLabelDate1 = new javax.swing.JLabel();
			jLabelDate1.setBounds(
				RealDim.getAbsoluteXValue(5),
				RealDim.getAbsoluteYValue(10),
				RealDim.getAbsoluteXValue(170),
				RealDim.getAbsoluteYValue(30));
			//modifica 05/08/2008 modifica periodo di riferimento quadro A-1
			//jLabelDate1.setText(" Dal 1 gennaio al 31 Dicembre 2007 ");
			jLabelDate1.setText("1) Dal 1 gennaio al 31 Maggio");
		}
		return jLabelDate1;

	}

	private javax.swing.JLabel getJLabelLitriConsumati() {

		if (jLabelLitriConsumati == null) {
			jLabelLitriConsumati = new javax.swing.JLabel();
			jLabelLitriConsumati.setBounds(
				RealDim.getAbsoluteXValue(10),
				RealDim.getAbsoluteYValue(25),
				RealDim.getAbsoluteXValue(132),
				RealDim.getAbsoluteYValue(45));
			jLabelLitriConsumati.setText("Litri consumati");
		}
		return jLabelLitriConsumati;

	}
	
	
	private javax.swing.JLabel getJLabelAlertPerc() {

		if (jLabelAlertPerc == null) {
			jLabelAlertPerc = new javax.swing.JLabel();
			jLabelAlertPerc.setBounds(
				RealDim.getAbsoluteXValue(10),
				RealDim.getAbsoluteYValue(25),
				RealDim.getAbsoluteXValue(132),
				RealDim.getAbsoluteYValue(45));
			//jLabelAlertPerc.setText("A partire ");
		}
		return jLabelAlertPerc;

	}

	protected JTextField getJTextFieldLitriConsumatiA1() {

		if (jTextFieldLitriConsumatiA1 == null) {

			jTextFieldLitriConsumatiA1 = new JTextField();
			jTextFieldLitriConsumatiA1.setHorizontalAlignment(JTextField.RIGHT);
			//jTextFieldLitriConsumatiA1.setBounds(404, 216, 259, 19);
			//jTextFieldLitriConsumatiA1.setEditable(false);
			//jTextFieldLitriConsumatiA1.setEnabled(false);
			jTextFieldLitriConsumatiA1.setBorder(BorderFactory.createLineBorder(Color.GRAY));
			jTextFieldLitriConsumatiA1
				.setBounds(
					RealDim.getAbsoluteXValue(115),
					RealDim.getAbsoluteYValue(40),
					RealDim.getAbsoluteXValue(54),
					RealDim.getAbsoluteYValue(19)
			//altezza
			);

			jTextFieldLitriConsumatiA1.setDocument(
				new StringDocument(
					Frontespizio.getDimTotaleLitriConsumatiA1()));
			jTextFieldLitriConsumatiA1.addFocusListener(this);
		}

		return jTextFieldLitriConsumatiA1;
	}

	private javax.swing.JLabel getJLabelImportoAcredito() {

		if (jLabelImportoAcredito == null) {
			jLabelImportoAcredito = new javax.swing.JLabel();
			jLabelImportoAcredito.setBounds(
				RealDim.getAbsoluteXValue(209),
				RealDim.getAbsoluteYValue(40),
				RealDim.getAbsoluteXValue(136),
				RealDim.getAbsoluteYValue(15));
			jLabelImportoAcredito.setText("Importo a credito");
		}
		return jLabelImportoAcredito;

	}

	protected JTextField getJTextFieldACreditoA1() {
		if (jTextFieldACreditoA1 == null) {
			jTextFieldACreditoA1 = new JTextField();
			jTextFieldACreditoA1.setHorizontalAlignment(JTextField.RIGHT);
			jTextFieldACreditoA1.setBorder(BorderFactory.createLineBorder(Color.GRAY));
			jTextFieldACreditoA1.setBounds(
				RealDim.getAbsoluteXValue(320),
				RealDim.getAbsoluteYValue(40),
				RealDim.getAbsoluteXValue(136),
				RealDim.getAbsoluteYValue(19));
			jTextFieldACreditoA1.setDocument(
				new BigDecimalDocument(
					Frontespizio.getDimImportoAcreditoA1Int(),
					Frontespizio.getDimImportoAcreditoA1Dec()));
			jTextFieldACreditoA1.addFocusListener(this);
		}
		return jTextFieldACreditoA1;
	}

	private JLabel getJLabelDate2() {

		if (jLabelDate2 == null) {
			jLabelDate2 = new javax.swing.JLabel();

			jLabelDate2.setBounds(
				RealDim.getAbsoluteXValue(5),
				RealDim.getAbsoluteYValue(60),
				RealDim.getAbsoluteXValue(145),
				RealDim.getAbsoluteYValue(15));
			//modifica 05/08/2008 modifica periodo di riferimento quadro A-2
			//jLabelDate2.setText(""/*"2) Dal 3 ottobre al 31 dicembre"*/);
			jLabelDate2.setText("2) Dal 1 giugno al 31 dicembre");
		}
		return jLabelDate2;

	}

	private javax.swing.JLabel getJLabelLitriConsumati2() {

		if (jLabelLitriConsumati2 == null) {
			jLabelLitriConsumati2 = new javax.swing.JLabel();

			jLabelLitriConsumati2.setBounds(
				RealDim.getAbsoluteXValue(10),
				RealDim.getAbsoluteYValue(80),
				RealDim.getAbsoluteXValue(132),
				RealDim.getAbsoluteYValue(19));
			//modifica 05/08/2008 litri consumati quadro A-2 abilitato
			//jLabelLitriConsumati2.setEnabled(false);
			jLabelLitriConsumati2.setText("Litri consumati");
		}
		return jLabelLitriConsumati2;

	}

	protected JTextField getJTextFieldLitriConsumatiA2() {

		if (jTextFieldLitriConsumatiA2 == null) {

			jTextFieldLitriConsumatiA2 = new JTextField();
			jTextFieldLitriConsumatiA2.setHorizontalAlignment(JTextField.RIGHT);
			//jTextFieldLitriConsumatiA1.setBounds(404, 216, 259, 19);
			//jTextFieldLitriConsumatiA2.setEditable(false);
			//jTextFieldLitriConsumatiA2.setEnabled(false);
			jTextFieldLitriConsumatiA2.setBounds(
				RealDim.getAbsoluteXValue(115),
				RealDim.getAbsoluteYValue(80),
				RealDim.getAbsoluteXValue(54),
				RealDim.getAbsoluteYValue(19));
			jTextFieldLitriConsumatiA2.setDocument(
				new StringDocument(
					Frontespizio.getDimTotaleLitriConsumatiA2()));
			jTextFieldLitriConsumatiA2.addFocusListener(this);
			if (!VisualConfig.DATI_CONTABILI_LITRI_CONSUMATI_2_ENABLED) {
				jTextFieldLitriConsumatiA2.setEnabled(false);
				jTextFieldLitriConsumatiA2.setEditable(false);
			}
		}
		return jTextFieldLitriConsumatiA2;
	}

	private javax.swing.JLabel getJLabelImportoAcredito2() {

		if (jLabelImportoAcredito2 == null) {
			jLabelImportoAcredito2 = new javax.swing.JLabel();
			jLabelImportoAcredito2.setBounds(
				RealDim.getAbsoluteXValue(209),
				RealDim.getAbsoluteYValue(80),
				RealDim.getAbsoluteXValue(132),
				RealDim.getAbsoluteYValue(15));
			//modifica 05/08/2008 importo a credito quadro A-2 abilitato
			//jLabelImportoAcredito2.setEnabled(false);	
			jLabelImportoAcredito2.setText("Importo a credito");
		}
		return jLabelImportoAcredito2;
	}

	protected JTextField getJTextFieldACreditoA2() {
		if (jTextFieldACreditoA2 == null) {
			jTextFieldACreditoA2 = new JTextField();
			jTextFieldACreditoA2.setHorizontalAlignment(JTextField.RIGHT);
			jTextFieldACreditoA2.setBounds(
				RealDim.getAbsoluteXValue(320),
				RealDim.getAbsoluteYValue(80),
				RealDim.getAbsoluteXValue(136),
				RealDim.getAbsoluteYValue(19));
			jTextFieldACreditoA2.setDocument(
				new BigDecimalDocument(
					Frontespizio.getDimImportoAcreditoA2Int(),
					Frontespizio.getDimImportoAcreditoA2Dec()));
			jTextFieldACreditoA2.addFocusListener(this);
			if (!VisualConfig.DATI_CONTABILI_IMPORTO_A_CREDITO_2_ENABLED) {
				// FHF				
				jTextFieldACreditoA2.setEnabled(false);
				jTextFieldACreditoA2.setEditable(false);
			}
		}
		return jTextFieldACreditoA2;
	}

	//------------------------------------fine----------------------------------------
	
	
	/******************new********************/
	
	private JLabel getJLabelDate2_new(int a,int b,int c, int d) {

			
				jLabelDate2 = new javax.swing.JLabel();

				jLabelDate2.setBounds(
					RealDim.getAbsoluteXValue(a),
					RealDim.getAbsoluteYValue(b),
					RealDim.getAbsoluteXValue(c),
					RealDim.getAbsoluteYValue(d));
				//modifica 05/08/2008 modifica periodo di riferimento quadro A-2
				//jLabelDate2.setText(""/*"2) Dal 3 ottobre al 31 dicembre"*/);
				jLabelDate2.setText("2) Dal 1 giugno al 31 dicembre");
			
			return jLabelDate2;

		}
		
		
	private void setJLabelDatePosition(JLabel label, int x,int y,int width,int height) {

			
				

			label.setBounds(
					RealDim.getAbsoluteXValue(x),
					RealDim.getAbsoluteYValue(y),
					RealDim.getAbsoluteXValue(width),
					RealDim.getAbsoluteYValue(height));
				
			
			

		}
		
	private void initJLabel(JLabel label,String text, int x,int y,int width,int height) {				

			label.setBounds(
					RealDim.getAbsoluteXValue(x),
					RealDim.getAbsoluteYValue(y),
					RealDim.getAbsoluteXValue(width),
					RealDim.getAbsoluteYValue(height));
				
			label.setText(text);
			

		}
		
		private void initJRadioButton(JRadioButton radioButton,ButtonGroup group,String text, boolean selected, int x,int y,int width,int height) {				
			
			radioButton.setBounds(
				RealDim.getAbsoluteXValue(x),
				RealDim.getAbsoluteYValue(y),
				RealDim.getAbsoluteXValue(width),
				RealDim.getAbsoluteYValue(height));
			radioButton.setText(text);
			radioButton.setSelected(selected);
			group.add(radioButton);
			

		}
		
		
		private void initJTextField(JTextField textField, Object[]proprieta) {				

			int indice = 0;
			
			int x = ((Integer)proprieta[indice++]).intValue();
			int y= ((Integer)proprieta[indice++]).intValue();
			int width= ((Integer)proprieta[indice++]).intValue();
			int height= ((Integer)proprieta[indice++]).intValue();
			int alignment= ((Integer)proprieta[indice++]).intValue();
			boolean enabled=((Boolean)proprieta[indice++]).booleanValue();
			boolean editable= ((Boolean)proprieta[indice++]).booleanValue();
			Color color = ((Color)proprieta[indice++]);
			Border border  = ((Border)proprieta[indice++]);
			Document document  = ((Document)proprieta[indice++]);
			
			if(alignment != -1)
				textField.setHorizontalAlignment(alignment);
				
			textField.setEnabled(enabled);	
			textField.setEditable(editable);
			if(color != null )
				textField.setBackground(color);
			if(border != null)
				textField.setBorder(border);
			if(document != null)
				textField.setDocument(document);
			
			textField.setBounds(
				RealDim.getAbsoluteXValue(x),
				RealDim.getAbsoluteYValue(y),
				RealDim.getAbsoluteXValue(width),
				RealDim.getAbsoluteYValue(height));
					
			
	}
		
		
		

		private javax.swing.JLabel getJLabelLitriConsumatiParametrico(int x,int y,int width, int height) {

			
				jLabelLitriConsumati2 = new javax.swing.JLabel();

				jLabelLitriConsumati2.setBounds(
					RealDim.getAbsoluteXValue(x),
					RealDim.getAbsoluteYValue(y),
					RealDim.getAbsoluteXValue(width),
					RealDim.getAbsoluteYValue(height));
				//modifica 05/08/2008 litri consumati quadro A-2 abilitato
				//jLabelLitriConsumati2.setEnabled(false);
				jLabelLitriConsumati2.setText("Litri consumati");
			
			return jLabelLitriConsumati2;

		}

		protected void setJTextFieldLitriConsumati(JTextField textField, int x,int y,int width,int height) {

							
				textField.setHorizontalAlignment(JTextField.RIGHT);			
				textField.setBounds(
					RealDim.getAbsoluteXValue(x),
					RealDim.getAbsoluteYValue(y),
					RealDim.getAbsoluteXValue(width),
					RealDim.getAbsoluteYValue(height));
			textField.setDocument(
					new BigIntegerDocument(
						Frontespizio.getDimTotaleLitriConsumatiA2()));
			textField.addFocusListener(this);
				if (!VisualConfig.DATI_CONTABILI_LITRI_CONSUMATI_2_ENABLED) {
					textField.setEnabled(false);
					textField.setEditable(false);
				}
			
			
		}

		private javax.swing.JLabel getJLabelImportoAcreditoParametrico(int x,int y,int width,int height) {

			
				jLabelImportoAcredito2 = new javax.swing.JLabel();
				jLabelImportoAcredito2.setBounds(
					RealDim.getAbsoluteXValue(x),
					RealDim.getAbsoluteYValue(y),
					RealDim.getAbsoluteXValue(width),
					RealDim.getAbsoluteYValue(height));
				//modifica 05/08/2008 importo a credito quadro A-2 abilitato
				//jLabelImportoAcredito2.setEnabled(false);	
				jLabelImportoAcredito2.setText("Importo a credito");
			
			return jLabelImportoAcredito2;
		}

		protected void setJTextFieldACredito(JTextField textField, int x,int y,int width,int height) {
			
				
			textField.setHorizontalAlignment(JTextField.RIGHT);
			textField.setBounds(
					RealDim.getAbsoluteXValue(x),
					RealDim.getAbsoluteYValue(y),
					RealDim.getAbsoluteXValue(width),
					RealDim.getAbsoluteYValue(height));
			textField.setDocument(
					new BigDecimalDocument(
						Frontespizio.getDimImportoAcreditoA2Int(),
						Frontespizio.getDimImportoAcreditoA2Dec()));
			textField.addFocusListener(this);
				if (!VisualConfig.DATI_CONTABILI_IMPORTO_A_CREDITO_2_ENABLED) {
					// FHF				
					textField.setEnabled(false);
					textField.setEditable(false);
				}
			
			
		}
	
	
	
	
	/******************************new**********************/
	
	
	

	/**
	 * This method initializes jLabel28
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel28() {
		/*if (jLabel28 == null) {
			jLabel28 = new javax.swing.JLabel();
			//	jLabel28.setBounds(0, 137, 132, 15);
			jLabel28.setBounds(
				RealDim.getAbsoluteXValue(10),
				RealDim.getAbsoluteYValue(y),
				RealDim.getAbsoluteXValue(132),
				RealDim.getAbsoluteYValue(15));
			jLabel28.setText("Totale Litri Consumati");
		}*/
		return jLabel28;
	}

	/**
	 * This method initializes jTextFieldTOTLitriConsumati
	 * 
	 * @return javax.swing.JTextField
	 */
	protected javax.swing.JTextField getJTextFieldTOTLitriConsumati() {
		/*if (jTextFieldTOTLitriConsumati == null) {
			jTextFieldTOTLitriConsumati = new javax.swing.JTextField();
			jTextFieldTOTLitriConsumati.setHorizontalAlignment(JTextField.RIGHT);
			jTextFieldTOTLitriConsumati.setEditable(false);
			jTextFieldTOTLitriConsumati.setBackground(Color.WHITE);
			jTextFieldTOTLitriConsumati.setBorder(BorderFactory.createLineBorder(Color.GRAY));
			//jTextFieldTOTLitriConsumati.setBounds(142, 134, 54, 19);
			//jTextFieldTOTLitriConsumati.setEditable(false);
			jTextFieldTOTLitriConsumati.setBounds(
				RealDim.getAbsoluteXValue(115),
				RealDim.getAbsoluteYValue(120),
				RealDim.getAbsoluteXValue(54),
				RealDim.getAbsoluteYValue(19));
			jTextFieldTOTLitriConsumati.setDocument(
				new BigIntegerDocument(
					Frontespizio.getDimTotaleLitriCconsumati()));
			//jTextFieldTOTLitriConsumati.addFocusListener(this);
		}*/
		return jTextFieldTOTLitriConsumati;
	}

	/**
	 * This method initializes jLabel29
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel29() {
		/*if (jLabel29 == null) {
			jLabel29 = new javax.swing.JLabel();
			//jLabel29.setBounds(209, 136, 136, 15);
			jLabel29.setBounds(
				RealDim.getAbsoluteXValue(209),
				RealDim.getAbsoluteYValue(120),
				RealDim.getAbsoluteXValue(136),
				RealDim.getAbsoluteYValue(15));
			jLabel29.setText("Totale Importo a Credito");
		}*/
		return jLabel29;
	}
	/**
	 * This method initializes jTextFieldTOTACredito
	 * 
	 * @return javax.swing.JTextField
	 */
	protected javax.swing.JTextField getJTextFieldTOTACredito() {
		/*if (jTextFieldTOTACredito == null) {
			jTextFieldTOTACredito = new javax.swing.JTextField();
			jTextFieldTOTACredito.setHorizontalAlignment(JTextField.RIGHT);
			jTextFieldTOTACredito.setEditable(false);
			jTextFieldTOTACredito.setBackground(Color.WHITE);
			jTextFieldTOTACredito.setBorder(BorderFactory.createLineBorder(Color.GRAY));
			//jTextFieldTOTACredito.setBounds(355, 134, 144, 19);
			//jTextFieldTOTACredito.setEditable(false);
			jTextFieldTOTACredito.setBounds(
				RealDim.getAbsoluteXValue(320),
				RealDim.getAbsoluteYValue(120),
				RealDim.getAbsoluteXValue(136),
				RealDim.getAbsoluteYValue(19));
			jTextFieldTOTACredito.setDocument(
				new BigDecimalDocument(
					Frontespizio.getDimTotaleImportCreditoInt(),
					Frontespizio.getDimTotaleImportCreditoDec()));
			jTextFieldTOTACredito.addFocusListener(this);
		}*/
		return jTextFieldTOTACredito;
	}
	/**
	 * This method initializes jRadioButtonEuro
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButtonEuro() {
		/*if (jRadioButtonEuro == null) {
			jRadioButtonEuro = new javax.swing.JRadioButton();
			//jRadioButtonEuro.setBounds(504, 132, 51, 23);
			jRadioButtonEuro.setBounds(
				RealDim.getAbsoluteXValue(504),
				RealDim.getAbsoluteYValue(120),
				RealDim.getAbsoluteXValue(51),
				RealDim.getAbsoluteYValue(23));
			jRadioButtonEuro.setText("Euro");
			jRadioButtonEuro.setSelected(true);
			buttonGroupValuta.add(jRadioButtonEuro);
		}*/
		return jRadioButtonEuro;
	}
	/**
	 * This method initializes jRadioButtonLire
	 * 
	 * @return javax.swing.JRadioButton
	 */
	//modifica 27/08/2008 radio button Lire non pi utilizzato
	private javax.swing.JRadioButton getJRadioButtonLire() {
		if (jRadioButtonLire == null) {
			jRadioButtonLire = new javax.swing.JRadioButton();
			//jRadioButtonLire.setBounds(555, 132, 47, 23);
			jRadioButtonLire.setBounds(
				RealDim.getAbsoluteXValue(555),
				RealDim.getAbsoluteYValue(120),
				RealDim.getAbsoluteXValue(47),
				RealDim.getAbsoluteYValue(23));
			jRadioButtonLire.setText("Lire");
			buttonGroupValuta.add(jRadioButtonLire);

		}
		return jRadioButtonLire;
	}

	/**
	 * This method initializes jTextFieldCCP
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldCCP() {
		/*if (jTextFieldCCP == null) {
			jTextFieldCCP = new javax.swing.JTextField();
			//7jTextFieldCCP.setBounds(404, 216, 259, 19);
			jTextFieldCCP.setEditable(false);
			jTextFieldCCP.setEnabled(false);
			jTextFieldCCP.setBounds(
				RealDim.getAbsoluteXValue(318),
				RealDim.getAbsoluteYValue(216),
				RealDim.getAbsoluteXValue(259),
				RealDim.getAbsoluteYValue(19));
			jTextFieldCCP.setDocument(
				new StringDocument(Frontespizio.getDimPostaContoCorrente()));
		}*/
		return jTextFieldCCP;
	}

	private javax.swing.JLabel getJLabel32() {
		/*if (jLabel32 == null) {
			jLabel32 = new javax.swing.JLabel();
			//	jLabel32.setBounds(115, 194, 155, 16);
			jLabel32.setBounds(
				RealDim.getAbsoluteXValue(101),
				RealDim.getAbsoluteYValue(194),
				RealDim.getAbsoluteXValue(155),
				RealDim.getAbsoluteYValue(16));
			jLabel32.setText("( Coordinate Bancarie Nazionali");
			jLabel32.setFont(
				new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
			jLabel32.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
		}*/
		return jLabel32;
	}
	/**
	 * This method initializes jLabel33
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel33() {
		/*if (jLabel33 == null) {
			jLabel33 = new javax.swing.JLabel();
			//jLabel33.setBounds(278, 194, 42, 16);
			jLabel33.setBounds(
				RealDim.getAbsoluteXValue(264),
				RealDim.getAbsoluteYValue(194),
				RealDim.getAbsoluteXValue(42),
				RealDim.getAbsoluteYValue(16));
			jLabel33.setText("Cod. ABI");
			jLabel33.setFont(
				new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
		}*/
		return jLabel33;
	}
	/**
	 * This method initializes jTextFieldIban
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldIban() {
		/*if (jTextFieldIban == null) {
			jTextFieldIban = new javax.swing.JTextField();
			//jTextFieldIban.setBounds(328, 241, 241, 19);
			jTextFieldIban.setEnabled(false);
			jTextFieldIban.setEditable(false);
			jTextFieldIban.setBounds(
				RealDim.getAbsoluteXValue(318),
				RealDim.getAbsoluteYValue(241),
				RealDim.getAbsoluteXValue(120),
				RealDim.getAbsoluteYValue(19));
			jTextFieldIban.setDocument(
				//modifica 07/08/2008 modifica dimensione IBAN da 20 a 27
				//new StringDocument(Frontespizio.getDimBancaContoCorrente()));
				new StringDocument(Frontespizio.getDimIban()));
		}*/
		return jTextFieldIban;
	}
	/**
	 * This method initializes jLabel34
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel34() {
		/*if (jLabel34 == null) {
			jLabel34 = new javax.swing.JLabel();
			//jLabel34.setBounds(420, 194, 46, 13);
			jLabel34.setBounds(
				RealDim.getAbsoluteXValue(420),
				RealDim.getAbsoluteYValue(194),
				RealDim.getAbsoluteXValue(46),
				RealDim.getAbsoluteYValue(13));
			jLabel34.setText("Cod. CAB");
			jLabel34.setFont(
				new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
		}*/
		return jLabel34;
	}
	/**
	 * This method initializes jTextFieldBIC
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldBIC() {
		/*if (jTextFieldBIC == null) {
			jTextFieldBIC = new javax.swing.JTextField();
			//jTextFieldBIC.setBounds(572, 241, 86, 19);
			jTextFieldBIC.setEnabled(false);
			jTextFieldBIC.setEditable(false);
			jTextFieldBIC.setBounds(
				RealDim.getAbsoluteXValue(488),
				RealDim.getAbsoluteYValue(241),
				RealDim.getAbsoluteXValue(89),
				RealDim.getAbsoluteYValue(19));
			jTextFieldBIC.setDocument(
				new StringDocument(Frontespizio.getDimPostaContoCorrente()));
		}*/
		return jTextFieldBIC;
	}
	/**
	 * This method initializes jLabel35
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel35() {
		/*if (jLabel35 == null) {
			jLabel35 = new javax.swing.JLabel();
			//jLabel35.setBounds(554, 194, 32, 13);
			jLabel35.setBounds(
				RealDim.getAbsoluteXValue(558),
				RealDim.getAbsoluteYValue(194),
				RealDim.getAbsoluteXValue(32),
				RealDim.getAbsoluteYValue(13));
			jLabel35.setText("C/C N.");
			jLabel35.setFont(
				new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
		}*/
		return jLabel35;
	}
	/**
	 * This method initializes jTextFieldCCN
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldCCN() {
		/*if (jTextFieldCCN == null) {
			jTextFieldCCN = new javax.swing.JTextField();
			//jTextFieldCCN.setBounds(593, 192, 81, 19);
			jTextFieldCCN.setEnabled(false);
			jTextFieldCCN.setEditable(false);
			jTextFieldCCN.setBounds(
				RealDim.getAbsoluteXValue(593),
				RealDim.getAbsoluteYValue(192),
				RealDim.getAbsoluteXValue(81),
				RealDim.getAbsoluteYValue(19));
			jTextFieldCCN.setDocument(
				new StringDocument(Frontespizio.getDimBancaContoCorrente()));
		}*/
		return jTextFieldCCN;
	}
	/**
	 * This method initializes jLabel36
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel36() {
		if (jLabel36 == null) {
			jLabel36 = new javax.swing.JLabel();
			jLabel36.setBounds(673, 189, 9, 23);
			jLabel36.setBounds(
				RealDim.getAbsoluteXValue(673),
				RealDim.getAbsoluteYValue(189),
				RealDim.getAbsoluteXValue(9),
				RealDim.getAbsoluteYValue(23));
			jLabel36.setText(" )");
			jLabel36.setFont(
				new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
		}
		return jLabel36;
	}
	/**
	 * This method initializes jRadioButtonCoordinatePostaliNaz
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButtonCoordinatePostaliNaz() {

		/*if (jRadioButtonCoordinatePostaliNaz == null) {
			jRadioButtonCoordinatePostaliNaz = new javax.swing.JRadioButton();
			//jRadioButtonCoordinatePostaliNaz.setBounds(679, 216, 21, 21);
			jRadioButtonCoordinatePostaliNaz.setBounds(
				RealDim.getAbsoluteXValue(679),
				RealDim.getAbsoluteYValue(216),
				RealDim.getAbsoluteXValue(21),
				RealDim.getAbsoluteYValue(21));
			jRadioButtonCoordinatePostaliNaz.addActionListener(this);
			buttonGroupDatiContabili.add(jRadioButtonCoordinatePostaliNaz);
		}*/
		return jRadioButtonCoordinatePostaliNaz;
	}
	/**
	 * This method initializes jLabel37
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelCoordinatePostaliNazionali() {
		/*if (jLabel37 == null) {
			jLabel37 = new javax.swing.JLabel();
			//jLabel37.setBounds(114, 219, 142, 13);
			jLabel37.setBounds(
				RealDim.getAbsoluteXValue(107),
				RealDim.getAbsoluteYValue(219),
				RealDim.getAbsoluteXValue(142),
				RealDim.getAbsoluteYValue(13));
			jLabel37.setText("( Coordinate Postali Nazionali");
			jLabel37.setFont(
				new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
			jLabel37.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			jLabel37.setHorizontalTextPosition(
				javax.swing.SwingConstants.RIGHT);
		}*/
		return jLabel37;
	}
	/**
	 * This method initializes jLabel38
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel38() {
		/*if (jLabel38 == null) {
			jLabel38 = new javax.swing.JLabel();
			//jLabel38.setBounds(265, 219, 134, 13);
			jLabel38.setBounds(
				RealDim.getAbsoluteXValue(264),
				RealDim.getAbsoluteYValue(219),
				RealDim.getAbsoluteXValue(134),
				RealDim.getAbsoluteYValue(13));
			jLabel38.setText("C/C Postale N");
			jLabel38.setFont(
				new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
		}*/
		return jLabel38;
	}
	/**
	 * This method initializes jTextFieldCodABI
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldCodABI() {
		/*if (jTextFieldCodABI == null) {
			jTextFieldCodABI = new javax.swing.JTextField();
			//jTextFieldCodABI.setBounds(328, 192, 85, 19);
			jTextFieldCodABI.setEnabled(false);
			jTextFieldCodABI.setEditable(false);
			jTextFieldCodABI.setBounds(
				RealDim.getAbsoluteXValue(318),
				RealDim.getAbsoluteYValue(192),
				RealDim.getAbsoluteXValue(85),
				RealDim.getAbsoluteYValue(19));
			jTextFieldCodABI.setDocument(
				new BigIntegerDocument(Frontespizio.getDimBancaABI()));
		}*/
		return jTextFieldCodABI;
	}
	/**
	 * This method initializes jLabel39
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel39() {
		/*if (jLabel39 == null) {
			jLabel39 = new javax.swing.JLabel();
			//jLabel39.setBounds(658, 242, 9, 19);
			jLabel39.setBounds(
				RealDim.getAbsoluteXValue(658),
				RealDim.getAbsoluteYValue(242),
				RealDim.getAbsoluteXValue(20),
				RealDim.getAbsoluteYValue(22));
			jLabel39.setText("       )");
			jLabel39.setFont(
				new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
			jLabel39.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}*/
		return jLabel39;
	}
	/**
	 * This method initializes jRadioButtonCoordinateBancarieEuropee
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax
		.swing
		.JRadioButton getJRadioButtonCoordinateBancarieEuropee() {
		/*if (jRadioButtonCoordinateBancarieEuropee == null) {
			jRadioButtonCoordinateBancarieEuropee =
				new javax.swing.JRadioButton();
			//jRadioButtonCoordinatePostaliNaz.setBounds(678, 126, 21, 21);
			jRadioButtonCoordinateBancarieEuropee.setBounds(
				RealDim.getAbsoluteXValue(679),
				RealDim.getAbsoluteYValue(126),
				RealDim.getAbsoluteXValue(21),
				RealDim.getAbsoluteYValue(21));
			buttonGroupDatiContabili.add(jRadioButtonCoordinateBancarieEuropee);
		}*/
		return jRadioButtonCoordinateBancarieEuropee;
	}
	/**
	 * This method initializes jLabel40
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelCoordinateBancarieEuropee() {
		/*if (jLabel40 == null) {
			jLabel40 = new javax.swing.JLabel();
			//	jLabel40.setBounds(113, 245, 150, 13);
			jLabel40.setBounds(
				RealDim.getAbsoluteXValue(111),
				RealDim.getAbsoluteYValue(245),
				RealDim.getAbsoluteXValue(142),
				RealDim.getAbsoluteYValue(13));
			jLabel40.setText("( Coordinate Bancarie Europee");
			jLabel40.setFont(
				new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
			jLabel40.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			jLabel40.setHorizontalTextPosition(
				javax.swing.SwingConstants.RIGHT);
		}*/
		return jLabel40;
	}
	/**
	 * This method initializes jLabel41
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel41() {
		/*if (jLabel41 == null) {
			jLabel41 = new javax.swing.JLabel();
			//jLabel41.setBounds(264, 245, 24, 13);
			jLabel41.setBounds(
				RealDim.getAbsoluteXValue(264),
				RealDim.getAbsoluteYValue(245),
				RealDim.getAbsoluteXValue(24),
				RealDim.getAbsoluteYValue(13));
			jLabel41.setText("IBAN");
			jLabel41.setFont(
				new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
		}*/
		return jLabel41;
	}
	/**
	 * This method initializes jTextFieldCodCAB
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldCodCAB() {
		/*if (jTextFieldCodCAB == null) {
			jTextFieldCodCAB = new javax.swing.JTextField();
			//jTextFieldCodCAB.setBounds(474, 192, 73, 19);
			jTextFieldCodCAB.setEditable(false);
			jTextFieldCodCAB.setEnabled(false);
			jTextFieldCodCAB.setBounds(
				RealDim.getAbsoluteXValue(474),
				RealDim.getAbsoluteYValue(192),
				RealDim.getAbsoluteXValue(73),
				RealDim.getAbsoluteYValue(19));
			jTextFieldCodCAB.setDocument(
				new BigIntegerDocument(Frontespizio.getDimBancaCAB()));
		}*/
		return jTextFieldCodCAB;
	}
	/**
	 * This method initializes jLabel42
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel42() {
		/*if (jLabel42 == null) {
			jLabel42 = new javax.swing.JLabel();
			//jLabel42.setBounds(543, 245, 26, 13);
			jLabel42.setBounds(
				RealDim.getAbsoluteXValue(455),
				RealDim.getAbsoluteYValue(245),
				RealDim.getAbsoluteXValue(26),
				RealDim.getAbsoluteYValue(13));
			jLabel42.setText("BIC");
			jLabel42.setFont(
				new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
		}*/
		return jLabel42;
	}

	/**
	 * This method initializes jLabel43
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel43() {
		/*if (jLabel43 == null) {
			jLabel43 = new javax.swing.JLabel();
			//jLabel43.setBounds(662, 216, 17, 22);
			jLabel43.setBounds(
				RealDim.getAbsoluteXValue(662),
				RealDim.getAbsoluteYValue(216),
				RealDim.getAbsoluteXValue(17),
				RealDim.getAbsoluteYValue(22));
			jLabel43.setText("     )");
			jLabel43.setFont(
				new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
			jLabel43.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}*/
		return jLabel43;
	}
	/**
	 * This method initializes jRadioButton7
	 * 
	 * @return javax.swing.JRadioButton
	 */

	/**
	 * This method initializes jRadioButtonCoordinateBancarieEuropee
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButton62() {
		/*if (jRadioButtonCoordinateBancarieEuropee == null) {
			jRadioButtonCoordinateBancarieEuropee =
				new javax.swing.JRadioButton();
			buttonGroupDatiContabili.add(jRadioButtonCoordinateBancarieEuropee);
			//jRadioButtonCoordinateBancarieEuropee.setBounds(679, 241, 18, 21);
			jRadioButtonCoordinateBancarieEuropee.addActionListener(this);
			jRadioButtonCoordinateBancarieEuropee.setBounds(
				RealDim.getAbsoluteXValue(679),
				RealDim.getAbsoluteYValue(241),
				RealDim.getAbsoluteXValue(18),
				RealDim.getAbsoluteYValue(21));
		}*/
		return jRadioButtonCoordinateBancarieEuropee;
	}
	/**
	 * This method initializes jPanel5
	 * E' il pannello dei dati contabili
	 * @return javax.swing.JPanel
	 */


	private javax.swing.JPanel getJPanel5_old() {
		if (jPanel5 == null) {
			/*jPanel5 = new javax.swing.JPanel();
			jPanel5.setLayout(null);

			// aggiunti reply
			jPanel5.add(getJLabelDate1());
			jPanel5.add(getJLabelLitriConsumati());
			jPanel5.add(getJTextFieldLitriConsumatiA1());
			jPanel5.add(getJLabelImportoAcredito());
			jPanel5.add(getJTextFieldACreditoA1());
			jPanel5.add(getJLabelDate2());
			jPanel5.add(getJLabelLitriConsumati2());
			jPanel5.add(getJTextFieldLitriConsumatiA2());
			jPanel5.add(getJLabelImportoAcredito2());
			jPanel5.add(getJTextFieldACreditoA2());
			//fine

			jPanel5.add(getJLabel28(), null);
			jPanel5.add(getJTextFieldTOTLitriConsumati(), null);
			jPanel5.add(getJLabel29(), null);
			jPanel5.add(getJTextFieldTOTACredito(), null);
			jPanel5.add(getJRadioButtonEuro(), null);
			//modifica 27/08/2008 eliminare il radio button Lire
			//jPanel5.add(getJRadioButtonLire(), null);
			jPanel5.add(getJRadioButton62(), null);
			jPanel5.add(getJRadioButtonCoordinatePostaliNaz(), null);
			jPanel5.add(getJLabel43(), null);
			jPanel5.add(getJLabel36(), null);
			jPanel5.add(getJLabel39(), null);
			jPanel5.add(getJTextFieldBIC(), null);
			jPanel5.add(getJTextFieldCCP(), null);
			jPanel5.add(getJTextFieldCCN(), null);
			jPanel5.add(getJLabel35(), null);
			jPanel5.add(getJTextFieldCodCAB(), null);
			jPanel5.add(getJLabel34(), null);
			jPanel5.add(getJTextFieldIban(), null);
			jPanel5.add(getJLabel42(), null);
			jPanel5.add(getJLabelCoordinateBancarieEuropee(), null);
			jPanel5.add(getJLabel41(), null);
			jPanel5.add(getJLabel38(), null);
			jPanel5.add(getJLabelCoordinatePostaliNazionali(), null);
			jPanel5.add(getJLabel32(), null);
			jPanel5.add(getJLabel33(), null);
			jPanel5.add(getJTextFieldCodABI(), null);
			jPanel5.add(getJLabel30(), null);
			jPanel5.add(getJLabel18(), null);
			jPanel5.add(getJLabel19(), null);
			jPanel5.add(getJRadioButtonCoordinateBancarieNaz(), null);
			jPanel5.add(getJRadioButtonModalitaPrescelta(), null);
			jPanel5.add(getJPanelOpzionePeriodo(), null);
			//jPanel5.setBounds(3, 4, 738, 266);
			jPanel5.setBounds(
				RealDim.getAbsoluteXValue(3),
				RealDim.getAbsoluteYValue(4),
				RealDim.getAbsoluteXValue(738),
				RealDim.getAbsoluteYValue(266));
			jPanel5.setBorder(
				javax.swing.BorderFactory.createLineBorder(
					java.awt.Color.black,
					1));*/
		}
		return jPanel5;
	}
	
	private javax.swing.JPanel getJPanel5() {
			
				JPanel jPanel5 = new javax.swing.JPanel();
				jPanel5.setLayout(null);
				
				int coordinataY = 0;
				int altezzaPanel = 0;	
				
				int firstX = 185;//145
				int secondX = 290;//250					
		
				jPanel5.add(getJLabelLitriConsumatiParametrico(firstX,coordinataY,132,45));
				jPanel5.add(getJLabelImportoAcreditoParametrico(secondX+30,coordinataY,136,45));
				
				
				
				int len = arrayLabelPeriodi.length;
				for (int i = 0; i < len; i++) {
					
					JLabel labelCorrente = arrayLabelPeriodi[i];
					JTextField textFieldCorrenteLitri = arrayLitriConsumati[i];
					JTextField textFieldCorrenteImporti = arrayImportoACredito[i];					
					
					
					setJLabelDatePosition(labelCorrente,5,(coordinataY+35),170,19);
					jPanel5.add(labelCorrente);
					
					setJTextFieldLitriConsumati(textFieldCorrenteLitri,firstX,(coordinataY+35),54,19);
					jPanel5.add(textFieldCorrenteLitri);
					
					setJTextFieldACredito(textFieldCorrenteImporti,secondX,(coordinataY+35),136,19);
					jPanel5.add(textFieldCorrenteImporti);
					
					JLabel prova = new JLabel();
					int perc = arrayPercentualeDecurtazione[i];
					if (perc>0){
						prova.setText("A partire dalla dichiarazione anno d'imposta 2015 il credito calcolato  ridotto del "+perc+"%");
						setJLabelDatePosition(prova,secondX+150,(coordinataY+35),300,19);
						jPanel5.add(prova);
					}
					coordinataY+=30;
					altezzaPanel+=170;					
				}
				
				

				//RIGA TOTALI*********************************************
				
				
				coordinataY+=35;
				
				//label totale litri consumati
				initJLabel(jLabel28,"Totale",10,coordinataY,132,15);			
				jPanel5.add(getJLabel28(), null);
				
				//textfield totale litri consumati
				Object[]textProprietaLitriConsumati= new Object[]{
									new Integer(firstX),new Integer(coordinataY),new Integer(54),new Integer(19),new Integer(JTextField.RIGHT),
									new Boolean(true),new Boolean(false),
									Color.WHITE, BorderFactory.createLineBorder(Color.GRAY), new BigIntegerDocument(Frontespizio.getDimTotaleLitriCconsumati())};
				initJTextField(jTextFieldTOTLitriConsumati, textProprietaLitriConsumati);
				jPanel5.add(getJTextFieldTOTLitriConsumati(), null);
				
				//textfield totale litri consumati
				Object[]textProprietaImportoACredito= new Object[]{
										  new Integer(secondX),new Integer(coordinataY),new Integer(136),new Integer(19),new Integer(JTextField.RIGHT),
										  new Boolean(true),new Boolean(false),
										  Color.WHITE, BorderFactory.createLineBorder(Color.GRAY), new BigDecimalDocument(Frontespizio.getDimTotaleImportCreditoInt(),Frontespizio.getDimTotaleImportCreditoDec())};
				initJTextField(jTextFieldTOTACredito, textProprietaImportoACredito);
				jTextFieldTOTACredito.addFocusListener(this);
				jPanel5.add(getJTextFieldTOTACredito(), null);
		
				//radio button euro
				initJRadioButton(jRadioButtonEuro,buttonGroupValuta,"Euro",true,444,coordinataY,51,23);
				jPanel5.add(getJRadioButtonEuro(), null);
				
							
				//END RIGA TOTALI********************************************************
				
				coordinataY +=35;
				//label modalit prescelta
				initJLabel(jLabel30,"Modalit Prescelta di funzione del credito:",10,coordinataY,275,17);				
				jPanel5.add(getJLabel30(), null);
				
				coordinataY +=20;
				//label compensazione
				initJLabel(jLabel18,"Compensazione ai sensi dell'art. 17 decreto legislativo n. 241/97 Mod(F24)",10,coordinataY,380,17);				
				jPanel5.add(getJLabel18(), null);
				
				//radio button 
				initJRadioButton(jRadioButtonModalitaPrescelta,buttonGroupDatiContabili,"",false,679,coordinataY,21,21);
				jRadioButtonModalitaPrescelta.addActionListener(this);
				jPanel5.add(getJRadioButtonModalitaPrescelta(), null);
				
		
		
		
			
				/********************************************************************/
				/*******************RIGA COORDINATE BANCARIE NAZIONALI***************/
				
//				coordinataY +=30;
//				initJLabel(jLabel19,"Mediante rimborso",10,coordinataY,109,14);				
//				jPanel5.add(getJLabel19(), null);
//				
//				
//				//label coordinate bancarie nazionali
//				initJLabelFont(jLabel32,"( Coordinate Bancarie Nazionali",new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10),javax.swing.SwingConstants.RIGHT,101,coordinataY,155,16);				
//				jPanel5.add(getJLabel32(), null);
//				
//				
//				//label cod abi
//				initJLabelFont(jLabel33,"Cod. ABI",new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10),-1,264,coordinataY,42,16);				
//				jPanel5.add(getJLabel33(), null);
//				
//				
//				//textfield cod. abi
//				Object[]textProprietaCodAbi= new Object[]{
//									new Integer(318),new Integer(coordinataY),new Integer(85),new Integer(19),new Integer(-1),
//									new Boolean(false),new Boolean(false),
//									null, null, new BigIntegerDocument(Frontespizio.getDimBancaABI())};
//				initJTextField(jTextFieldCodABI, textProprietaCodAbi);
//				jPanel5.add(getJTextFieldCodABI(), null);
//				
//				
//				//label cod cab
//				initJLabelFont(jLabel34,"Cod. CAB",new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10),-1,420,coordinataY,46,13);				
//				jPanel5.add(getJLabel34(), null);
//				
//				//textfield cod. cab
//				Object[]textProprietaCodCab= new Object[]{
//									new Integer(474),new Integer(coordinataY),new Integer(73),new Integer(19),new Integer(-1),
//									new Boolean(false),new Boolean(false),
//									null, null, new BigIntegerDocument(Frontespizio.getDimBancaCAB())};
//				initJTextField(jTextFieldCodCAB, textProprietaCodCab);
//				jPanel5.add(getJTextFieldCodCAB(), null);
//				
//				//label cod c/c n
//				initJLabelFont(jLabel35,"C/C N.",new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10),-1,558,coordinataY,32,13);				
//				jPanel5.add(getJLabel35(), null);
//				
//				//textfield cod. c/c n
//				Object[]textProprietaCcn= new Object[]{
//									new Integer(593),new Integer(coordinataY),new Integer(81),new Integer(19),new Integer(-1),
//									new Boolean(false),new Boolean(false),
//									null, null, new BigIntegerDocument(Frontespizio.getDimBancaContoCorrente())};
//				initJTextField(jTextFieldCCN, textProprietaCcn);
//				jPanel5.add(getJTextFieldCCN(), null);
//				
//				//label ")"
//				initJLabelFont(jLabel43,"     )",new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10),javax.swing.SwingConstants.CENTER,662,coordinataY,17,22);				
//				jPanel5.add(getJLabel43(), null);				
//		
//				
//				//radio button coordinate bancarie nazionali
//				initJRadioButton(jRadioButtonCoordinateBancarieNaz,buttonGroupDatiContabili,"",false,679,coordinataY,21,21);
//				jRadioButtonCoordinateBancarieNaz.addActionListener(this);
//				jPanel5.add(getJRadioButtonCoordinateBancarieNaz(), null);
								
				/*********************END RIGA COORDINATE BANCARIE NAZIONALI*********/
				
				
				/*****************************************************************/
				/********************* RIGA COORDINATE POSTALI NAZIONALI*********/
//				coordinataY +=30;
//				
//				//label 'Coordinate Postali Nazionali'
//				initJLabelFont(jLabel37,"( Coordinate Postali Nazionali",new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10),javax.swing.SwingConstants.RIGHT,107,coordinataY,142,13);				
//				jPanel5.add(getJLabelCoordinatePostaliNazionali(), null);
//				
//				//label cod c/c postale
//				initJLabelFont(jLabel38,"C/C Postale N",new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10),-1,264,coordinataY,134,13);				
//				jPanel5.add(getJLabel38(), null);
//				
//				//textfield cod. ccp
//				Object[]textProprietaCcp= new Object[]{
//									new Integer(318),new Integer(coordinataY),new Integer(259),new Integer(19),new Integer(-1),
//									new Boolean(false),new Boolean(false),
//									null, null, new StringDocument(Frontespizio.getDimPostaContoCorrente())};
//				initJTextField(jTextFieldCCP, textProprietaCcp);
//				jPanel5.add(getJTextFieldCCP(), null);
//				
//				//label ")"
//				initJLabelFont(jLabel39,"     )",new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10),javax.swing.SwingConstants.CENTER,658,coordinataY,20,22);				
//				jPanel5.add(getJLabel39(), null);
//				
//				//radio button coordinate postali nazionali
//				initJRadioButton(jRadioButtonCoordinatePostaliNaz,buttonGroupDatiContabili,"",false,679,coordinataY,21,21);
//				jRadioButtonCoordinatePostaliNaz.addActionListener(this);
//				jPanel5.add(getJRadioButtonCoordinatePostaliNaz(), null);	
				
				
				
				/*********************END RIGA COORDINATE POSTALI NAZIONALI*********/
				
			
				
				
				
			
		
				/*****************************************************************/
				/********************* RIGA COORDINATE BANCARIE EUROPEE*********/	
				
				coordinataY +=30;
				initJLabel(jLabel19,"Mediante rimborso",10,coordinataY,109,14);				
				jPanel5.add(getJLabel19(), null);
				
				//label 'Coordinate Postali europee'
				initJLabelFont(jLabel40," Coordinate Bancarie Europee",new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10),javax.swing.SwingConstants.RIGHT,111,coordinataY,142,13);				
				jPanel5.add(getJLabelCoordinateBancarieEuropee(), null);
				
				//label 'IBAN'
				initJLabelFont(jLabel41,"IBAN",new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10),-1,264,coordinataY,24,13);				
				jPanel5.add(getJLabel41(), null);
				
				//textfield iban
				Object[]textProprietaIban= new Object[]{
									new Integer(290),new Integer(coordinataY),new Integer(150),new Integer(19),new Integer(-1),
									new Boolean(false),new Boolean(false),
									null, null, new StringDocument(Frontespizio.getDimIban()-2)};
				initJTextField(jTextFieldIban, textProprietaIban);
				jPanel5.add(getJTextFieldIban(), null);
				
				//label 'bic'
				initJLabelFont(jLabel42,"BIC",new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10),javax.swing.SwingConstants.RIGHT,455,coordinataY,26,13);				
				jPanel5.add(getJLabel42(), null);
				
				//textfield bic
				Object[]textProprietaBic= new Object[]{
									new Integer(488),new Integer(coordinataY),new Integer(89),new Integer(19),new Integer(-1),
									new Boolean(false),new Boolean(false),
									null, null, new StringDocument(Frontespizio.getDimBIC()-2)};
				initJTextField(jTextFieldBIC, textProprietaBic);
				jPanel5.add(getJTextFieldBIC(), null);
				
				//label ")"
				initJLabelFont(jLabel36,"     ",new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10),javax.swing.SwingConstants.CENTER,658,coordinataY,20,22);				
				jPanel5.add(getJLabel36(), null);
				
				//radio button coordinate Bancarie Europee
				initJRadioButton(jRadioButtonCoordinateBancarieEuropee,buttonGroupDatiContabili,"",false,679,coordinataY,21,21);
				jRadioButtonCoordinateBancarieEuropee.addActionListener(this);
				jPanel5.add(getJRadioButton62(), null);	
			
				
				/*********************END RIGA COORDINATE BANCARIE EUROPEE*********/
				
				
				//jPanel5.add(getJPanelOpzionePeriodo(), null);//DA VERIFICARE
		       
				jPanel5.setBorder(
					javax.swing.BorderFactory.createLineBorder(
						java.awt.Color.black,
						1));
						
				jPanel5.setPreferredSize(new Dimension(10,altezzaPanel));			
		
			
				return jPanel5;
		}
	
	
	
	
	
	
	
	/**
	 * This method initializes jLabel30
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel30() {
		/*if (jLabel30 == null) {
			jLabel30 = new javax.swing.JLabel();
			//jLabel30.setBounds(2, 108, 275, 17);
			jLabel30.setText("Modalit Prescelta di funzione del credito:");
			jLabel30.setBounds(
				RealDim.getAbsoluteXValue(10),
				RealDim.getAbsoluteYValue(148),
				RealDim.getAbsoluteXValue(275),
				RealDim.getAbsoluteYValue(17));
		}*/
		return jLabel30;
	}
	/**
	 * This method initializes jPanel6
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel6() {
		if (jPanel6 == null) {
			jPanel6 = new javax.swing.JPanel();
			jPanel6.setLayout(null);
			jPanel6.add(getJLabel3(), null);
			jPanel6.add(getJComboBoxProvinciaSedeAmm(), null);
			jPanel6.add(getJLabel13(), null);
			jPanel6.add(getJComboBoxComuneSedeAmm(), null);
			jPanel6.add(getJTextFieldIndirizzoSedeAmm(), null);
			jPanel6.add(getJLabel17(), null);
			//jPanel6.setBounds(8, 113, 731, 45);
			jPanel6.setBackground(java.awt.Color.lightGray);
			jPanel6.setBounds(
				RealDim.getAbsoluteXValue(8),
				RealDim.getAbsoluteYValue(113),
				RealDim.getAbsoluteXValue(731),
				RealDim.getAbsoluteYValue(45));

			jPanel6.setBorder(
				javax.swing.BorderFactory.createTitledBorder(
					null,
					"Sede Amministrativa",
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION,
					null,
					null));

		}
		return jPanel6;
	}
	/**
	 * This method initializes jLabel3
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel3() {
		if (jLabel3 == null) {
			jLabel3 = new javax.swing.JLabel();
			//jLabel3.setBounds(7, 21, 57, 17);
			jLabel3.setText("Provincia");
			jLabel3.setBounds(
				RealDim.getAbsoluteXValue(7),
				RealDim.getAbsoluteYValue(21),
				RealDim.getAbsoluteXValue(57),
				RealDim.getAbsoluteYValue(17));
		}
		return jLabel3;
	}
	/**
	 * This method initializes jComboBoxProvinciaSedeAmm
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxProvinciaSedeAmm() {
		if (jComboBoxProvinciaSedeAmm == null) {
			jComboBoxProvinciaSedeAmm = new javax.swing.JComboBox();
			//	jComboBoxProvinciaSedeAmm.setBounds(70, 21, 155, 17);
			jComboBoxProvinciaSedeAmm.setBounds(
				RealDim.getAbsoluteXValue(70),
				RealDim.getAbsoluteYValue(21),
				RealDim.getAbsoluteXValue(155),
				RealDim.getAbsoluteYValue(17));
			
		}
		return jComboBoxProvinciaSedeAmm;
	}
	/**
	 * This method initializes jLabel13
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel13() {
		if (jLabel13 == null) {
			jLabel13 = new javax.swing.JLabel();
			//jLabel13.setBounds(238, 21, 61, 15);
			jLabel13.setBounds(
				RealDim.getAbsoluteXValue(238),
				RealDim.getAbsoluteYValue(21),
				RealDim.getAbsoluteXValue(61),
				RealDim.getAbsoluteYValue(15));
			jLabel13.setText("Comune");
		}
		return jLabel13;
	}
	/**
	 * This method initializes jComboBoxComuneSedeAmm
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxComuneSedeAmm() {
		if (jComboBoxComuneSedeAmm == null) {
			jComboBoxComuneSedeAmm = new javax.swing.JComboBox();
			//jComboBoxComuneSedeAmm.setBounds(299, 21, 87, 17);
			jComboBoxComuneSedeAmm.addActionListener(this);
			jComboBoxComuneSedeAmm.setBounds(
				RealDim.getAbsoluteXValue(296),
				RealDim.getAbsoluteYValue(21),
				RealDim.getAbsoluteXValue(87),
				RealDim.getAbsoluteYValue(17));
				jComboBoxComuneSedeAmm.setRenderer(new ComuneComboBoxRenderer());
		}
		return jComboBoxComuneSedeAmm;
	}
	
	public static class ComuneComboBoxRenderer extends BasicComboBoxRenderer {
		public Component getListCellRendererComponent(JList list, Object value,
			int index, boolean isSelected, boolean cellHasFocus) {
		  if (isSelected) {
			setBackground(list.getSelectionBackground());
			setForeground(list.getSelectionForeground());
			if (-1 < index) {
			  list.setToolTipText(value.toString());
			}
		  } else {
			setBackground(list.getBackground());
			setForeground(list.getForeground());
		  }
		  setFont(list.getFont());
		  setText((value == null) ? "" : value.toString());
		  return this;
		}
	  }
	
	/**
	 * This method initializes jTextFieldIndirizzoSedeAmm
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldIndirizzoSedeAmm() {
		if (jTextFieldIndirizzoSedeAmm == null) {
			jTextFieldIndirizzoSedeAmm = new javax.swing.JTextField();
			//jTextFieldIndirizzoSedeAmm.setBounds(444, 21, 284, 17);
			jTextFieldIndirizzoSedeAmm.setBounds(
				RealDim.getAbsoluteXValue(444),
				RealDim.getAbsoluteYValue(21),
				RealDim.getAbsoluteXValue(284),
				RealDim.getAbsoluteYValue(17));
			jTextFieldIndirizzoSedeAmm.setDocument(
				new StringDocument(
					Frontespizio.getDimIndirizzoSedeAmministrativa()));
		}
		return jTextFieldIndirizzoSedeAmm;
	}
	/**
	 * This method initializes jLabel17
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel17() {
		if (jLabel17 == null) {
			jLabel17 = new javax.swing.JLabel();
			//jLabel17.setBounds(390, 21, 56, 17);
			jLabel17.setText("Indirizzo");
			jLabel17.setBounds(
				RealDim.getAbsoluteXValue(390),
				RealDim.getAbsoluteYValue(21),
				RealDim.getAbsoluteXValue(56),
				RealDim.getAbsoluteYValue(17));
		}
		return jLabel17;
	}
	/**
	 * This method initializes jLabel18
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel18() {
		/*if (jLabel18 == null) {
			jLabel18 = new javax.swing.JLabel();
			//jLabel18.setBounds(0, 168, 457, 14);
			jLabel18.setText(
				"Compensazione ai sensi dell'art. 17 decreto legislativo n. 241/97 Mod(F24)");
			jLabel18.setBounds(
				RealDim.getAbsoluteXValue(10),
				RealDim.getAbsoluteYValue(168),
				RealDim.getAbsoluteXValue(457),
				RealDim.getAbsoluteYValue(14));
		}*/
		return jLabel18;
	}
	/**
	 * This method initializes jLabel19
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel19() {
		/*if (jLabel19 == null) {
			jLabel19 = new javax.swing.JLabel();
			//jLabel19.setBounds(0, 194, 109, 14);
			jLabel19.setText("Mediante rimborso");
			jLabel19.setBounds(
				RealDim.getAbsoluteXValue(10),
				RealDim.getAbsoluteYValue(194),
				RealDim.getAbsoluteXValue(109),
				RealDim.getAbsoluteYValue(14));

		}*/
		return jLabel19;
	}
	/**
	 * This method initializes jRadioButtonCoordinateBancarieNaz
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButtonCoordinateBancarieNaz() {
		/*if (jRadioButtonCoordinateBancarieNaz == null) {
			jRadioButtonCoordinateBancarieNaz = new javax.swing.JRadioButton();
			//	jRadioButtonCoordinateBancarieNaz.setBounds(679, 192, 21, 21);
			jRadioButtonCoordinateBancarieNaz.addActionListener(this);
			jRadioButtonCoordinateBancarieNaz.setBounds(
				RealDim.getAbsoluteXValue(679),
				RealDim.getAbsoluteYValue(192),
				RealDim.getAbsoluteXValue(21),
				RealDim.getAbsoluteYValue(21));
			buttonGroupDatiContabili.add(jRadioButtonCoordinateBancarieNaz);
		}*/
		return jRadioButtonCoordinateBancarieNaz;
	}
	/**
	 * This method initializes jRadioButtonModalitaPrescelta
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButtonModalitaPrescelta() {
		/*if (jRadioButtonModalitaPrescelta == null) {
			jRadioButtonModalitaPrescelta = new javax.swing.JRadioButton();
			jRadioButtonModalitaPrescelta.addActionListener(this);
			//jRadioButtonModalitaPrescelta.setBounds(679, 169, 21, 21);
			buttonGroupDatiContabili.add(jRadioButtonModalitaPrescelta);
			jRadioButtonModalitaPrescelta.setBounds(
				RealDim.getAbsoluteXValue(679),
				RealDim.getAbsoluteYValue(169),
				RealDim.getAbsoluteXValue(21),
				RealDim.getAbsoluteYValue(21));
		}*/
		return jRadioButtonModalitaPrescelta;
	}

	/**
	 * This method initializes jPanelComunitario
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanelComunitario() {
		if (jPanelComunitario == null) {
			jPanelComunitario = new javax.swing.JPanel();
			jPanelComunitario.setLayout(null);
			jPanelComunitario.add(getJLabel20(), null);
			jPanelComunitario.add(getJTextFieldCittaPanelloComunitario(), null);
			jPanelComunitario.add(getJLabel211(), null);
			jPanelComunitario.add(
				getJTextFieldIndirizzoPannelloComunitario(),
				null);
			jPanelComunitario.setBorder(
				javax.swing.BorderFactory.createTitledBorder(
					null,
					"Sede",
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION,
					null,
					null));
			jPanelComunitario.setBounds(
				RealDim.getAbsoluteXValue(5),
				RealDim.getAbsoluteYValue(75),
				RealDim.getAbsoluteXValue(731),
				RealDim.getAbsoluteYValue(45));
		}
		return jPanelComunitario;
	}
	/**
	 * This method initializes jLabel20
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel20() {
		if (jLabel20 == null) {
			jLabel20 = new javax.swing.JLabel();
			//	jLabel20.setBounds(5, 21, 26, 26);
			jLabel20.setText("Citt");
			jLabel20.setBounds(
				RealDim.getAbsoluteXValue(5),
				RealDim.getAbsoluteYValue(12),
				RealDim.getAbsoluteXValue(26),
				RealDim.getAbsoluteYValue(26));
		}
		return jLabel20;
	}

	/**
	 * This method initializes jTextFieldCittaPanelloComunitario
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldCittaPanelloComunitario() {
		if (jTextFieldCittaPanelloComunitario == null) {
			jTextFieldCittaPanelloComunitario = new javax.swing.JTextField();
			//jTextFieldCittaPanelloComunitario.setBounds(36, 5, 10, 20);
			jTextFieldCittaPanelloComunitario.setBounds(
				RealDim.getAbsoluteXValue(36),
				RealDim.getAbsoluteYValue(17),
				RealDim.getAbsoluteXValue(200),
				RealDim.getAbsoluteYValue(17));
		}
		return jTextFieldCittaPanelloComunitario;
	}
	/**
	 * This method initializes jLabel211
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel211() {
		if (jLabel211 == null) {
			jLabel211 = new javax.swing.JLabel();
			//jLabel211.setBounds(5, 5, 10, 10);
			jLabel211.setText("Indirizzo");
			jLabel211.setBounds(
				RealDim.getAbsoluteXValue(400),
				RealDim.getAbsoluteYValue(20),
				RealDim.getAbsoluteXValue(50),
				RealDim.getAbsoluteYValue(10));
		}
		return jLabel211;
	}
	/**
	 * This method initializes jTextFieldIndirizzoPannelloComunitario
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax
		.swing
		.JTextField getJTextFieldIndirizzoPannelloComunitario() {
		if (jTextFieldIndirizzoPannelloComunitario == null) {
			jTextFieldIndirizzoPannelloComunitario =
				new javax.swing.JTextField();
			//jTextFieldIndirizzoPannelloComunitario.setBounds(5, 5, 10, 20);
			jTextFieldIndirizzoPannelloComunitario.setBounds(
				RealDim.getAbsoluteXValue(450),
				RealDim.getAbsoluteYValue(17),
				RealDim.getAbsoluteXValue(200),
				RealDim.getAbsoluteYValue(17));
		}
		return jTextFieldIndirizzoPannelloComunitario;
	}
	/**
	 * This method initializes jPanelOpzionePeriodo
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanelOpzionePeriodo() {
		if (jPanelOpzionePeriodo == null) {
			jPanelOpzionePeriodo = new javax.swing.JPanel();
			jPanelOpzionePeriodo.setLayout(null);
			jPanelOpzionePeriodo.add(getJLabel213(), null);
			jPanelOpzionePeriodo.add(getJLabel214(), null);
			jPanelOpzionePeriodo.add(getJLabel212(), null);
			jPanelOpzionePeriodo.add(
				getJTextFieldLitriConsumatiMassaSup_INF(),
				null);
			jPanelOpzionePeriodo.add(getJLabel215(), null);
			jPanelOpzionePeriodo.add(
				getJTextFieldLitriConsumatiMassaInf(),
				null);
			jPanelOpzionePeriodo.add(
				getJTextFieldImportoCreditoMassaSUP_INF(),
				null);
			jPanelOpzionePeriodo.add(getJLabel216(), null);
			jPanelOpzionePeriodo.add(getJLabel217(), null);
			jPanelOpzionePeriodo.add(getJLabel218(), null);
			jPanelOpzionePeriodo.add(
				getJTextFieldImportoCreditoiMassaInf11(),
				null);
			jPanelOpzionePeriodo.add(getJCheckBoxCarbonTaxPresentata(), null);
			jPanelOpzionePeriodo.add(
				getJTextFieldLitriConsumatiMassaInf(),
				null);
			//jPanelOpzionePeriodo.setBounds(1, 5, 735, 101);
			jPanelOpzionePeriodo.setBounds(
				RealDim.getAbsoluteXValue(1),
				RealDim.getAbsoluteYValue(5),
				RealDim.getAbsoluteXValue(735),
				RealDim.getAbsoluteYValue(101));
			jPanelOpzionePeriodo.setVisible(false);
		}
		return jPanelOpzionePeriodo;
	}
	/**
	 * This method initializes jLabel213
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel213() {
		if (jLabel213 == null) {
			jLabel213 = new javax.swing.JLabel();
			//jLabel213.setBounds(1, 2, 364, 16);
			jLabel213.setText(
				"Dichiarazioni di Carbontax per il 2004 presentata/da presentare");
			jLabel213.setBounds(
				RealDim.getAbsoluteXValue(1),
				RealDim.getAbsoluteYValue(2),
				RealDim.getAbsoluteXValue(364),
				RealDim.getAbsoluteYValue(16));
		}
		return jLabel213;
	}
	/**
	 * This method initializes jLabel214
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel214() {
		if (jLabel214 == null) {
			jLabel214 = new javax.swing.JLabel();
			//jLabel214.setBounds(1, 18, 445, 14);
			jLabel214.setText(
				"a)Autoveicoli con massa massima superiore a 3,5 T e inferiore a 11,5 T");
			jLabel214.setBounds(
				RealDim.getAbsoluteXValue(1),
				RealDim.getAbsoluteYValue(18),
				RealDim.getAbsoluteXValue(445),
				RealDim.getAbsoluteYValue(14));
		}
		return jLabel214;
	}
	/**
	 * This method initializes jLabel212
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel212() {
		if (jLabel212 == null) {
			jLabel212 = new javax.swing.JLabel();
			//jLabel212.setBounds(22, 40, 91, 14);
			jLabel212.setText("Litri consumati:");
			jLabel212.setBounds(
				RealDim.getAbsoluteXValue(22),
				RealDim.getAbsoluteYValue(40),
				RealDim.getAbsoluteXValue(91),
				RealDim.getAbsoluteYValue(14));
		}
		return jLabel212;
	}
	/**
	 * This method initializes jTextFieldLitriConsumatiMassaSup_INF
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldLitriConsumatiMassaSup_INF() {
		if (jTextFieldLitriConsumatiMassaSup_INF == null) {
			jTextFieldLitriConsumatiMassaSup_INF = new javax.swing.JTextField();
			//jTextFieldLitriConsumatiMassaSup_INF.setBounds(115, 37, 133, 19);
			jTextFieldLitriConsumatiMassaSup_INF.setBounds(
				RealDim.getAbsoluteXValue(115),
				RealDim.getAbsoluteYValue(37),
				RealDim.getAbsoluteXValue(133),
				RealDim.getAbsoluteYValue(19));
			//	jTextFieldLitriConsumatiMassaSup_INF.setDocument(new BigIntegerDocument(Frontespizio.getDimTotaleLitriConsumatiAutoveicoliMassaMassimaSupa3()));
		}
		return jTextFieldLitriConsumatiMassaSup_INF;
	}
	/**
	 * This method initializes jLabel215
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel215() {
		if (jLabel215 == null) {
			jLabel215 = new javax.swing.JLabel();
			//jLabel215.setBounds(305, 40, 141, 14);
			jLabel215.setText("Importo a credito(Euro):");
			jLabel215.setBounds(
				RealDim.getAbsoluteXValue(305),
				RealDim.getAbsoluteYValue(40),
				RealDim.getAbsoluteXValue(141),
				RealDim.getAbsoluteYValue(14));
		}
		return jLabel215;
	}

	/**
	 * This method initializes jTextFieldImportoCreditoMassaSUP_INF
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldImportoCreditoMassaSUP_INF() {
		if (jTextFieldImportoCreditoMassaSUP_INF == null) {
			jTextFieldImportoCreditoMassaSUP_INF = new javax.swing.JTextField();
			//	jTextFieldImportoCreditoMassaSUP_INF.setBounds(449, 37, 133, 19);
			jTextFieldImportoCreditoMassaSUP_INF.setBounds(
				RealDim.getAbsoluteXValue(449),
				RealDim.getAbsoluteYValue(37),
				RealDim.getAbsoluteXValue(133),
				RealDim.getAbsoluteYValue(19));
		}

		return jTextFieldImportoCreditoMassaSUP_INF;
	}
	/**
	 * This method initializes jLabel216
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel216() {
		if (jLabel216 == null) {
			jLabel216 = new javax.swing.JLabel();
			//jLabel216.setBounds(1, 59, 351, 14);
			jLabel216.setText(
				"b)Autoveicoli con massa massima non inferiore a 11,5T");
			jLabel216.setBounds(
				RealDim.getAbsoluteXValue(1),
				RealDim.getAbsoluteYValue(59),
				RealDim.getAbsoluteXValue(351),
				RealDim.getAbsoluteYValue(14));
		}
		return jLabel216;
	}
	/**
	 * This method initializes jLabel217
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel217() {
		if (jLabel217 == null) {
			jLabel217 = new javax.swing.JLabel();
			//jLabel217.setBounds(22, 81, 92, 14);
			jLabel217.setText("Litri consumati:");
			jLabel217.setBounds(
				RealDim.getAbsoluteXValue(22),
				RealDim.getAbsoluteYValue(81),
				RealDim.getAbsoluteXValue(92),
				RealDim.getAbsoluteYValue(14));
		}
		return jLabel217;
	}
	/**
	 * This method initializes jTextFieldLitriConsumatiMassaInf
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldLitriConsumatiMassaInf() {
		if (jTextFieldLitriConsumatiMassaInf == null) {
			jTextFieldLitriConsumatiMassaInf = new javax.swing.JTextField();
			//jTextFieldLitriConsumatiMassaInf.setBounds(115, 79, 133, 19);
			jTextFieldLitriConsumatiMassaInf.setBounds(
				RealDim.getAbsoluteXValue(115),
				RealDim.getAbsoluteYValue(79),
				RealDim.getAbsoluteXValue(133),
				RealDim.getAbsoluteYValue(19));
		}
		return jTextFieldLitriConsumatiMassaInf;
	}
	/**
	 * This method initializes jLabel218
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel218() {
		if (jLabel218 == null) {
			jLabel218 = new javax.swing.JLabel();
			//jLabel218.setBounds(305, 81, 141, 14);
			jLabel218.setText("Importo a credito(Euro)");
			jLabel218.setBounds(
				RealDim.getAbsoluteXValue(305),
				RealDim.getAbsoluteYValue(81),
				RealDim.getAbsoluteXValue(141),
				RealDim.getAbsoluteYValue(14));
		}
		return jLabel218;
	}
	/**
	 * This method initializes jTextFieldImportoCreditoiMassaInf11
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldImportoCreditoiMassaInf11() {
		if (jTextFieldImportoCreditoiMassaInf11 == null) {
			jTextFieldImportoCreditoiMassaInf11 = new javax.swing.JTextField();
			//jTextFieldImportoCreditoiMassaInf11.setBounds(449, 79, 133, 19);
			jTextFieldImportoCreditoiMassaInf11.setBounds(
				RealDim.getAbsoluteXValue(449),
				RealDim.getAbsoluteYValue(79),
				RealDim.getAbsoluteXValue(133),
				RealDim.getAbsoluteYValue(19));
		}
		return jTextFieldImportoCreditoiMassaInf11;
	}
	/**
	 * This method initializes jCheckBoxCarbonTaxPresentata
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private javax.swing.JCheckBox getJCheckBoxCarbonTaxPresentata() {
		if (jCheckBoxCarbonTaxPresentata == null) {
			jCheckBoxCarbonTaxPresentata = new javax.swing.JCheckBox();
			//jCheckBoxCarbonTaxPresentata.setBounds(5, 5, 21, 21);
			jCheckBoxCarbonTaxPresentata.setBounds(
				RealDim.getAbsoluteXValue(240),
				RealDim.getAbsoluteYValue(0),
				RealDim.getAbsoluteXValue(21),
				RealDim.getAbsoluteYValue(19));
		}
		return jCheckBoxCarbonTaxPresentata;
	}
	
	/**
	 * @return
	 */
	public JTextField[] getArrayLitriConsumati() {
		return arrayLitriConsumati;
	}

	/**
	 * @param fields
	 */
	public void setArrayLitriConsumati(JTextField[] fields) {
		arrayLitriConsumati = fields;
	}

	/**
	 * @return
	 */
	public JTextField[] getArrayImportoACredito() {
		return arrayImportoACredito;
	}

	/**
	 * @param fields
	 */
	public void setArrayImportoACredito(JTextField[] fields) {
		arrayImportoACredito = fields;
	}

	

	/**
	 * @return
	 */
	public JLabel[] getLabelPeriodi() {
		return arrayLabelPeriodi;
	}

	/**
	 * @param labels
	 */
	public void setLabelPeriodi(JLabel[] labels) {
		arrayLabelPeriodi = labels;
	}

	/**
	 * @return
	 */
	public double[] getArrayAliquote() {
		return arrayAliquote;
	}

	/**
	 * @param ds
	 */
	public void setArrayAliquote(double[] ds) {
		arrayAliquote = ds;
	}

	/**
	 * @return
	 */
	public static int getNumeroAliquote() {
		return NumeroAliquote;
	}

	/**
	 * @return
	 */
	public static String  getPeriodo() {
		return periodo;
	}

	/**
	 * @return
	 */
	public static String getAnnoRiferimento() {
		return annoRiferimento;
	}

	/**
	 * @return
	 */
	public static String[] getArrayStringPeriodi() {
		return arrayStringPeriodi;
	}

	/**
	 * @param strings
	 */
	public static void setArrayStringPeriodi(String[] strings) {
		arrayStringPeriodi = strings;
	}

	/**
	 * @return
	 */
	public static int getNumeroPeriodo() {
		return numeroPeriodo;
	}

	
	/**
	 * @return
	 */
	public static Object[] getSetStringDecretiLegge() {
		return setStringDecretiLegge.toArray();
	}

	

}